unit UAspFileDataSet;

interface

uses   SysUtils,Classes,Controls,Stdctrls,ExtCtrls,Buttons
      ,Messages
      ,Graphics,Dialogs,Forms,Menus,Mask
      ,TntClasses,TntStdCtrls,TntExtCtrls,TntButtons,TntGraphics
      ,DsgnIntf
      ,UD5UniCodeProcs
      ,FileRWLib_TLB;

Const ole32DLL = 'ole32.dll';

type
  TPoint = record
   X,Y:Longint;
  end;
  //----------------------------------------------------
  TDBProcParamItem   = FileRWLib_TLB.TDbProcParamItem;
  TDBProcParams      = FileRWLib_TLB.TDbProcParams;
  TDBProcItem        = FileRWLib_TLB.TDbProcItem;
  TDbMethods         = FileRWLib_TLB.TDbMethods;
  TProcParamIOType   = FileRWLib_TLB.TProcParamIOType;
  TCallTriggerTiming = FileRWLib_TLB.TCallTriggerTiming;
  //----------------------------------------------------
  TAspFileDataSet        = class;
  TAspFileDataSource     = class;
  TAspFileDBEdit         = class;
  TAspFileDBMemo         = class;
  TAspFileDBComboBox     = class;
  TAspFileDBText         = class;
  TAspFileDBWEdit        = class;
  TAspFileDBWText        = class;
  TAspFileDBNavigator    = class;
  TAspFileDBGrid         = class;
  TColumnItem            = class;
  TGridCell              = class;
  TGridCellW             = class;

  TColumnItemClass       = class of TColumnItem;

  TPickListRefFieldItemClass = class of TPickListRefFieldItem;

  TColumnEditStyle = ( CES_None,CES_PickList,CES_Ellipsis,CES_CheckBox,CES_Memo
                      ,CES_ClickBtn);
  TColumnLinkControlStyle = (CLS_Top,CLS_Down);

  TTitleAlignType  = (TA_Left,TA_Center,TA_Right);
  TColumnAlignType = (CA_Left,CA_Center,CA_Right);

  TNavBtnPressedEvent  = procedure(Sender:TComponent;BtnName:string) of Object;

  TCellPickListInitEvent     = procedure(Column:TColumnItem) of Object;
  TGridNewRecordEvent        = procedure(Sender:TComponent)  of Object;
  TGridNewDataPageEvent      = procedure(Sender:TComponent)  of Object;

  TGridCheckRecFlashEvent = procedure(Row:integer;var IsRefreshRec:boolean
                                                      ;var CompareData:string) of Object;
  TGridDoRecordFlashEvent = procedure(ChkIsTrue:boolean;
                                      CellData:string;
                                      var CellCanvas:TCanvas) of Object;

  TColumnDisplayFormatEvent    = procedure(Sender:TColumnItem;var DisplayStr:string) of Object;
  TColumnDisplayFormatWEvent   = procedure(Sender:TColumnItem;var DisplayWStr:WideString) of Object;
  TColumnLinkControlClickEvent = procedure(Sender:TObject;ControlCaption:string)  of Object;


  //For AnsiString Ctrl -->TGridCell
  TCellBtnPressedEvent       = procedure(dbState:string;Column:TColumnItem;DataCell:TGridCell) of Object;
  TCellComboBoxSelectedEvent = TCellBtnPressedEvent;
  TCellGetValueEvent         = TCellBtnPressedEvent;

  //For UniCode Ctrl -->TGridCellW
  TCellWBtnPressedEvent       = procedure(dbState:string;Column:TColumnItem;DataCell:TGridCellW) of Object;
  TCellWComboBoxSelectedEvent = TCellWBtnPressedEvent;
  TCellWGetValueEvent         = TCellWBtnPressedEvent;

  TGridPopUpMenuClickEvent   = procedure(Sender:TObject;MenuCaption:string)  of Object;

  TEditBeforeSetDataEvent = procedure(Sender:TComponent
                                      ;OldValue:string
                                      ;Var NewValue:string) of Object;

  TEditAfterSetDataEvent   = procedure(Sender:TComponent;FieldValue:string) of Object;

  TEditBeforeGetDataEvent  = procedure(Sender:TComponent;FieldValue:string) of Object;

  TEditAfterGetDataEvent   = procedure(Sender:TComponent;FieldValue:string) of Object;

  TEditWBeforeSetDataEvent = procedure(Sender:TComponent
                                       ;OldValue:WideString
                                       ;Var NewValue:WideString) of Object;

  TEditWAfterSetDataEvent  = procedure(Sender:TComponent;FieldValue:WideString) of Object;

  TEditWBeforeGetDataEvent = procedure(Sender:TComponent;FieldValue:WideString) of Object;

  TEditWAfterGetDataEvent  = procedure(Sender:TComponent;FieldValue:WideString) of Object;

  TAspFileDbControlFieldStr  = type String;
  TAspFileDbControlFieldName = class(TPropertyEditor)
    public
      function  GetEditLimit:integer;              Override;
      function  GetAttributes:TPropertyAttributes; Override;
      procedure GetValues(proc:TGetStrProc);       Override;
      function  GetValue:String;                   Override;
      procedure SetValue(const value:String);      Override;
  end;

  TAspFileDbFileStr  = type String;
  TAspFileDbFileName = class(TStringProperty)
  public
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
  end;

  TAspFileDbSchemaFileStr = type String;
  TAspFileDbSchemaFileName = class(TStringProperty)
  public
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
  end;

  TWarpField = class(TComponent)
  private
    FDataSet:TAspFileDataSet;
    FFieldName:string;
    function  GetAsString:string;
    procedure SetAsString(Value:string);
    function  GetAsBoolean: boolean;
    function  GetAsFloat: double;
    function  GetAsInteger: integer;
    function  GetAsVariant: Variant;
    procedure SetAsBoolean(const Value: boolean);
    procedure SetAsFloat(const Value: double);
    procedure SetAsInteger(const Value: integer);
    procedure SetAsVariant(const Value: Variant);
    function  GetAsUniCodeStr: WideString;
    procedure SetAsUniCodeStr(const Value: WideString);
  public
    Constructor Create(AOwner:TComponent); Override;
  published
    property AsString:string   read GetAsString  write SetAsString;
    property AsBoolean:boolean read GetAsBoolean write SetAsBoolean;
    property AsInteger:integer read GetAsInteger write SetAsInteger;
    property AsFloat  :double  read GetAsFloat   write SetAsFloat;
    property AsVariant:Variant read GetAsVariant write SetAsVariant;
    property AsUniCodeStr:WideString read  GetAsUniCodeStr
                                     write SetAsUniCodeStr;
  end;

  TAspFileDataSet = Class(TComponent)
  private
    IsDesignTimeOpened:boolean;
    InternalDataSource:TAspFileDataSource;
    //-----------------------------------
    FCallEditor:boolean;
    //-----------------------------------
    FWarpFieldList:TStringList;
    FFilterCommand:TStringList;
    FDataSet:IFileDataSet;
    FAccessUserName:string;
    FAccessFileName:TAspFileDbFileStr;
    FSchemaFileName:TAspFileDbSchemaFileStr;
    FActive:boolean;
    FReadOnly:boolean;
    FMethods:TDbMethods;
    procedure SetFDataSet(const Value:IFileDataSet);
    procedure SetFAccessFileName(const Value:TAspFileDbFileStr);
    procedure SetFActive(const Value:boolean);
    procedure SetFAccessUserName(const Value:string);
    procedure SetFFilterCommand(const Value: TStringList);
    procedure SetFReadOnly(const Value: boolean);
    function  GetFFilterCommand: TStringList;
    procedure SetFSchemaFileName(const Value:TAspFileDbSchemaFileStr);
    function  GetOrderByValue: boolean;
    procedure SetOrderByValue(const Value: boolean);
    function  GetCallFieldEditor: boolean;
    procedure SetCallFieldEditor(const Value: boolean);
    procedure SetFCallEditor(const Value: boolean);
  protected
    procedure DoAfterFilterChange;
    procedure DoAfterDataChange;
    procedure DoAfterDBStateChange;
    procedure DoInitDataControlData;
  public

    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
    function  AddNewField(FieldName:string;Size:integer;IsKey,CanNull,
                          IsUniCodeField:boolean;
                          IsLookUpField:boolean;LookUpDataSet:TAspFileDataSet;
                          MasterFieldName,LookUpKeyField,LookUpResultField:string):boolean;

    function  AddDetailDb(DetailOBJ:TAspFileDataSet;
                          MasterKeyFields,DetailForginKeyFields:string;
                          IsMultiFieldsRelation:boolean):boolean;

    function  IsEof:boolean;
    function  IsBof:boolean;
    function  IsEmpty:boolean;
    function  IsDetailDB:boolean;
    function  IsUseFilter:boolean;
    function  IsKeyField (FieldName:string):boolean;
    function  IsDataField(FieldName:string):boolean;
    function  IsNotNullField(FieldName:string):boolean;
    function  FieldDataSize(FieldName:string):integer;
    function  IsThisFieldExists(FieldName:string):boolean;
    function  DeleteField(FieldName:string):boolean;
    function  DeleteAllFields:boolean;

    procedure SetUseFilter(Value:boolean);

    function  RecordCount:integer;
    function  FieldCount:integer;
    function  DetailDbCount:integer;
    function  DataFilterCount:integer;

    function  DbState:string;
    function  FieldName(Index:integer):string;

    procedure First;
    procedure Prior;
    procedure Next;
    procedure Last;
    procedure Insert;
    procedure Edit;
    procedure Delete;
    function  Post:boolean;
    procedure Cancel;

    function  LocateByKeyValues(KeyValues:TStringList):boolean; Overload;
    function  LocateByKeyValues(KeyValues:String):boolean; Overload;

    function  CreateDataFile(NewTableName:string):boolean;

    function  GetBookMark:integer;
    procedure GotoBookMark(BookMark:integer);

    function  AddNewDataFilterItem(FilterCommandStr:string):boolean;
    function  DeleteDataFilterItem(FilterItemName:string):boolean;
    procedure DeleteAllDataFilters;

    function  LockCurrentRecord(LockReasonStr:string):boolean;
    function  UnLockCurrentRecord:boolean;

    procedure SaveSchema(FileName:string);
    function  DataFileSize:integer;

    function  FieldByName(inFieldName: string):TWarpField;

    procedure CallFieldEditorProc;

    function  SumTotalValueWithFilter(FieldName:string):double;

    property  RecDataSet:IFileDataSet read FDataSet    write SetFDataSet;
    property  CallEditor:boolean      read FCallEditor write SetFCallEditor;

  published
    property  Active:boolean read FActive write SetFActive Default FALSE;
    property  AccessFile:TAspFileDbFileStr read  FAccessFileName
                                           write SetFAccessFileName;
    property  AccessUser:string read FAccessUserName write SetFAccessUserName;
    property  SchemaFileName:TAspFileDbSchemaFileStr read  FSchemaFileName
                                                     write SetFSchemaFileName;
    property  DataReadOnly:boolean      read FReadOnly         write SetFReadOnly;
    property  FilterCommand:TStringList read GetFFilterCommand write SetFFilterCommand;
    property  DBMethods:TDbMethods read FMethods write FMethods;
    property  OrderByDesc:boolean  read GetOrderByValue    write SetOrderByValue;
    property  DefineFields:boolean read GetCallFieldEditor write SetCallFieldEditor;
  end;
  
  TAspFileDataSource = class(TComponent)
  private
    FDataControls:TStrings;
    FDataSet:TAspFileDataSet;
    procedure SetFDataSet(const Value:TAspFileDataSet);
  protected
    function  CtrlByName(inName:string):TComponent;
    procedure AddNewDBEdit(inDbEdit :TAspFileDBEdit);
    procedure RemoveDBEdit(OutDbEdit:TAspFileDBEdit);
    procedure AddNewDBMemo(inDbMemo :TAspFileDBMemo);
    procedure RemoveDBMemo(OutDbMemo:TAspFileDBMemo);
    procedure AddNewDBComboBox(inDbEdit :TAspFileDBComboBox);
    procedure RemoveDBComboBox(OutDbEdit:TAspFileDBComboBox);
    procedure AddNewDBWEdit(inDbEdit :TAspFileDBWEdit);
    procedure RemoveDBWEdit(OutDbEdit:TAspFileDBWEdit);
    procedure AddNewDBText(inDbText :TAspFileDBText);
    procedure RemoveDBText(OutDbText:TAspFileDBText);
    procedure AddNewDBWText(inDbText :TAspFileDBWText);
    procedure RemoveDBWText(OutDbText:TAspFileDBWText);
    procedure AddNewDBNavigator(inDbNav :TAspFileDBNavigator);
    procedure RemoveDBNavigator(OutDbNav:TAspFileDBNavigator);
    procedure AddNewDBGrid(inDbGrid :TAspFileDBGrid);
    procedure RemoveDBGrid(OutDbGrid:TAspFileDBgrid);

    procedure RefreshDBGridParamsWithNavigatorFirstClick;
    procedure RefreshDBGridParamsWithNavigatorPriorClick;
    procedure RefreshDBGridParamsWithNavigatorNextClick;
    procedure RefreshDBGridParamsWithNavigatorLastClick;

    procedure RefreshDBGridParamsWithNavigatorPostClick;
    procedure RefreshDBGridParamsWithNavigatorDeleteClick;

    procedure RefreshDBGridParamsWhenDataFilterChanged;
    
    procedure ResetDBGridSelectCell(Sender:TAspFileDBGrid;
                                    Col,NewRow:integer);
    procedure ResetAllGridGridTopDataPos;
    procedure PostDisplayData;
    procedure PostDisplayDataWithOutDbGird;
    procedure RefreshNavigator;
    procedure RefreshDBGrid;
  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
  published
    property  DataSet:TAspFileDataSet read FDataSet write SetFDataSet;
  end;

  TAspFileDBEdit = class(TMaskEdit)
  private
    Value:string;
    FDataSource:TAspFileDataSource;
    FFieldName:TAspFileDbControlFieldStr;

    FBeforeSetData:TEditBeforeSetDataEvent;
    FAfterSetData :TEditAfterSetDataEvent;

    FBeforeGetData:TEditBeforeGetDataEvent;
    FAfterGetData :TEditAfterGetDataEvent;

    procedure SetFDataSource(const Value: TAspFileDataSource);
    procedure SetFFieldName(const Value: TAspFileDbControlFieldStr);
  protected

  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
    procedure   KeyPress(var Key: Char); Override;
  published
    property  EditMask;
    property  DataSource:TAspFileDataSource read FDataSource
                                            write SetFDataSource;
                                            
    property  DataField:TAspFileDbControlFieldStr read FFieldName
                                                  write SetFFieldName;

    property  OnBeforeSetData:TEditBeforeSetDataEvent
                              read FBeforeSetData write FBeforeSetData;

    property  OnAfterSetData :TEditAfterSetDataEvent
                              read FAfterSetData  write FAfterSetData;

    property  OnBeforeGetData:TEditBeforeGetDataEvent
                              read FBeforeGetData write FBeforeGetData;

    property  OnAfterGetData :TEditAfterGetDataEvent
                              read FAfterGetData  write FAfterGetData;
  end;

  TAspFileDBMemo = class(TMemo)
  private
    Value:TStrings;
    FDataSource:TAspFileDataSource;
    FFieldName:TAspFileDbControlFieldStr;

    FBeforeSetData:TEditBeforeSetDataEvent;
    FAfterSetData :TEditAfterSetDataEvent;

    FBeforeGetData:TEditBeforeGetDataEvent;
    FAfterGetData :TEditAfterGetDataEvent;

    procedure SetFDataSource(const Value: TAspFileDataSource);
    procedure SetFFieldName(const Value: TAspFileDbControlFieldStr);
  protected

  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
    procedure   KeyPress(var Key: Char); Override;
  published
    property  DataSource:TAspFileDataSource read FDataSource
                                            write SetFDataSource;

    property  DataField:TAspFileDbControlFieldStr read FFieldName
                                                  write SetFFieldName;

    property  OnBeforeSetData:TEditBeforeSetDataEvent
                              read FBeforeSetData write FBeforeSetData;

    property  OnAfterSetData :TEditAfterSetDataEvent
                              read FAfterSetData  write FAfterSetData;

    property  OnBeforeGetData:TEditBeforeGetDataEvent
                              read FBeforeGetData write FBeforeGetData;

    property  OnAfterGetData :TEditAfterGetDataEvent
                              read FAfterGetData  write FAfterGetData;
  end;

  TAspFileDBComboBox = class(TComboBox)
  private
    FDataSource:TAspFileDataSource;
    FFieldName:TAspFileDbControlFieldStr;

    FBeforeSetData:TEditBeforeSetDataEvent;
    FAfterSetData :TEditAfterSetDataEvent;

    FBeforeGetData:TEditBeforeGetDataEvent;
    FAfterGetData :TEditAfterGetDataEvent;

    procedure SetFDataSource(const Value: TAspFileDataSource);
    procedure SetFFieldName(const Value: TAspFileDbControlFieldStr);
  protected
  public   
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
    procedure   KeyPress(var Key: Char); Override;
  published
    property  DataSource:TAspFileDataSource read FDataSource
                                            write SetFDataSource;

    property  DataField:TAspFileDbControlFieldStr read FFieldName
                                                  write SetFFieldName;

    property  OnBeforeSetData:TEditBeforeSetDataEvent
                              read FBeforeSetData write FBeforeSetData;

    property  OnAfterSetData :TEditAfterSetDataEvent
                              read FAfterSetData  write FAfterSetData;

    property  OnBeforeGetData:TEditBeforeGetDataEvent
                              read FBeforeGetData write FBeforeGetData;

    property  OnAfterGetData :TEditAfterGetDataEvent
                              read FAfterGetData  write FAfterGetData;
  end;

  TAspFileDBText = class(TLabel)
  private
    FDataSource:TAspFileDataSource;
    FFieldName:TAspFileDbControlFieldStr;
    procedure SetFDataSource(const Value: TAspFileDataSource);
  protected

  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
  published
    property  DataSource:TAspFileDataSource read  FDataSource
                                            write SetFDataSource;

    property  DataField:TAspFileDbControlFieldStr read FFieldName
                                                  write FFieldName;
  end;

  TAspFileDBWEdit = class(TTntEdit)
  private
    FDataSource:TAspFileDataSource;
    FFieldName:TAspFileDbControlFieldStr;

    FBeforeSetData:TEditWBeforeSetDataEvent;
    FAfterSetData :TEditWAfterSetDataEvent;

    FBeforeGetData:TEditWBeforeGetDataEvent;
    FAfterGetData :TEditWAfterGetDataEvent;

    procedure SetFDataSource(const Value: TAspFileDataSource);
    procedure SetFFieldName(const Value: TAspFileDbControlFieldStr);
  protected

  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
    procedure   KeyPress(var Key: Char); Override;
  published
    property  DataSource:TAspFileDataSource read FDataSource
                                            write SetFDataSource;

    property  DataField:TAspFileDbControlFieldStr read FFieldName
                                                  write SetFFieldName;

    property  OnBeforeSetData:TEditWBeforeSetDataEvent
                              read FBeforeSetData write FBeforeSetData;

    property  OnAfterSetData :TEditWAfterSetDataEvent
                              read FAfterSetData  write FAfterSetData;

    property  OnBeforeGetData:TEditWBeforeGetDataEvent
                              read FBeforeGetData write FBeforeGetData;

    property  OnAfterGetData :TEditWAfterGetDataEvent
                              read FAfterGetData  write FAfterGetData;
  end;

  TAspFileDBWText = class(TTntLabel)
  private
    FDataSource:TAspFileDataSource;
    FFieldName:TAspFileDbControlFieldStr;
    procedure SetFDataSource(const Value: TAspFileDataSource);
  protected

  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;
  published
    property  DataSource:TAspFileDataSource read  FDataSource
                                            write SetFDataSource;

    property  DataField:TAspFileDbControlFieldStr read FFieldName
                                                  write FFieldName;
  end;

  TNavBtn = class(TBitBtn)
  private

  protected

  public
    IsCustomBtn:boolean;
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
  published
    property Enabled;
  end;

  TAspFileDBNavigator = class(TPanel)
  private
    { Private declarations }
    BtnFirst :TNavBtn;
    BtnPrior :TNavBtn;
    BtnNext  :TNavBtn;
    BtnLast  :TNavBtn;
    BtnAdd   :TNavBtn;
    BtnEdit  :TNavBtn;
    BtnDelete:TNavBtn;
    BtnSave  :TNavBtn;
    BtnCancel:TNavBtn;
    BtnQuery :TNavBtn;
    SplitterPanel:TPanel;
    //----------------------------------------
    InternalNavNo :integer;
    FAllBtnHeight :integer;
    FConfirmDelete:boolean;
    FDataSource:TAspFileDataSource;

    FBeforeNavBtnClick:TNavBtnPressedEvent;
    FAfterNavBtnClick :TNavBtnPressedEvent;

    FBeforeCustomBtnClick:TNavBtnPressedEvent;
    FAfterCustomBtnClick :TNavBtnPressedEvent;

    procedure SetFDataSource(const Value: TAspFileDataSource);
    function  GetAddPic   :TBitMap;
    function  GetCancelPic:TBitMap;
    function  GetDeletePic:TBitMap;
    function  GetEditPic  :TBitMap;
    function  GetFirstPic :TBitMap;
    function  GetLastPic  :TBitMap;
    function  GetNextPic  :TBitMap;
    function  GetPriorPic :TBitMap;
    function  GetQueryPic :TBitMap;
    function  GetSavePic  :TBitMap;
    procedure SetAddPic   (const Value: TBitMap);
    procedure SetCancelPic(const Value: TBitMap);
    procedure SetDeletePic(const Value: TBitMap);
    procedure SetEditPic  (const Value: TBitMap);
    procedure SetFirstPic (const Value: TBitMap);
    procedure SetLastPic  (const Value: TBitMap);
    procedure SetNextPic  (const Value: TBitMap);
    procedure SetPriorPic (const Value: TBitMap);
    procedure SetQueryPic (const Value: TBitMap);
    procedure SetSavePic  (const Value: TBitMap);
    function  GetAddCaption   : string;
    function  GetCancelCaption: string;
    function  GetDeleteCaption: string;
    function  GetEditCaption  : string;
    function  GetFirstCaption : string;
    function  GetLastCaption  : string;
    function  GetNextCaption  : string;
    function  GetPriorCaption : string;
    function  GetQueryCaption : string;
    function  GetSaveCaption  : string;
    procedure SetAddCaption   (const Value: string);
    procedure SetCancelCaption(const Value: string);
    procedure SetDeleteCaption(const Value: string);
    procedure SetEditCaption  (const Value: string);
    procedure SetFirstCaption (const Value: string);
    procedure SetLastCaption  (const Value: string);
    procedure SetNextCaption  (const Value: string);
    procedure SetPriorCaption (const Value: string);
    procedure SetQueryCaption (const Value: string);
    procedure SetSaveCaption  (const Value: string);
    function  GetAddEnabled: boolean;
    function  GetCancelEnabled: boolean;
    function  GetDeleteEnabled: boolean;
    function  GetEditEnabled: boolean;
    function  GetFirstEnabled: boolean;
    function  GetLastEnabled: boolean;
    function  GetNextEnabled: boolean;
    function  GetPriorEnabled: boolean;
    function  GetQueryEnabled: boolean;
    function  GetSaveEnabled: boolean;
    procedure SetAddEnabled(const Value: boolean);
    procedure SetCancelEnabled(const Value: boolean);
    procedure SetDeleteEnabled(const Value: boolean);
    procedure SetEditEnabled(const Value: boolean);
    procedure SetFirstEnabled(const Value: boolean);
    procedure SetLastEnabled(const Value: boolean);
    procedure SetNextEnabled(const Value: boolean);
    procedure SetPriorEnabled(const Value: boolean);
    procedure SetQueryEnabled(const Value: boolean);
    procedure SetSaveEnabled(const Value: boolean);
    procedure SetFConfirmDelete(const Value: boolean);
    procedure SetAllBtnHeight(const Value: integer);
    function  GetAddIsCustomBtn   :boolean;
    function  GetCancelIsCustomBtn:boolean;
    function  GetDeleteIsCustomBtn:boolean;
    function  GetEditIsCustomBtn  :boolean;
    function  GetFirstIsCustomBtn :boolean;
    function  GetLastIsCustomBtn  :boolean;
    function  GetNextIsCustomBtn  :boolean;
    function  GetPriorIsCustomBtn :boolean;
    function  GetQueryIsCustomBtn :boolean;
    function  GetSaveIsCustomBtn  :boolean;
    procedure SetAddIsCustomBtn(const Value: boolean);
    procedure SetCancelIsCustomBtn(const Value: boolean);
    procedure SetDeleteIsCustomBtn(const Value: boolean);
    procedure SetEditIsCustomBtn(const Value: boolean);
    procedure SetFirstIsCustomBtn(const Value: boolean);
    procedure SetLastIsCustomBtn(const Value: boolean);
    procedure SetNextIsCustomBtn(const Value: boolean);
    procedure SetPriorIsCustomBtn(const Value: boolean);
    procedure SetQueryIsCustomBtn(const Value: boolean);
    procedure SetSaveIsCustomBtn(const Value: boolean);
    function GetAddVisible: boolean;
    function GetCancelVisible: boolean;
    function GetDeleteVisible: boolean;
    function GetEditVisible: boolean;
    function GetFirstVisible: boolean;
    function GetLastVisible: boolean;
    function GetNextVisible: boolean;
    function GetPriorVisible: boolean;
    function GetQueryVisible: boolean;
    function GetSaveVisible: boolean;
    procedure SetAddVisible(const Value: boolean);
    procedure SetCancelVisible(const Value: boolean);
    procedure SetDeleteVisible(const Value: boolean);
    procedure SetEditVisible(const Value: boolean);
    procedure SetFirstVisible(const Value: boolean);
    procedure SetLastVisible(const Value: boolean);
    procedure SetNextVisible(const Value: boolean);
    procedure SetPriorVisible(const Value: boolean);
    procedure SetQueryVisible(const Value: boolean);
    procedure SetSaveVisible(const Value: boolean);
  protected
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Paint;   Override;
    procedure   ReSize;  Override;

    procedure EnableButtons( enFirst,enPrior,enNext,enLast
                            ,enAdd,enEdit,enDel,enQry,enSave,enCancel:boolean);

    procedure RunFirstClick(Sender:TObject);
    procedure RunPriorClick(Sender:TObject);
    procedure RunNextClick(Sender:TObject);
    procedure RunLastClick(Sender:TObject);

    procedure RunAddClick(Sender:TObject);
    procedure RunEditClick(Sender:TObject);
    procedure RunDeleteClick(Sender:TObject);
    procedure RunQueryClick(Sender:TObject);
    procedure RunSaveClick(Sender:TObject);
    procedure RunCancelClick(Sender:TObject);

    procedure RunCustomClick(Sender:TObject);

  published

    property  ConfirmDelete:boolean read  FConfirmDelete
                                    write SetFConfirmDelete;

    property  DataSource:TAspFileDataSource read  FDataSource
                                            write SetFDataSource;

    property  AllBtnHeight :integer read FAllBtnHeight write SetAllBtnHeight;

    property  BtnFirstPic :TBitMap  read GetFirstPic  write SetFirstPic;
    property  BtnPriorPic :TBitMap  read GetPriorPic  write SetPriorPic;
    property  BtnNextPic  :TBitMap  read GetNextPic   write SetNextPic;
    property  BtnLastPic  :TBitMap  read GetLastPic   write SetLastPic;

    property  BtnAddPic   :TBitMap  read GetAddPic    write SetAddPic;
    property  BtnEditPic  :TBitMap  read GetEditPic   write SetEditPic;
    property  BtnDeletePic:TBitMap  read GetDeletePic write SetDeletePic;
    property  BtnQueryPic :TBitMap  read GetQueryPic  write SetQueryPic;
    property  BtnSavePic  :TBitMap  read GetSavePic   write SetSavePic;
    property  BtnCancelPic:TBitMap  read GetCancelPic write SetCancelPic;

    property  BtnFirstCaption :string  read  GetFirstCaption
                                       write SetFirstCaption;


    property  BtnPriorCaption :string  read  GetPriorCaption
                                       write SetPriorCaption;

    property  BtnNextCaption  :string  read  GetNextCaption
                                       write SetNextCaption;

    property  BtnLastCaption  :string  read  GetLastCaption
                                       write SetLastCaption;

    property  BtnAddCaption   :string  read  GetAddCaption
                                       write SetAddCaption;

    property  BtnEditCaption  :string  read  GetEditCaption
                                       write SetEditCaption;

    property  BtnDeleteCaption:string  read  GetDeleteCaption
                                       write SetDeleteCaption;

    property  BtnQueryCaption :string  read  GetQueryCaption
                                       write SetQueryCaption;

    property  BtnSaveCaption  :string  read  GetSaveCaption
                                       write SetSaveCaption;

    property  BtnCancelCaption:string  read  GetCancelCaption
                                       write SetCancelCaption;

    property  BtnFirstIsCustomBtn:boolean read  GetFirstIsCustomBtn
                                          write SetFirstIsCustomBtn;

    property  BtnPriorIsCustomBtn:boolean read  GetPriorIsCustomBtn
                                              write SetPriorIsCustomBtn;

    property  BtnNextIsCustomBtn:boolean read  GetNextIsCustomBtn
                                              write SetNextIsCustomBtn;

    property  BtnLastIsCustomBtn:boolean read  GetLastIsCustomBtn
                                              write SetLastIsCustomBtn;

    property  BtnAddIsCustomBtn:boolean read  GetAddIsCustomBtn
                                            write SetAddIsCustomBtn;

    property  BtnEditIsCustomBtn:boolean read  GetEditIsCustomBtn
                                             write SetEditIsCustomBtn;

    property  BtnDeleteIsCustomBtn:boolean read  GetDeleteIsCustomBtn
                                              write SetDeleteIsCustomBtn;

    property  BtnQueryIsCustomBtn:boolean read  GetQueryIsCustomBtn
                                              write SetQueryIsCustomBtn;

    property  BtnSaveIsCustomBtn:boolean read  GetSaveIsCustomBtn
                                             write SetSaveIsCustomBtn;

    property  BtnCancelIsCustomBtn:boolean read  GetCancelIsCustomBtn
                                               write SetCancelIsCustomBtn;

    property  BtnFirstEnabled :boolean  read  GetFirstEnabled
                                        write SetFirstEnabled;


    property  BtnPriorEnabled :boolean  read  GetPriorEnabled
                                        write SetPriorEnabled;

    property  BtnNextEnabled  :boolean  read  GetNextEnabled
                                        write SetNextEnabled;

    property  BtnLastEnabled  :boolean  read  GetLastEnabled
                                        write SetLastEnabled;

    property  BtnAddEnabled   :boolean  read  GetAddEnabled
                                        write SetAddEnabled;

    property  BtnEditEnabled  :boolean  read  GetEditEnabled
                                        write SetEditEnabled;

    property  BtnDeleteEnabled:boolean  read  GetDeleteEnabled
                                        write SetDeleteEnabled;

    property  BtnQueryEnabled :boolean  read  GetQueryEnabled
                                        write SetQueryEnabled;

    property  BtnSaveEnabled  :boolean  read  GetSaveEnabled
                                        write SetSaveEnabled;

    property  BtnCancelEnabled:boolean  read  GetCancelEnabled
                                        write SetCancelEnabled;
    //---------------------------------------------------------
    property  BtnFirstVisible :boolean read  GetFirstVisible
                                       write SetFirstVisible;

    property  BtnPriorVisible :boolean read  GetPriorVisible
                                       write SetPriorVisible;

    property  BtnNextVisible :boolean  read  GetNextVisible
                                       write SetNextVisible;

    property  BtnLastVisible :boolean  read  GetLastVisible
                                       write SetLastVisible;

    property  BtnAddVisible :boolean   read  GetAddVisible
                                       write SetAddVisible;

    property  BtnEditVisible :boolean  read  GetEditVisible
                                       write SetEditVisible;

    property  BtnDeleteVisible :boolean read  GetDeleteVisible
                                        write SetDeleteVisible;

    property  BtnQueryVisible :boolean read  GetQueryVisible
                                       write SetQueryVisible;

    property  BtnSaveVisible :boolean  read  GetSaveVisible
                                       write SetSaveVisible;

    property  BtnCancelVisible :boolean read  GetCancelVisible
                                        write SetCancelVisible;
    //---------------------------------------------------------
    property OnBeforeNavBtnClick:TNavBtnPressedEvent read  FBeforeNavBtnClick
                                                     write FBeforeNavBtnClick;

    property OnAfterNavBtnClick :TNavBtnPressedEvent read  FAfterNavBtnClick
                                                     write FAfterNavBtnClick;

    property BeforeCustomBtnClick:TNavBtnPressedEvent read  FBeforeCustomBtnClick
                                                      write FBeforeCustomBtnClick;
    property AfterCustomBtnClick :TNavBtnPressedEvent read  FAfterCustomBtnClick
                                                      write FAfterCustomBtnClick;
  end;

  TGridCell = class(TCustomPanel)
  private
    FIsTitleCell:boolean;
    FIsModify:boolean;
    FIsSelect:boolean;
    FCol:integer;
    FRow:integer;
    FOldValue:string;
    FValue:string;
    procedure SetFCol(const Value: integer);
    procedure SetFRow(const Value: integer);
    procedure SetFIsTitleCell(const Value: boolean);
    procedure SetFIsModify(const Value: boolean);
    function  GetAsString: string;
    procedure SetAsString(const Value: string);
    function  GetOldValue: string;
    procedure SetOldValue(const Value: string);
  protected
    RecPos        :integer;
    GKeyValue     :string;
    OwnerComp     :TColumnItem;
    FilterRecPos  :integer;
    PhysicalRecPos:integer;
    //------------------------------------------------
    function    GetEditOwner:TColumnItem;
    procedure   PutCellData(inCell:TGridCell);
    procedure   ClearCellData;
    procedure   InitDataCellValue;

    procedure   DoOnComboBoxChange(Sender:TObject);
    procedure   DoOnButtonClick(Sender:TObject);
    procedure   DoOnCheckBoxClick(Sender:TObject);

    procedure   DataCellSetFocus(SeekCursorPos:boolean);
  public
    IsFlashByUser:boolean;
    FlashCheckIsTrue:boolean;

    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Paint; Override;

    procedure   MouseDown( Button: TMouseButton
                          ;Shift: TShiftState; X, Y: Integer); Override;
    procedure   KeyDown(var Key: Word; Shift: TShiftState); Override;
    procedure   KeyPress(var Key: Char); Override;
    procedure   DoKeyDowned (Sender:TObject;var Key: Word; Shift: TShiftState);
    procedure   DoKeyPressed(Sender:TObject;var Key: Char);

    function    IsSelected:boolean;

    property    AsString:string read GetAsString write SetAsString;
    property    OldValue:string read GetOldValue write SetOldValue;

  published
    property IsTitleCell:boolean read FIsTitleCell write SetFIsTitleCell;
    property IsModify   :boolean read FIsModify    write SetFIsModify;
    property Col:integer read FCol write SetFCol;
    property Row:integer read FRow write SetFRow;
  end;

  TGridCellW = class(TTntCustomPanel)
  private
    FIsTitleCell:boolean;
    FIsModify:boolean;
    FCol:integer;
    FRow:integer;
    FOldValue:WideString;
    FValue:WideString;
    procedure SetFCol(const Value: integer);
    procedure SetFRow(const Value: integer);
    procedure SetFIsTitleCell(const Value: boolean);
    procedure SetFIsModify(const Value: boolean);
    function  GetAsUniCodeStr: WideString;
    procedure SetAsUniCodeStr(const Value: WideString);
    function  GetOldValue: WideString;
    procedure SetOldValue(const Value: WideString);
  protected
    RecPos        :integer;
    FilterRecPos  :integer;
    PhysicalRecPos:integer;
    GKeyValue     :string;
    OwnerComp:TColumnItem;
    function    GetEditOwner:TColumnItem;
    procedure   PutCellData(inCell:TGridCell);
    procedure   ClearCellData;
    procedure   InitDataCellValue;

    procedure   DoOnComboBoxChange(Sender:TObject);
    procedure   DoOnButtonClick(Sender:TObject);

    procedure   DataCellSetFocus(SeekCursorPos:boolean);
  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Paint; Override;
    procedure   MouseDown( Button: TMouseButton
                          ;Shift: TShiftState; X, Y: Integer); Override;
    procedure   KeyDown(var Key: Word; Shift: TShiftState); Override;
    procedure   KeyPress(var Key: Char); Override;
    procedure   DoKeyDowned (Sender:TObject;var Key: Word; Shift: TShiftState);
    procedure   DoKeyPressed(Sender:TObject;var Key: Char);

    property    AsUniCodeStr:WideString read  GetAsUniCodeStr
                                        write SetAsUniCodeStr;
    property    OldValue:WideString read GetOldValue write SetOldValue;

  published
    property IsTitleCell:boolean read FIsTitleCell write SetFIsTitleCell;
    property IsModify   :boolean read FIsModify    write SetFIsModify;
    property Col:integer read FCol write SetFCol;
    property Row:integer read FRow write SetFRow;
  end;

  TPickListRefFieldItem = class(TCollectionItem)
  Private
    FDisPlayName:string;
    FFieldDescrip:string;
    FDataList:TStrings;
    function  GetDataList:TStrings;
    function  GetRefData(Index: integer): string;
    procedure SetDataList(const Value: TStrings);
    procedure SetRefData(Index: integer; const Value: string);
    procedure SetFFieldDescrip(const Value: string);
  Protected
    function    GetRefFieldDescStr:string;
    function    GetDisplayName: string; Override;
    procedure   SetDisplayName(const Value: string); Override;
  Public
    Constructor Create(Collection:TCollection); Override;
    Destructor  Destroy; Override;
    procedure   Assign(Source: TPersistent); Override;
  Published
    property FieldDescrip:string  read FFieldDescrip write SetFFieldDescrip;
    property DataList:TStrings read GetDataList  write SetDataList;
  end;

  TColumnPickListRefFields = Class(TOwnedCollection)
  private
    procedure   SetPickListRefFieldItem(Index:Integer;
                                        value:TPickListRefFieldItem);
    function    GetPickListRefFieldItem(Index: Integer):TPickListRefFieldItem;
    function GetPickListRefFieldItemByDesc(
      Descrip: string): TPickListRefFieldItem;
    procedure SetPickListRefFieldItemByDesc(Descrip: string;
      const Value: TPickListRefFieldItem);
  protected
    function    GetCount:Integer;
  Public
    Constructor Create(TheOwner:TComponent;
                       ItemClass:TPickListRefFieldItemClass);
    Destructor  Destroy; Override;
    function    Add:TPickListRefFieldItem;

    property    RefFields[Index: Integer]:TPickListRefFieldItem
                  read  GetPickListRefFieldItem
                  write SetPickListRefFieldItem;
    property    RefFieldByDesc[Descrip :string]:TPickListRefFieldItem
                  read  GetPickListRefFieldItemByDesc
                  write SetPickListRefFieldItemByDesc;
  end;

  TColumnItem = class(TCollectionItem)
  Private
    ColumnCombo:TComboBox;
    ColumnComboW:TTntComboBox;
    TitleCell:TGridCell;
    LinkControl:TPanel;
    //-----------------------------------------
    FBeARecordSelectColumn:boolean;
    FSelectColumnCaption:string;
    FUseSelfComboBox:boolean;
    //-----------------------------------------
    FWithOutFocus:boolean;
    FMaskStr:string;
    FTitleHint:string;
    FFieldName:TAspFileDbControlFieldStr;
    FEditStyle:TColumnEditStyle;
    FEditComboStyle:TComboBoxStyle;
    FDataCellList:TStrings;
    FPickUpList :TStrings;
    FPickListRefFields:TColumnPickListRefFields;
    //-----------------------------------------
    FShowPickUpListItem:boolean;
    FPickUpListW:TTntStrings;
    FDisPlayName:string;
    FTitle:string;
    FTitleColor:TColor;
    FTitleAlign:TTitleAlignType;
    FTitleFont:TFont;
    //-----------------------------------------
    FColumnColor:TColor;
    FColumnFontColor:TColor;
    FColumnFontStyles:TFontStyles;
    FColumnCharCase:TEditCharCase;
    //-----------------------------------------
    FHaveLinkControl:boolean;
    FLinkControlWidth:integer;
    FLinkControlHeight:integer;
    FLinkControlColor:TColor;
    FLinkControlCaption:string;
    FLinkControlAlignment:TAlignment;
    FLinkControlFont:TFont;
    FLinkControlStyle:TColumnLinkControlStyle;
    //-----------------------------------------
    FUseColumnColor:boolean;
    FColumnAlign:TColumnAlignType;
    FWidth:integer;
    FImeName:TImeName;
    //-----------------------------------------
    FCellBtnPressed      :TCellBtnPressedEvent;
    FCellComboBoxSelected:TCellComboBoxSelectedEvent;
    FCellGetValue        :TCellGetValueEvent;
    FCellPickListInit    :TCellPickListInitEvent;
    //-----------------------------------------
    FCellWBtnPressed      :TCellWBtnPressedEvent;
    FCellWComboBoxSelected:TCellWComboBoxSelectedEvent;
    FCellWGetValue        :TCellWGetValueEvent;
    //-----------------------------------------
    FOnFormatDisplayValue :TColumnDisplayFormatEvent;
    FOnFormatDisplayValueW:TColumnDisplayFormatWEvent;
    //-----------------------------------------
    procedure  SetFTitle(value:string);
    procedure  SetFEditStyle(const Value: TColumnEditStyle);
    function   GetFPickUpList: TStrings;
    procedure  SetFPickUpList(const Value: TStrings);
    procedure  SetFWidth(const Value: integer);
    procedure  SetFTitleColor(const Value: Tcolor);
    procedure  SetFTitleAlign(const Value: TTitleAlignType);
    procedure  SetFColumnAlign(const Value: TColumnAlignType);
    procedure  SetFColumnColor(const Value: TColor);
    procedure  SetFUseColumnColor(const Value: boolean);
    function   GetDataCell(Row: Integer): TGridCell;
    procedure  SetFColumnFontColor(const Value: TColor);
    procedure  SetFColumnFontStyles(const Value: TFontStyles);
    function   GetDataCellW(Row: Integer): TGridCellW;
    procedure  SetFTitleHint(const Value: string);
    procedure  SetFHaveLinkControl(const Value: boolean);
    procedure  SetFLinkControlCaption(const Value: string);
    procedure  SetFLinkControlColor(const Value: TColor);
    procedure  SetFLinkControlHeight(const Value: integer);
    procedure  SetFLinkControlWidth(const Value: integer);
    procedure  SetFLinkControlAlignment(const Value: TAlignment);
    procedure  SetFUseSelfComboBox(const Value: boolean);
    procedure  SetFLinkControlFont(const Value: TFont);
    procedure  SetFTitleFont(const Value: TFont);
    procedure  SetFLinkControlStyle(const Value: TColumnLinkControlStyle);
  Protected
     function  GetDisplayName: string; override;
     function  GetColumnStateStr:string;
     procedure SetDisplayName(const Value: string); override;
     procedure DoLinkControlClick(Sender:TObject);

     procedure ColumnTitleFixColumnWidth(FixWidth:integer);
  Public
     procedure ResetDataCellsWidth(NewWidth:integer);
     procedure OffsetCellLeftPos(offset:integer);
     function  CalcNewTitleCellLeftPos:integer;
     function  CalcNewDataCellTopPos(Index:integer):integer;

     procedure  AddNewDataCell;

     procedure  DeleteDataCell;

     Constructor Create(Collection:TCollection);override;
     Destructor  Destroy; Override;
     procedure   Assign(Source: TPersistent); override;

     property    DataCells[Row:Integer]:TGridCell read GetDataCell;
     property    DataCellsW[Row:Integer]:TGridCellW read GetDataCellW;

  Published
     property SelectColumnCaption:string read FSelectColumnCaption
                                         write FSelectColumnCaption;

     property BeARecordSelectColumn:boolean read FBeARecordSelectColumn
                                            write FBeARecordSelectColumn;

     property ImeName:TImeName read FImeName write FImeName;

     property ColumnWidth:integer read FWidth write SetFWidth;

     property ColumnAlign:TColumnAlignType read  FColumnAlign
                                           write SetFColumnAlign;
     property ColumnEditMask:string read FMaskStr write FMaskStr;
     property ColumnColor:TColor read FColumnColor write SetFColumnColor;
     property ColumnCharCase:TEditCharCase read FColumnCharCase write FColumnCharCase;
     property ColumnFontColor:TColor read FColumnFontColor write SetFColumnFontColor;
     property ColumnFontStyles:TFontStyles read FColumnFontStyles
                                           write SetFColumnFontStyles;
     property ColumnWithOutFocus:boolean read  FWithOutFocus
                                         write FWithOutFocus;
     property ColumnUseSelfComboBox:boolean read FUseSelfComboBox
                                            write SetFUseSelfComboBox;                                   
     property UseColumnColor:boolean read  FUseColumnColor
                                     write SetFUseColumnColor;
     property Title:string read FTitle write SetFTitle;
     property TitleHint:string read FTitleHint write SetFTitleHint;
     property TitleAlign:TTitleAlignType read FTitleAlign write SetFTitleAlign;
     property TitleColor:Tcolor read FTitleColor write SetFTitleColor;
     property TitleFont:TFont read FTitleFont write SetFTitleFont;

     property HaveLinkControl:boolean read  FHaveLinkControl
                                      write SetFHaveLinkControl;
     property LinkControlWidth:integer read  FLinkControlWidth
                                       write SetFLinkControlWidth;
     property LinkControlHeight:integer read  FLinkControlHeight
                                        write SetFLinkControlHeight;
     property LinkControlColor:TColor read  FLinkControlColor
                                      write SetFLinkControlColor;
     property LinkControlCaption:string read  FLinkControlCaption
                                        write SetFLinkControlCaption;
     property LinkControlFont:TFont read  FLinkControlFont
                                    write SetFLinkControlFont;
     property LinkControlAlignment:TAlignment read FLinkControlAlignment
                                          write SetFLinkControlAlignment;
     property LinkControlStyle:TColumnLinkControlStyle
                               read  FLinkControlStyle
                               write SetFLinkControlStyle;
     
     property EditStyle:TColumnEditStyle read FEditStyle write SetFEditStyle;

     property PickListEditStyle:TComboBoxStyle read  FEditComboStyle
                                               write FEditComboStyle;

     property ShowPickUpListItem:boolean read FShowPickUpListItem
                                         write FShowPickUpListItem;

     property PickList:TStrings read GetFPickUpList write SetFPickUpList;
     property PickListRefFields:TColumnPickListRefFields
                                read  FPickListRefFields
                                write FPickListRefFields;

     property DataField:TAspFileDbControlFieldStr read  FFieldName
                                                  write FFieldName;

     property CellBtnPressed:TCellBtnPressedEvent read FCellBtnPressed
                                                  write FCellBtnPressed;
                                                  
     property CellComboBoxSelected:TCellComboBoxSelectedEvent
                                             read  FCellComboBoxSelected
                                             write FCellComboBoxSelected;

     property CellGetValue:TCellGetValueEvent read  FCellGetValue
                                              write FCellGetValue;

     property CellPickListInit:TCellPickListInitEvent read  FCellPickListInit
                                                      write FCellPickListInit;

     property OnFormatDisplayValue:TColumnDisplayFormatEvent
                                   read  FOnFormatDisplayValue
                                   write FOnFormatDisplayValue;
     property OnFormatDisplayValueW:TColumnDisplayFormatWEvent
                                   read  FOnFormatDisplayValueW
                                   write FOnFormatDisplayValueW;
  end;
  
  TGridColumns = Class(TOwnedCollection)
  private
    FGrid:TAspFileDBGrid;
    procedure SeTColumnItem(Index:Integer;value:TColumnItem);
    function  GeTColumnItem(Index: Integer):TColumnItem;
    function  GetDataCell(Col, Row: Integer): TGridCell;
    function  GetDataCellW(Col, Row: Integer): TGridCellW;
  protected
    function    GetCount:Integer;
  Public
    Constructor Create(TheOwner:TComponent;ItemClass:TColumnItemClass);
    Destructor  Destroy; Override;
    function    Add:TColumnItem;
    property    Columns[Index: Integer]:TColumnItem
                read  GeTColumnItem write SeTColumnItem;
    property    DataCells[Col,Row: Integer]:TGridCell read GetDataCell;
    property    DataCellsW[Col,Row: Integer]:TGridCellW read GetDataCellW;
  end;

  TAspFileDBGrid = class(TScrollingWinControl)
  private
    { Private declarations }
    IsRefreshWithDataSource:boolean;

    IsSelectUniCodeDataCell:boolean;
    SelectedCell:TGridCell;
    SelectedCellW:TGridCellW;

    IsCursorUpChangeGridPostData:boolean;
    IsCursorDownChangeGridPostData:boolean;

    CurrentEditRow:integer;

    FScrollPanel:TScrollBar;

    FOnChkRecFlash:TGridCheckRecFlashEvent;
    FOnDoRecFlash :TGridDoRecordFlashEvent;
    FOnLinkControlClick:TColumnLinkControlClickEvent;

    FAutoSize:boolean;
    FMaxGridRow:integer;
    FTitleCellStartY:integer;
    FTitleCellHeight:Integer;
    FDataCellStartY:integer;
    FDataCellHeight:Integer;
    LeftStartX:integer;

    tmpChkBox:TCheckBox;
    tmpMemo  :TMemo;
    tmpEdit  :TMaskEdit;
    tmpCombo :TComboBox;
    tmpBtn   :TButton;

    tmpChkBoxW:TTntCheckBox;
    tmpMemoW  :TTntMemo;
    tmpEditW  :TTntEdit;
    tmpComboW :TTntComboBox;
    tmpBtnW   :TTntButton;

    FUseIntervalColor:boolean;
    FDataSource:TAspFileDataSource;
    FPopupMenu:TPopUpMenu;

    FGridNewDataPage    : TGridNewDataPageEvent;
    FGridNewRecord      : TGridNewRecordEvent;
    FGridPopUpMenuClick : TGridPopUpMenuClickEvent;

    FRowCount:integer;
    FColumns:TGridColumns;
    FReadOnly:boolean;
    FKeyFieldColor:TColor;
    FRecordFocusColor:TColor;
    procedure SetFRowCount(const Value: integer);
    procedure SetFDataSource(const Value: TAspFileDataSource);
    function  GetFRowCount: integer;
    procedure SetFReadOnly(const Value: boolean);
    procedure SetFPopupMenu(const Value: TPopUpMenu);
    procedure SetFRecordFocusColor(const Value: TColor);
    procedure SetFKeyFieldColor(const Value: TColor);
    procedure SetFUseIntervalColor(const Value: Boolean);
    procedure SetFDataCellStartY(const Value: integer);
    procedure SetFTitleCellHeight(const Value: Integer);
    procedure SetFTitleCellStartY(const Value: integer);
    procedure SetFMaxGridRow(const Value: integer);
    procedure SetFDataCellHeight(const Value: Integer);
    procedure ScrollData(Sender: TObject; ScrollCode: TScrollCode;
                         var ScrollPos: Integer);
    procedure SetFAutoSize(const Value: boolean);
  protected
    { Protected declarations }
    GridTopDataPos:integer;
    BreakDataRefreshLink:boolean;
    IsCursorPosInGridDisplayArea:boolean;
    GridMoveDataCursor:boolean;
    NavigatorMoveDataCursor:boolean;
    NavigatorMoveDataPrior :boolean;
    NavigatorMoveDataNext  :boolean;
    NavigatorMoveDataFirst :boolean;
    NavigatorMoveDataLast  :boolean;

    procedure   ResetGridScrollView;

    function    GetCurrentRecordInWhichRow:integer;
    function    IsThisRowDataIsDifferentWithFieldData(ThisRow:integer):boolean;

    procedure   RepaintSelectedRowCells(SelectedRow:integer);

    procedure   RunPopUpMenuClick(Sender:TObject);

    procedure   AddNewRecordCells;
    procedure   DeleteRecordCells;

    procedure   ClearInsertRow;
    procedure   DeleteInsertRowDataCell;

    procedure   SetNavigatorMoveDataCursor(IsMoveCursor:boolean);

    procedure   SetDBGridMoveDataCursor;

    procedure   DoOnExit(Sender: TObject);

    property RowCount:integer read GetFRowCount write SetFRowCount;
    
    property GridNewDataPage:TGridNewDataPageEvent read  FGridNewDataPage
                                                   write FGridNewDataPage;

    property GridNextRecord :TGridNewRecordEvent   read  FGridNewRecord
                                                   write FGridNewRecord;
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;

    procedure   ReSize; Override;

    procedure   Notification( AComponent:TComponent
                             ;Operation:TOperation); Override;

    procedure   MouseDown( Button: TMouseButton
                          ;Shift: TShiftState; X, Y: Integer); Override;

    function    ColumnByTitle(inTitleName:string):TColumnItem;

    procedure   DisableRefreshData;
    procedure   RefreshWithDataSource;
  published
    { Published declarations }
    property Align;
    property Font;
    property Color;
    property TabStop;
    property TabOrder;
    property AutoSize:boolean read FAutoSize write SetFAutoSize;
    property DataSource:TAspFileDataSource read FDataSource write SetFDataSource;
    property Columns   :TGridColumns read FColumns   write FColumns;
    property TitleCellHeight:Integer read FTitleCellHeight write SetFTitleCellHeight;
    property TitleCellStartY:integer read FTitleCellStartY write SetFTitleCellStartY;
    property IsReadOnly:boolean      read FReadOnly  write SetFReadOnly;
    property MaxGridRow:integer read FMaxGridRow write SetFMaxGridRow;
    property RecordFocusColor:TColor read  FRecordFocusColor
                                     write SetFRecordFocusColor;
    property KeyFieldColor:TColor    read  FKeyFieldColor
                                     write SetFKeyFieldColor;
    property UseIntervalColor:Boolean read FUseIntervalColor write SetFUseIntervalColor;                                                                  
    property PopUpMenu :TPopUpMenu   read FPopupMenu write SetFPopupMenu;

    property OnGridPopUpMenuClick:TGridPopUpMenuClickEvent
                                     read  FGridPopUpMenuClick
                                     write FGridPopUpMenuClick;
    
    property OnLinkControlClick:TColumnLinkControlClickEvent
                                  read  FOnLinkControlClick
                                  write FOnLinkControlClick;
    property OnKeyDown;
    property OnKeyPress;

    property DataCellStartY:integer read FDataCellStartY write SetFDataCellStartY;
    property DataCellHeight:Integer read FDataCellHeight write SetFDataCellHeight;

    property OnChkRecFlash:TGridCheckRecFlashEvent read FOnChkRecFlash write FOnChkRecFlash;
    property OnDoRecFlash :TGridDoRecordFlashEvent read FOnDoRecFlash write FOnDoRecFlash;
  end;

  function AspFileDBOBJInitialize(pvReserved: Pointer): HResult; stdcall;

procedure Register;

implementation

uses UStdFdEditor;

var DestroyTargetNavName:string;

procedure Register;
begin
  RegisterPropertyEditor( TypeInfo(TAspFileDbControlFieldStr),nil
                         ,'',TAspFileDbControlFieldName);

  RegisterPropertyEditor( TypeInfo(TAspFileDbFileStr),nil
                         ,'',TAspFileDbFileName);

  RegisterPropertyEditor( TypeInfo(TAspFileDbSchemaFileStr),nil
                         ,'',TAspFileDbSchemaFileName);
                         
  RegisterComponents('AspFileDBSuit',[ TAspFileDataSet
                                      ,TAspFileDataSource
                                      ,TAspFileDBEdit
                                      ,TAspFileDBText
                                      ,TAspFileDBNavigator
                                      ,TAspFileDBGrid
                                      ,TAspFileDBWEdit
                                      ,TAspFileDBWText
                                      ,TAspFileDBComboBox
                                      ,TAspFileDBMemo
                                      ]);
end;

function IsColumnItemLinkUniCodeField(inColumn:TColumnItem):boolean;
var VDataSet:TAspFileDataSet;
begin
  result := FALSE;
  if(inColumn = nil)then Exit;
  if(TGridColumns(inColumn.GetOwner).FGrid = nil)then Exit
  else
    if(TGridColumns(inColumn.GetOwner).FGrid.DataSource <> nil)then
      begin
        VDataSet := TGridColumns(inColumn.GetOwner).FGrid.FDataSource.FDataSet;
        if(VDataSet <> nil)then
        if(inColumn.FFieldName <> '')then
          begin
            if(VDataSet.RecDataSet.IsThisFieldExists(inColumn.FFieldName) = TRUE)then
              if(VDataSet.RecDataSet.IsUniCodeField[inColumn.FFieldName] = TRUE)then
                result := TRUE;
          end;//if...end!!
      end;//if...end!!
  VDataSet := nil;    
end;

function AnsiStrToUniCodeStr(const S: AnsiString): WideString;
begin
  Result := UTF8Decode(S);
end;

function UniCodeStrToAnsiStr(const S: WideString): AnsiString;
begin
  Result := UTF8Encode(S);
end;

function DBRunTrigger( DBObj:TAspFileDataSet
                       ;TriggerTime: TCallTriggerTiming
                       ;var ErrorMsg: string
                       ;var AbortYN:boolean):boolean;
var i:integer;
    noError,haveAbort:boolean;
begin
  if(DBObj = nil)then Exit;
  noError   := TRUE;
  haveAbort := FALSE;               
  for i := 0 to DBObj.FMethods.Count -1 do
    begin
      
      if(DBObj.FMethods.Process[i].BeATrigger = TRUE)then
      if(DBObj.FMethods.Process[i].TriggerTime = TriggerTime)then
        try
          noError := DBObj.FMethods.Process[i].ExecuteProc(ErrorMsg,haveAbort);
        except
          //KEEP debug haveAbort := TRUE;
        end;//try...except...end!!
      if(haveAbort = TRUE)then
        begin
          AbortYN := TRUE;
          Break;
        end;//if...end!!
    end;//for...i...end!!
end;

procedure RefreshAllDbControlDisplayData(inDataSource:TAspFileDataSource);
begin 
  if(inDataSource = nil)then Exit;
  if(inDataSource.DataSet = nil)then Exit;
  if(inDataSource.DataSet.Active = FALSE)then Exit;
  inDataSource.PostDisplayData;
end;

//TAspFileDbControlFieldName
function TAspFileDbControlFieldName.GetAttributes: TPropertyAttributes;
begin
  result := [paMultiselect,paValueList,paSortList];
end;

function TAspFileDbControlFieldName.GetEditLimit: integer;
begin
  result := 128;
end;

function TAspFileDbControlFieldName.GetValue: String;
begin
  result := GetStrValue;
end;

procedure TAspFileDbControlFieldName.GetValues(proc: TGetStrProc);
var i:integer;
    IsOpenSuccess:boolean;
    tmpAccessUser:string;
    PropertyOwnComp:TComponent;
    tmpFileDataSource:TAspFileDataSource;
begin
  tmpAccessUser := '';
  IsOpenSuccess := FALSE;
  PropertyOwnComp := TComponent(self.GetComponent(0));
  if(PropertyOwnComp.ClassType = TAspFileDBEdit)then
    tmpFileDataSource := TAspFileDBEdit(PropertyOwnComp).FDataSource;

  if(PropertyOwnComp.ClassType = TAspFileDBMemo)then
    tmpFileDataSource := TAspFileDBMemo(PropertyOwnComp).FDataSource;

  if(PropertyOwnComp.ClassType = TAspFileDBComboBox)then
    tmpFileDataSource := TAspFileDBComboBox(PropertyOwnComp).FDataSource;

  if(PropertyOwnComp.ClassType = TAspFileDBText)then
    tmpFileDataSource := TAspFileDBText(PropertyOwnComp).FDataSource;

  if(PropertyOwnComp.ClassType = TAspFileDBWEdit)then
    tmpFileDataSource := TAspFileDBWEdit(PropertyOwnComp).FDataSource;

  if(PropertyOwnComp.ClassType = TAspFileDBWText)then
    tmpFileDataSource := TAspFileDBWText(PropertyOwnComp).FDataSource;

  if(PropertyOwnComp.ClassType = TColumnItem)then
    tmpFileDataSource
      := TGridColumns(TColumnItem(PropertyOwnComp).GetOwner).FGrid.FDataSource;
  //--------------------------------------------------------------------
  if(tmpFileDataSource = nil)then
    begin
      PropertyOwnComp   := nil;
      tmpFileDataSource := nil;
      Exit;
    end;//if...end!!  
  if(trim(tmpFileDataSource.FDataSet.AccessFile) = '')
    and(trim(tmpFileDataSource.FDataSet.SchemaFileName) = '')then Exit;
  //--------------------------------------------------------------------
  if(tmpFileDataSource <> nil)then
  if(tmpFileDataSource.FDataSet <> nil)then
    begin
      if(tmpFileDataSource.FDataSet.Active = FALSE)then
         begin
           tmpAccessUser := tmpFileDataSource.FDataSet.AccessUser;
           tmpFileDataSource.FDataSet.AccessUser := 'Designer';
           tmpFileDataSource.FDataSet.Active := TRUE;
           IsOpenSuccess := TRUE;
         end;//if...end!!
      if(tmpFileDataSource.FDataSet.Active = TRUE)then
        begin
          for i := 0 to tmpFileDataSource.FDataSet.FDataSet.FieldCount-1 do
            Proc(tmpFileDataSource.FDataSet.FDataSet.FieldName[i]);
          //-----------------------------------------------------------------
          if(IsOpenSuccess = TRUE)then
            begin
              tmpFileDataSource.FDataSet.Active     := FALSE;
              tmpFileDataSource.FDataSet.AccessUser := tmpAccessUser;
            end;//if...end!!

        end;//if...end!!
    end;//if...end!!
  //--------------------------------------------------------------------
  PropertyOwnComp   := nil;
  tmpFileDataSource := nil;
end;

procedure TAspFileDbControlFieldName.SetValue(const value: String);
var selectField:string;
    FieldSize:integer;
    PropertyOwnComp:TComponent;
    tmpFileDataSource:TAspFileDataSource;
    tmpDataSet:TAspFileDataSet;
    tmpLabel:TLabel;
begin
  SetStrValue(value);
  if(trim(value) = '')then Exit;
  selectField := value;
  PropertyOwnComp := TComponent(self.GetComponent(0));
  if(PropertyOwnComp.ClassType = TAspFileDBEdit)then
    begin
      tmpFileDataSource := TAspFileDBEdit(PropertyOwnComp).FDataSource;
      if(tmpFileDataSource <> nil)then
      if(tmpFileDataSource.FDataSet <> nil)then
        begin
          if(tmpFileDataSource.FDataSet.FDataSet.IsKeyField[selectField] = TRUE)then
            TAspFileDBEdit(PropertyOwnComp).Color := $0076B4F8
          else TAspFileDBEdit(PropertyOwnComp).Color := clWhite;
          FieldSize := tmpFileDataSource.FDataSet.RecDataSet.FieldDataSize[selectField];
          TAspFileDBEdit(PropertyOwnComp).MaxLength := FieldSize;
          //----------------------------------------------------------------------------
          if(csDesigning in PropertyOwnComp.ComponentState)then
          if(MessageDlg( 'Auto Create Label(TLabel)??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
            begin
              tmpLabel := TLabel.Create(TAspFileDBEdit(PropertyOwnComp).Owner);
              tmpLabel.Name := 'Lb_'+FormatDateTime('ddhhnnss',Now);
              tmpLabel.Caption := InputBox( 'Label Content(TLabel.Caption)'
                                           ,'Input Label Content :',selectField);
              tmpLabel.Left    := TAspFileDBEdit(PropertyOwnComp).Left-tmpLabel.Width-24;
              tmpLabel.Top     := TAspFileDBEdit(PropertyOwnComp).Top + 4;
              tmpLabel.Parent  := TAspFileDBEdit(PropertyOwnComp).Parent;
              tmpLabel := nil;
            end;//if...end!!
           //----------------------------------------------------------------------------
        end;//if...end!!
    end;//if...end!!

  if(PropertyOwnComp.ClassType = TAspFileDBComboBox)then
    begin
      tmpFileDataSource := TAspFileDBComboBox(PropertyOwnComp).FDataSource;
      if(tmpFileDataSource <> nil)then
      if(tmpFileDataSource.FDataSet <> nil)then
        begin
          if(tmpFileDataSource.FDataSet.FDataSet.IsKeyField[selectField] = TRUE)then
            TAspFileDBComboBox(PropertyOwnComp).Color := $0076B4F8
          else TAspFileDBComboBox(PropertyOwnComp).Color := clWhite;
          FieldSize := tmpFileDataSource.FDataSet.RecDataSet.FieldDataSize[selectField];
          TAspFileDBComboBox(PropertyOwnComp).MaxLength := FieldSize;
          //----------------------------------------------------------------------------
          if(csDesigning in PropertyOwnComp.ComponentState)then
          if(MessageDlg( 'Auto Create Label(TLabel)??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
            begin
              tmpLabel := TLabel.Create(TAspFileDBComboBox(PropertyOwnComp).Owner);
              tmpLabel.Name := 'Lb_'+FormatDateTime('ddhhnnss',Now);
              tmpLabel.Caption := InputBox( 'Label Content(TLabel.Caption)'
                                           ,'Input Label Content :',selectField);
              tmpLabel.Left    := TAspFileDBComboBox(PropertyOwnComp).Left-tmpLabel.Width-24;
              tmpLabel.Top     := TAspFileDBComboBox(PropertyOwnComp).Top + 4;
              tmpLabel.Parent  := TAspFileDBComboBox(PropertyOwnComp).Parent;
              tmpLabel := nil;
            end;//if...end!!
           //----------------------------------------------------------------------------
        end;//if...end!!
    end;//if...end!!

  if(PropertyOwnComp.ClassType = TAspFileDBWEdit)then
    begin
      tmpFileDataSource := TAspFileDBWEdit(PropertyOwnComp).FDataSource;
      if(tmpFileDataSource <> nil)then
      if(tmpFileDataSource.FDataSet <> nil)then
        begin
          if(tmpFileDataSource.FDataSet.FDataSet.IsKeyField[selectField] = TRUE)then
            TAspFileDBWEdit(PropertyOwnComp).Color := $0076B4F8
          else TAspFileDBWEdit(PropertyOwnComp).Color := clWhite;
          FieldSize := tmpFileDataSource.FDataSet.RecDataSet.FieldDataSize[selectField];
          TAspFileDBWEdit(PropertyOwnComp).MaxLength := FieldSize;
          //----------------------------------------------------------------------------
          if(csDesigning in PropertyOwnComp.ComponentState)then
          if(MessageDlg( 'Auto Create Label(TLabel)??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
            begin
              tmpLabel := TLabel.Create(TAspFileDBWEdit(PropertyOwnComp).Owner);
              tmpLabel.Name := 'Lb_'+FormatDateTime('ddhhnnss',Now);
              tmpLabel.Caption := InputBox( 'Label Content(TLabel.Caption)'
                                           ,'Input Label Content :',selectField);
              tmpLabel.Left    := TAspFileDBWEdit(PropertyOwnComp).Left-tmpLabel.Width-24;
              tmpLabel.Top     := TAspFileDBWEdit(PropertyOwnComp).Top + 4;
              tmpLabel.Parent  := TAspFileDBWEdit(PropertyOwnComp).Parent;
              tmpLabel := nil;
            end;//if...end!!
           //----------------------------------------------------------------------------
        end;//if...end!!
    end;//if...end!!
  //----------------------------------------------------------------------------  
  if(PropertyOwnComp.ClassType = TAspFileDBMemo)then
    begin
      tmpFileDataSource := TAspFileDBMemo(PropertyOwnComp).FDataSource;
      if(tmpFileDataSource <> nil)then
      if(tmpFileDataSource.FDataSet <> nil)then
        begin
          if(tmpFileDataSource.FDataSet.FDataSet.IsKeyField[selectField] = TRUE)then
            TAspFileDBMemo(PropertyOwnComp).Color := $0076B4F8
          else TAspFileDBMemo(PropertyOwnComp).Color := clWhite;
          FieldSize := tmpFileDataSource.FDataSet.RecDataSet.FieldDataSize[selectField];
          TAspFileDBMemo(PropertyOwnComp).MaxLength := FieldSize;
          //----------------------------------------------------------------------------
          if(csDesigning in PropertyOwnComp.ComponentState)then
          if(MessageDlg( 'Auto Create Label(TLabel)??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
            begin
              tmpLabel := TLabel.Create(TAspFileDBMemo(PropertyOwnComp).Owner);
              tmpLabel.Name := 'Lb_'+FormatDateTime('ddhhnnss',Now);
              tmpLabel.Caption := InputBox( 'Label Content(TLabel.Caption)'
                                           ,'Input Label Content :',selectField);
              tmpLabel.Left    := TAspFileDBMemo(PropertyOwnComp).Left-tmpLabel.Width-24;
              tmpLabel.Top     := TAspFileDBMemo(PropertyOwnComp).Top + 4;
              tmpLabel.Parent  := TAspFileDBMemo(PropertyOwnComp).Parent;
              tmpLabel := nil;
            end;//if...end!!
           //----------------------------------------------------------------------------
        end;//if...end!!
    end;//if...end!!
  PropertyOwnComp   := nil;
  tmpFileDataSource := nil;
end;

//TAspFileDbFileName.
procedure TAspFileDbFileName.Edit;
var FileOpen: TOpenDialog;
    tmpFileDB:TAspFileDataSet;
    str,NameStr:string;
    i,id:integer;
begin
  tmpFileDB := TAspFileDataSet(self.GetComponent(0));
  FileOpen  := TOpenDialog.Create(Nil);
  FileOpen.Filename := GetValue;
  FileOpen.Filter := 'FileDB Files (*.XDB)|*.XDB|All Files (*.*)|*.*';
  FileOpen.Options := FileOpen.Options + [ofPathMustExist, ofFileMustExist];
  try
    if(FileOpen.Execute = TRUE)then
    if(trim(FileOpen.Filename) <> '')then
      begin
        tmpFileDB.SchemaFileName := '';
        tmpFileDB.AccessFile := FileOpen.Filename;
        SetValue(FileOpen.Filename);
      end;//if...end!!
  finally
    FileOpen.Free;
    tmpFileDB := nil;
  end;
end;

function TAspFileDbFileName.GetAttributes: TPropertyAttributes;
begin
  result := [paDialog, paRevertable];
end;

//TAspFileDbSchemaFileName.
procedure TAspFileDbSchemaFileName.Edit;
var FileOpen: TOpenDialog;
    tmpFileDB:TAspFileDataSet;
    str:string;
    i,id:integer;
begin
  tmpFileDB := TAspFileDataSet(self.GetComponent(0));
  if(tmpFileDB.Active = TRUE)then Exit;
  FileOpen := TOpenDialog.Create(Nil);
  FileOpen.Filename := GetValue;
  FileOpen.Filter := 'AspFileDB Schema Data (*.SFD)|*.SFD|All Files (*.*)|*.*';
  FileOpen.Options := FileOpen.Options + [ofPathMustExist, ofFileMustExist];
  FileOpen.Execute;
  try
    if(trim(FileOpen.Filename) <> '')then
      begin
        SetValue(FileOpen.Filename);
        tmpFileDB.SchemaFileName := FileOpen.Filename;
      end;//if...end!!
  finally
    FileOpen.Free;
    tmpFileDB := nil;
  end;
end;

function TAspFileDbSchemaFileName.GetAttributes: TPropertyAttributes;
begin
  result := [paDialog, paRevertable];
end;

//TWarpField.
Constructor TWarpField.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  self.FDataSet   := nil;
  self.FFieldName := '';
end;

function TWarpField.GetAsBoolean: boolean;
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
    result := self.FDataSet.RecDataSet.FieldByName[self.FFieldName];
end;

function TWarpField.GetAsFloat: double;
begin
  result := 0.0;
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
    result := self.FDataSet.RecDataSet.FieldByName[self.FFieldName];
end;

function TWarpField.GetAsInteger: integer;
var vstr:string;
begin
  result := 0;
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
    begin
      vstr := self.FDataSet.RecDataSet.FieldByName[self.FFieldName];
      result := StrToIntDef(vstr,0);
    end;//if...end!!
end;

function TWarpField.GetAsString: string;
begin
  result := '';
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
    result := self.FDataSet.RecDataSet.FieldByName[self.FFieldName];
end;

function TWarpField.GetAsUniCodeStr: WideString;
var rstr:string;
begin
  result := #0;
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
    begin
      rstr   := self.FDataSet.RecDataSet.FieldByName[self.FFieldName];
      result := AnsiStrToUniCodeStr(rstr);
    end;//if...end!!  
end;

function TWarpField.GetAsVariant: Variant;
begin
  result := '';
  if(self = nil)then Exit; 
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
    result := self.FDataSet.RecDataSet.FieldByName[self.FFieldName];
end;

procedure TWarpField.SetAsBoolean(const Value: boolean);
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet = nil)then Exit;
  //-------------------------------------------------------
  if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
  if(self.FDataSet.RecDataSet.DbState  = 'Insert')
    or(self.FDataSet.RecDataSet.DbState  = 'Edit')then
    if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
      self.FDataSet.RecDataSet.FieldByName[self.FFieldName] := Value;
end;

procedure TWarpField.SetAsFloat(const Value: double);
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet = nil)then Exit;
  //-------------------------------------------------------
  if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
  if(self.FDataSet.RecDataSet.DbState  = 'Insert')
    or(self.FDataSet.RecDataSet.DbState  = 'Edit')then
    if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
      self.FDataSet.RecDataSet.FieldByName[self.FFieldName] := Value;
end;

procedure TWarpField.SetAsInteger(const Value: integer);
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet = nil)then Exit;
  //-------------------------------------------------------
  if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
  if(self.FDataSet.RecDataSet.DbState  = 'Insert')
    or(self.FDataSet.RecDataSet.DbState  = 'Edit')then
    if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
      self.FDataSet.RecDataSet.FieldByName[self.FFieldName] := Value;
end;

procedure TWarpField.SetAsString(Value:string);
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet = nil)then Exit;
  //-------------------------------------------------------
  if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
  if(self.FDataSet.RecDataSet.DbState  = 'Insert')
    or(self.FDataSet.RecDataSet.DbState  = 'Edit')then
    if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
      self.FDataSet.RecDataSet.FieldByName[self.FFieldName] := Value;
end;

procedure TWarpField.SetAsUniCodeStr(const Value: WideString);
var instr:string;
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet = nil)then Exit;
  //-------------------------------------------------------
  if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
  if(self.FDataSet.RecDataSet.DbState  = 'Insert')
    or(self.FDataSet.RecDataSet.DbState  = 'Edit')then
    if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
      begin
        instr := UniCodeStrToansiStr(Value);
        self.FDataSet.RecDataSet.FieldByName[self.FFieldName] := instr;
      end;//if...end!!  
end;

procedure TWarpField.SetAsVariant(const Value: Variant);
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)or(self.FFieldName = '')then Exit;
  if(self.FDataSet.RecDataSet = nil)then Exit;
  //-------------------------------------------------------
  if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
  if(self.FDataSet.RecDataSet.DbState  = 'Insert')
    or(self.FDataSet.RecDataSet.DbState  = 'Edit')then
    if(self.FDataSet.RecDataSet.IsThisFieldExists(self.FFieldName) = TRUE)then
      self.FDataSet.RecDataSet.FieldByName[self.FFieldName] := Value;
end;

//TAspFileDataSet.
procedure InitDBMethod(DestDs:TAspFileDataSet);
begin
  //Debug !! if(DestDs.FDataSet.InitAspFileDBMethod(DestDs.FMethods) = FALSE)then
  //Debug !!   ShowMessage('Method Maping Fail !!')
  //Debug !!else
  //Debug !! ShowMessage('Method Maping Success !!');
  DestDs.FDataSet.InitAspFileDBMethod(DestDs.FMethods);
end;

function AspFileDBOBJInitialize; external ole32DLL name 'CoInitialize';

Constructor TAspFileDataSet.Create(AOwner: TComponent);
begin
  AspFileDBOBJInitialize(nil);
  inherited Create(AOwner);
  self.FDataSet := CoFileDataSet.Create;
  self.FFilterCommand := TStringList.Create;
  self.FWarpFieldList := TStringList.Create;
  //------------------------------------------------------------------
  self.FDataSet.SetFAfterRecDataSetDataChange(self.DoAfterDataChange);
  self.FDataSet.SetFInitDataControlData(self.DoInitDataControlData);
  self.FDataSet.SetFDBStateChange(self.DoAfterDBStateChange);
  self.FDataSet.SetFUseFilterChange(self.DoAfterFilterChange);
  //------------------------------------------------------------------
  self.FMethods := TDbMethods.Create(self,TDbProcItem);
  //------------------------------------------------------------------
  self.FDataSet.CompressData := FALSE;
  self.FDataSet.EncryptData  := FALSE;
end;

Destructor TAspFileDataSet.Destroy;
begin
  self.FDataSet := nil;
  while(self.FWarpFieldList.Count > 0)do
    begin
      TWarpField(self.FWarpFieldList.Objects[0]).FDataSet := nil;
      TWarpField(self.FWarpFieldList.Objects[0]).Free;
      self.FWarpFieldList.Delete(0);
    end;//while...end!!
  //--------------------------------------------------------------  
  if(self.FFilterCommand <> nil)then
    begin
      self.FFilterCommand.Clear;
      self.FFilterCommand.Free;
    end;//if...end!!
  self.FMethods.Free;  
  inherited Destroy;
end;

procedure TAspFileDataSet.Notification(AComponent: TComponent;
  Operation: TOperation);
var IsOpened:OleVariant;
    i:integer;
begin
  inherited;
  if(Operation <> OpRemove)then
  if(csLoading in self.ComponentState)then
  if(self.FFilterCommand <> nil)then
  if(self.IsDesignTimeOpened = TRUE)
     and(self.RecDataSet.IsOpened = FALSE)then
    begin
      self.FDataSet.Open(IsOpened);
      InitDBMethod(self);
      if(self.FDataSet.IsOpened = TRUE)then
        begin
          self.FActive := TRUE;
          //-------------------------------------------------------------
          if(self.FFilterCommand.Count > 0)then
            begin
              self.RecDataSet.UseFilter := FALSE;
              self.RecDataSet.DeleteAllDataFilters;
              for i := 0 to self.FFilterCommand.Count-1 do
                self.RecDataSet
                  .AddDataFilterWithCommandStr(self.FFilterCommand[i]);
              self.RecDataSet.UseFilter := TRUE;
            end;//if...end!!
           //---------------------------------------------------------
           if(self.FDataSet.AccessUser = 'Explorer')then
             self.FDataSet.SaveSchema(self.AccessFile);
           //---------------------------------------------------------
           if(self.FDataSet.RecordCount > 0)
             and(self.InternalDataSource <> nil)then
             self.InternalDataSource.PostDisplayData;
        end //if...end!!
      else self.FActive := FALSE;
    end;//if...end!!
end;

procedure TAspFileDataSet.DoAfterDataChange;
begin
  //when The MetaData Had Been Init To RecSet's Fields
  // this Event Will Be Trigger !!
  if(self.InternalDataSource <> nil)then
    begin
      if(self.RecDataSet.OrderByDesc = TRUE)
        or(self.RecDataSet.OrderByDesc = FALSE)
        or(self.RecDataSet.UseFilter = TRUE)then
        begin
          DoAfterFilterChange;
          self.InternalDataSource.RefreshNavigator;
        end;//if...end!!
      self.InternalDataSource.PostDisplayData;
    end;//if...end!!
end;

procedure TAspFileDataSet.DoAfterDbStateChange;
begin
  if(self.InternalDataSource <> nil)then
    begin
      self.InternalDataSource.RefreshNavigator;
      self.InternalDataSource.RefreshDBGrid;
    end;//if...end!!
end;

procedure TAspFileDataSet.DoAfterFilterChange;
begin
  self.InternalDataSource
      .RefreshDBGridParamsWhenDataFilterChanged;
end;

procedure TAspFileDataSet.DoInitDataControlData;
var i,j,CtrlCount :integer;
    tmpEdit  :TAspFileDBEdit;
    tmpMemo  :TAspFileDBMemo;
    tmpEditW :TAspFileDBWEdit;
    tmpGrid  :TAspFileDBGrid;
    tmpCombo :TAspFileDBComboBox;
    FieldStr,OldValueStr,ValueStr:string;
    OldValueStrW,ValueStrW:WideString;
begin
  if(self.InternalDataSource <> nil)then
    begin
      CtrlCount := self.InternalDataSource.FDataControls.Count;
      if(self.FDataSet.DBState = 'Insert')then
        begin
          for i := 0 to CtrlCount-1 do
            begin
              ValueStr := '';  FieldStr := '';  OldValueStr := '';
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBEdit)then
                begin
                  tmpEdit  := TAspFileDBEdit(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpEdit.DataField;
                  ValueStr := tmpEdit.Text;
                  if(trim(FieldStr) <> '')then
                    if(trim(ValueStr) <> '')then
                      begin
                        OldValueStr := '';
                        if(Assigned(tmpEdit.FBeforeSetData))then
                          tmpEdit.FBeforeSetData(tmpEdit,OldValueStr,ValueStr);

                        self.FDataSet.FieldByName[FieldStr] := ValueStr;

                        if(Assigned(tmpEdit.FAfterSetData))then
                          tmpEdit.FAfterSetData(tmpEdit,ValueStr);
                      end; //if...end!!
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBMemo)then
                begin                       
                  tmpMemo  := TAspFileDBMemo(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpMemo.DataField;
                  ValueStr := tmpMemo.Lines.CommaText;
                  if(trim(FieldStr) <> '')then
                    if(trim(ValueStr) <> '')then
                      begin
                        OldValueStr := '';
                        if(Assigned(tmpMemo.FBeforeSetData))then
                          tmpMemo.FBeforeSetData(tmpMemo,OldValueStr,ValueStr);

                        self.FDataSet.FieldByName[FieldStr] := ValueStr;

                        if(Assigned(tmpMemo.FAfterSetData))then
                          tmpMemo.FAfterSetData(tmpMemo,ValueStr);
                      end; //if...end!!
                  tmpMemo := nil;    
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBComboBox)then
                begin
                  tmpCombo := TAspFileDBComboBox(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpCombo.DataField;
                  ValueStr := tmpCombo.Text;
                  if(trim(FieldStr) <> '')then
                    if(trim(ValueStr) <> '')then
                      begin
                        OldValueStr := '';
                        if(Assigned(tmpCombo.FBeforeSetData))then
                          tmpCombo.FBeforeSetData(tmpCombo,OldValueStr,ValueStr);

                        self.FDataSet.FieldByName[FieldStr] := ValueStr;

                        if(Assigned(tmpCombo.FAfterSetData))then
                          tmpCombo.FAfterSetData(tmpCombo,ValueStr);
                      end; //if...end!!
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBWEdit)then
                begin
                  tmpEditW := TAspFileDBWEdit(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpEditW.DataField;
                  ValueStrW:= tmpEditW.Text;
                  if(trim(FieldStr) <> '')then
                    if(trim(ValueStrW) <> '')then
                      begin                                      
                        OldValueStrW := #0;
                        if(Assigned(tmpEditW.FBeforeSetData))then
                          tmpEditW.FBeforeSetData(tmpEditW,OldValueStrW,ValueStrW);

                        self.FDataSet.FieldByNameW[FieldStr] := ValueStrW;

                        if(Assigned(tmpEditW.FAfterSetData))then
                          tmpEditW.FAfterSetData(tmpEditW,ValueStrW);
                      end; //if...end!!
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBGrid)then
                begin
                  tmpGrid := TAspFileDBGrid(self.InternalDataSource
                                                .FDataControls.Objects[i]);
                  if(tmpGrid.IsReadOnly = FALSE)then
                  if(tmpGrid.CurrentEditRow >= 0)then
                    begin
                      for j := 0 to tmpGrid.Columns.Count-1 do
                        begin
                          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[j]) = FALSE)then
                            begin
                              ValueStr := tmpGrid.Columns.Columns[j]
                                                 .DataCells[tmpGrid.CurrentEditRow].AsString;
                              FieldStr := tmpGrid.Columns.Columns[j].DataField;
                              if(trim(FieldStr) <> '')then
                                if(trim(ValueStr) <> '')then
                                  self.FDataSet.FieldByName[FieldStr] := ValueStr;
                            end//if...end!!
                          else
                            begin
                              ValueStrW := tmpGrid.Columns.Columns[j]
                                                  .DataCellsW[tmpGrid.CurrentEditRow].AsUniCodeStr;
                              FieldStr := tmpGrid.Columns.Columns[j].DataField;
                              if(trim(FieldStr) <> '')then
                              if(trim(ValueStrW) <> '')then
                                self.FDataSet.FieldByNameW[FieldStr] := ValueStrW;
                            end;//else...end!!
                        end;//for...j...end!!
                      tmpGrid.CurrentEditRow := -1;
                    end; //if...end!!
                end;//if...end!!
              //----------------------------------------------------------------------------
            end;//for...i...end!!
        end;//if...Insert...end!!
      //====================================================================
      if(self.FDataSet.DbState = 'Edit')then
        begin
          for i := 0 to CtrlCount-1 do
            begin
              ValueStr := '';
              FieldStr := '';
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBEdit)then
                begin
                  tmpEdit  := TAspFileDBEdit(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpEdit.DataField;
                  ValueStr := tmpEdit.Text;
                  if(trim(FieldStr) <> '')then
                  if(self.FDataSet.IsKeyField[FieldStr] = FALSE)then
                    begin
                      OldValueStr := self.FDataSet.FieldByName[FieldStr];
                     if(Assigned(tmpEdit.FBeforeSetData))then
                       tmpEdit.FBeforeSetData(tmpEdit,OldValueStr,ValueStr);

                     self.FDataSet.FieldByName[FieldStr] := ValueStr;

                     if(Assigned(tmpEdit.FAfterSetData))then
                       tmpEdit.FAfterSetData(tmpEdit,ValueStr);
                    end;//if...end!!  
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBMemo)then
                begin
                  tmpMemo  := TAspFileDBMemo(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpMemo.DataField;
                  ValueStr := tmpMemo.Text;
                  if(trim(FieldStr) <> '')then
                  if(self.FDataSet.IsKeyField[FieldStr] = FALSE)then
                    begin
                      OldValueStr := self.FDataSet.FieldByName[FieldStr];
                     if(Assigned(tmpMemo.FBeforeSetData))then
                       tmpMemo.FBeforeSetData(tmpMemo,OldValueStr,ValueStr);

                     self.FDataSet.FieldByName[FieldStr] := ValueStr;

                     if(Assigned(tmpMemo.FAfterSetData))then
                       tmpMemo.FAfterSetData(tmpEdit,ValueStr);
                    end;//if...end!!
                  tmpMemo := nil;   
                end;//if...end!!  
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBComboBox)then
                begin
                  tmpCombo := TAspFileDBComboBox(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpCombo.DataField;
                  ValueStr := tmpCombo.Text;
                  if(trim(FieldStr) <> '')then
                  if(self.FDataSet.IsKeyField[FieldStr] = FALSE)then
                    begin
                      OldValueStr := self.FDataSet.FieldByName[FieldStr];
                     if(Assigned(tmpCombo.FBeforeSetData))then
                       tmpCombo.FBeforeSetData(tmpCombo,OldValueStr,ValueStr);

                     self.FDataSet.FieldByName[FieldStr] := ValueStr;

                     if(Assigned(tmpCombo.FAfterSetData))then
                       tmpCombo.FAfterSetData(tmpCombo,ValueStr);
                    end;//if...end!!  
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBWEdit)then
                begin
                  tmpEditW := TAspFileDBWEdit(self.InternalDataSource.FDataControls.Objects[i]);
                  FieldStr := tmpEditW.DataField;
                  ValueStrW:= tmpEditW.Text;
                  if(trim(FieldStr) <> '')then
                  if(self.FDataSet.IsKeyField[FieldStr] = FALSE)then
                    begin
                      OldValueStrW := self.FDataSet.FieldByNameW[FieldStr];
                     if(Assigned(tmpEditW.FBeforeSetData))then
                       tmpEditW.FBeforeSetData(tmpEditW,OldValueStrW,ValueStrW);

                     self.FDataSet.FieldByNameW[FieldStr] := ValueStrW;

                     if(Assigned(tmpEditW.FAfterSetData))then
                       tmpEditW.FAfterSetData(tmpEditW,ValueStrW);
                    end;//if...end!!  
                end;//if...end!!
              //----------------------------------------------------------------------------
              if(TComponent(self.InternalDataSource.FDataControls
                                .Objects[i]).ClassType = TAspFileDBGrid)then
                begin
                  tmpGrid := TAspFileDBGrid(self.InternalDataSource
                                                .FDataControls.Objects[i]);
                  if(tmpGrid.IsReadOnly = FALSE)
                    and(tmpGrid.CurrentEditRow >= 0)then
                    begin
                      for j := 0 to tmpGrid.Columns.Count-1 do
                        begin
                          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[j]) = FALSE)then
                            begin
                              if(tmpGrid.Columns.Columns[j]
                                    .DataCells[tmpGrid.CurrentEditRow].IsModify = TRUE)then
                                begin
                                  ValueStr := tmpGrid.Columns.Columns[j]
                                                 .DataCells[tmpGrid.CurrentEditRow].AsString;
                                  FieldStr := tmpGrid.Columns.Columns[j].DataField;
                                  if(trim(FieldStr) <> '')then
                                  if(self.FDataSet.IsKeyField[FieldStr] = FALSE)then
                                    self.FDataSet.FieldByName[FieldStr] := ValueStr;
                                end;//if...end!!
                            end //if...end!!
                          else
                            begin
                              if(tmpGrid.Columns.Columns[j]
                                    .DataCellsW[tmpGrid.CurrentEditRow].IsModify = TRUE)then
                                begin
                                  ValueStrW := tmpGrid.Columns.Columns[j]
                                                 .DataCellsW[tmpGrid.CurrentEditRow].AsUniCodeStr;
                                  FieldStr := tmpGrid.Columns.Columns[j].DataField;
                                  if(trim(FieldStr) <> '')then
                                  if(self.FDataSet.IsKeyField[FieldStr] = FALSE)then
                                    self.FDataSet.FieldByNameW[FieldStr] := ValueStrW;
                                end;//if...end!!
                            end;//else...end!!
                        end;//for...j...end!!
                      tmpGrid.CurrentEditRow := -1;
                    end;//if...end!!
                  tmpGrid := nil;
                end;//if...end!!
              //----------------------------------------------------------------------------
            end;//for...i...end!!
        end;//if...Insert...end!!
      //====================================================================
    end;//if...end!!
  tmpEdit := nil;
  tmpGrid := nil;
end;

procedure TAspFileDataSet.SetFAccessFileName(const Value:TAspFileDbFileStr);
begin
  FAccessFileName := Value;
  self.FDataSet.AccessFile := FAccessFileName;
end;

procedure TAspFileDataSet.setFSchemaFileName(const Value:TAspFileDbSchemaFileStr);
begin
  FSchemaFileName := Value;
  self.FDataSet.SetSchemaFileName(FSchemaFileName);
end;

procedure TAspFileDataSet.SetFAccessUserName(const Value: string);
begin
  FAccessUserName := Value;
  self.FDataSet.AccessUser := FAccessUserName;
end;

procedure TAspFileDataSet.SetFReadOnly(const Value: boolean);
begin
  if(self.FDataSet <> nil)then
  if(self.Active = FALSE)then
    begin
      FReadOnly := Value;
      self.FDataSet.IsReadOnly := FReadOnly;
    end;//if...end!!
end;

procedure TAspFileDataSet.SetFActive(const Value: boolean);
var i:integer;
    IsOpened:OleVariant;
    tmpField:TWarpField;
begin
  IsDesignTimeOpened := FALSE;
  if(self.FDataSet <> nil)then
    begin
      case Value of
        TRUE :begin
                if(csLoading in self.ComponentState)then
                  IsDesignTimeOpened := TRUE
                else
                  begin
                    self.FDataSet.Open(IsOpened);
                    InitDBMethod(self);
                    if(self.FDataSet.IsOpened = TRUE)then
                      begin
                        self.FActive := TRUE;
                        if(self.FDataSet.AccessUser = 'Explorer')then
                          self.FDataSet.SaveSchema(self.AccessFile);
                        //----------------------------------------------
                        if(self.FDataSet.RecordCount > 0)then
                          if(self.InternalDataSource <> nil)then
                            self.InternalDataSource.PostDisplayData;
                        self.InternalDataSource.RefreshNavigator;
                        self.InternalDataSource.RefreshDBGrid;
                        //----------------------------------------------
                        if(self.InternalDataSource = nil)then
                          self.Notification(nil,OpInsert);
                        //----------------------------------------------
                        if(self.FWarpFieldList.Count = 0)then
                        for i := 0 to self.RecDataSet.FieldCount-1 do
                          begin
                            tmpField := TWarpField.Create(nil);
                            tmpField.FFieldName := self.RecDataSet.FieldName[i];
                            tmpField.FDataSet   := self;
                            self.FWarpFieldList
                                .AddObject(tmpField.FFieldName,tmpField);
                            tmpField := nil;
                          end;//for...i...end!!
                        //--------------------------------------------------------------
                        if(self.FFilterCommand.Count > 0)then
                          begin
                            self.RecDataSet.UseFilter := FALSE;
                            self.RecDataSet.DeleteAllDataFilters;
                            for i := 0 to self.FFilterCommand.Count-1 do
                              self.RecDataSet
                                  .AddDataFilterWithCommandStr(self.FFilterCommand[i]);
                            self.RecDataSet.UseFilter := TRUE;
                          end;//if...end!!
                        //--------------------------------------------------------------
                      end //if...end!!
                    else self.FActive := FALSE;
                  end;//if...else...end!!
              end;
        FALSE:begin
                self.FDataSet.Close;
                self.FActive := FALSE;
                self.FDataSet.UseFilter := FALSE;
                self.FDataSet.DeleteAllDataFilters;
                if(self.InternalDataSource <> nil)then
                  begin
                    self.InternalDataSource.PostDisplayData;
                    self.InternalDataSource
                        .RefreshDBGridParamsWhenDataFilterChanged;
                  end;
                //-------------------------------------------------
                while(self.FWarpFieldList.Count > 0)do
                  begin
                    TWarpField(self.FWarpFieldList.Objects[0]).FDataSet := nil;
                    TWarpField(self.FWarpFieldList.Objects[0]).Free;
                    self.FWarpFieldList.Delete(0);
                  end;//while...end!!
              end;
      end;//case...end!!
    end;//if...end!!
end;

procedure TAspFileDataSet.SetFDataSet(const Value: IFileDataSet);
begin
  FDataSet := Value;
end;

function TAspFileDataSet.GetFFilterCommand: TStringList;
begin
  result := self.FFilterCommand;
end;

procedure TAspFileDataSet.SetFFilterCommand(const Value: TStringList);
begin
  self.FFilterCommand.BeginUpdate;
  self.FFilterCommand.Assign(Value);
  self.FFilterCommand.EndUpdate;
end;

//TAspFileDataSource.
Constructor TAspFileDataSource.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.FDataControls := TStringList.Create;
end;

Destructor TAspFileDataSource.Destroy;
var i:integer;
begin
  if(self.FDataControls <> nil)then
    begin
      for i := 0 to self.FDataControls.Count-1 do
        self.FDataControls.Objects[i] := nil;
      self.FDataControls.Free;
    end;//if...end!!
  inherited Destroy;
end;

procedure TAspFileDataSource.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSet)then self.FDataSet := nil;
end;

function TAspFileDataSource.CtrlByName(inName: string): TComponent;
var i:integer;
begin
  result := nil;
  if(self.FDataControls.Count <= 0)then Exit;
  for i := 0 to self.FDataControls.Count-1 do
    begin
      if(TComponent(self.FDataControls.Objects[i]).Name = inName)then
        begin
          result := TComponent(self.FDataControls.Objects[i]);
          Break;
        end;//if...end!!
    end;//for...i...end!!
end;

procedure TAspFileDataSource.AddNewDBEdit(inDbEdit: TAspFileDBEdit);
begin
  if(inDbEdit = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbEdit) < 0)then
    self.FDataControls.AddObject(inDbEdit.Name,inDbEdit);
end;

procedure TAspFileDataSource.RemoveDBEdit(OutDbEdit: TAspFileDBEdit);
var id:integer;
begin
  if(OutDbEdit = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbEdit);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBMemo(inDbMemo: TAspFileDBMemo);
begin
  if(inDbMemo = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbMemo) < 0)then
    self.FDataControls.AddObject(inDbMemo.Name,inDbMemo);
end;

procedure TAspFileDataSource.RemoveDBMemo(OutDbMemo: TAspFileDBMemo);
var id:integer;
begin
  if(OutDbMemo = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbMemo);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBComboBox(inDbEdit: TAspFileDBComboBox);
begin
  if(inDbEdit = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbEdit) < 0)then
    self.FDataControls.AddObject(inDbEdit.Name,inDbEdit);
end;

procedure TAspFileDataSource.RemoveDBComboBox(OutDbEdit: TAspFileDBComboBox);
var id:integer;
begin
  if(OutDbEdit = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbEdit);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBWEdit(inDbEdit: TAspFileDBWEdit);
begin
  if(inDbEdit = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbEdit) < 0)then
    self.FDataControls.AddObject(inDbEdit.Name,inDbEdit);
end;

procedure TAspFileDataSource.RemoveDBWEdit(OutDbEdit: TAspFileDBWEdit);
var id:integer;
begin
  if(OutDbEdit = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbEdit);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBText(inDbText: TAspFileDBText);
begin
  if(inDbText = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbText) < 0)then
    self.FDataControls.AddObject(inDbText.Name,inDbText);
end;

procedure TAspFileDataSource.RemoveDBText(OutDbText: TAspFileDBText);
var id:integer;
begin
  if(OutDbText = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbText);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBWText(inDbText: TAspFileDBWText);
begin
  if(inDbText = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbText) < 0)then
    self.FDataControls.AddObject(inDbText.Name,inDbText);
end;

procedure TAspFileDataSource.RemoveDBWText(OutDbText: TAspFileDBWText);
var id:integer;
begin
  if(OutDbText = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbText);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBNavigator(inDbNav: TAspFileDBNavigator);
begin
  if(inDbNav = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbNav) < 0)then
    self.FDataControls.AddObject(inDbNav.Name,inDbNav);
end;

procedure TAspFileDataSource.RemoveDBNavigator(OutDbNav: TAspFileDBNavigator);
var id:integer;
begin
  if(OutDbNav = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbNav);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.AddNewDBGrid(inDbGrid: TAspFileDBGrid);
begin
  if(inDbGrid = nil)then Exit;
  if(self.FDataControls.IndexOfObject(inDbGrid) < 0)then
    self.FDataControls.AddObject(inDbGrid.Name,inDbGrid);
end;

procedure TAspFileDataSource.RemoveDBGrid(OutDbGrid: TAspFileDBgrid);
var id:integer;
begin
  if(OutDbGrid = nil)then Exit;
  id := self.FDataControls.IndexOfObject(OutDbGrid);
  self.FDataControls.Objects[id] := nil;
  self.FDataControls.Delete(id);
end;

procedure TAspFileDataSource.PostDisplayData;

var i,j,k,l,LoopRowCount,FocusColWhenInsert:integer;
    RecPos,NewRow,OldRow:integer;
    GridFirstDataNodePosition:integer;
    GridDisplayDataStartRowNo:integer;
    Fieldstr,ValueStr:string;
    ValueStrW:WideString;
    tmpEdit:TAspFileDBEdit;
    tmpMemo:TAspFileDBMemo;
    tmpCombo:TAspFileDBComboBox;
    tmpText:TAspFileDBText;
    tmpEditW:TAspFileDBWEdit;
    tmpTextW:TAspFileDBWText;
    tmpGrid:TAspFileDBGrid;
    msg:string;
    AbortYN,PostGridDataWhenDataSetFirstOpen:boolean;
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)then Exit;
  if(self.FDataSet.RecDataSet.DbState = 'Edit')then Exit;
  DBRunTrigger(self.FDataSet,trgBeforeScroll,msg,AbortYN);
  for i := 0 to self.FDataControls.Count-1 do
    begin
      Fieldstr := '';
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBEdit)then
        begin
          tmpEdit := TAspFileDBEdit(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            begin
              tmpEdit.Value := '';
              tmpEdit.Text  := '';
            end
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                Fieldstr := tmpEdit.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                    if(assigned(tmpEdit.FBeforeGetData))then
                      tmpEdit.FBeforeGetData(tmpEdit,ValueStr);
                    tmpEdit.Value := ValueStr;
                    tmpEdit.Text  := ValueStr;
                    if(assigned(tmpEdit.FAfterGetData))then
                      tmpEdit.FAfterGetData(tmpEdit,ValueStr);
                  end;//if...end!!
              end//if...end!!
            else tmpEdit.Text := '';
          tmpEdit := nil;
        end;//if...end!!
      //------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBMemo)then
        begin
          tmpMemo := TAspFileDBMemo(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            begin
              tmpMemo.Value.Clear;
              tmpMemo.Lines.Clear;
            end
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                tmpMemo.Value.Clear;
                tmpMemo.Lines.Clear;
                Fieldstr := tmpMemo.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                    if(assigned(tmpMemo.FBeforeGetData))then
                      tmpMemo.FBeforeGetData(tmpMemo,ValueStr);
                    tmpMemo.Value.Add(ValueStr);
                    tmpMemo.Lines.Add(ValueStr);
                    if(assigned(tmpMemo.FAfterGetData))then
                      tmpMemo.FAfterGetData(tmpMemo,ValueStr);
                  end;//if...end!!
              end//if...end!!
            else tmpMemo.Lines.Clear;
          tmpMemo := nil;
        end;//if...end!!
      //------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBComboBox)then
        begin
          tmpCombo := TAspFileDBComboBox(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpCombo.Text := ''
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                Fieldstr := tmpCombo.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                    if(assigned(tmpCombo.FBeforeGetData))then
                      tmpCombo.FBeforeGetData(tmpCombo,ValueStr);
                    //old tmpCombo.Text := ValueStr;
                    for j := 0 to tmpCombo.Items.Count-1 do
                      begin
                        k := 0;
                        k := Pos(ValueStr,tmpCombo.Items[j]);
                        if(k = 1)then
                          begin
                            tmpCombo.ItemIndex := j;
                            Break;
                          end//if...end!!
                        else ///old tmpCombo.ItemIndex := -1;
                          tmpCombo.Text := ValueStr;
                      end;//for...j...end!!
                    if(assigned(tmpCombo.FAfterGetData))then
                      tmpCombo.FAfterGetData(tmpCombo,ValueStr);
                  end;//if...end!!
              end//if...end!!
            else tmpCombo.Text := '';
          tmpCombo := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBWEdit)then
        begin
          tmpEditW := TAspFileDBWEdit(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpEditW.Text := #0
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                Fieldstr := tmpEditW.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStrW := self.FDataSet.RecDataSet.FieldByNameW[Fieldstr];
                    if(assigned(tmpEditW.FBeforeGetData))then
                      tmpEditW.FBeforeGetData(tmpEditW,ValueStrW);
                    tmpEditW.Text := ValueStrW;
                    if(assigned(tmpEditW.FAfterGetData))then
                      tmpEditW.FAfterGetData(tmpEditW,ValueStrW);
                  end;//if...end!!
              end//if...end!!
            else tmpEditW.Text := #0;
          tmpEditW := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBText)then
        begin
          tmpText := TAspFileDBText(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpText.Caption := ''
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                Fieldstr := tmpText.DataField;
                if(trim(Fieldstr) <> '')then
                  tmpText.Caption := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
              end//if...end!!
            else tmpText.Caption := tmpText.Name;
          tmpText := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBWText)then
        begin
          tmpTextW := TAspFileDBWText(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpTextW.Caption := #0
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                Fieldstr := tmpText.DataField;
                if(trim(Fieldstr) <> '')then
                  ValueStrW := self.FDataSet.RecDataSet.FieldByNameW[Fieldstr];
                  tmpTextW.Caption := ValueStrW;
              end//if...end!!
            else tmpTextW.Caption := tmpTextW.Name;
          tmpTextW := nil;
        end;//if...end!!
      //****************************************************************************
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
        begin
          PostGridDataWhenDataSetFirstOpen := FALSE;
          tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState <> 'Insert')then
            begin
              if(tmpGrid.tmpBtn    .Visible = TRUE)then tmpGrid.tmpBtn   .Visible := FALSE;
              if(tmpGrid.tmpEdit   .Visible = TRUE)then tmpGrid.tmpEdit  .Visible := FALSE;
              if(tmpGrid.tmpCombo  .Visible = TRUE)then tmpGrid.tmpCombo .Visible := FALSE;
              if(tmpGrid.tmpBtnW   .Visible = TRUE)then tmpGrid.tmpBtnW  .Visible := FALSE;
              if(tmpGrid.tmpEditW  .Visible = TRUE)then tmpGrid.tmpEditW .Visible := FALSE;
              if(tmpGrid.tmpComboW .Visible = TRUE)then tmpGrid.tmpComboW.Visible := FALSE;
              if(tmpGrid.tmpChkBox .Visible = TRUE)then tmpGrid.tmpChkBox.Visible := FALSE;
              if(tmpGrid.tmpMemo   .Visible = TRUE)then tmpGrid.tmpMemo  .Visible := FALSE;
              if(tmpGrid.tmpChkBoxW.Visible = TRUE)then tmpGrid.tmpChkBoxW.Visible := FALSE;
              if(tmpGrid.tmpMemoW  .Visible = TRUE)then tmpGrid.tmpMemoW .Visible := FALSE;
              if(tmpGrid.tmpBtnW   .Visible = TRUE)then tmpGrid.tmpBtnW  .Visible := FALSE;
            end;//if...end!!
          //----------------------------------------------------------------------------
          if(tmpGrid.Columns.Count = 0)then Continue;
          if(tmpGrid.BreakDataRefreshLink = TRUE)then
            begin
              tmpGrid := nil; Continue;
            end;//if...end!!
          //=============================================================================
          if(tmpGrid.IsReadOnly = TRUE)
            and(self.FDataSet.RecDataSet.DbState = 'Insert')then
            begin
              tmpGrid := nil; Continue;
            end;//if...end!!
          //=============================================================================
          if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
            begin
              RecPos := self.FDataSet.RecDataSet.GetBookMark;
              if(Self.FDataSet.RecDataSet.RecordCount = 0)then
                begin
                  if(self.FDataSet.RecDataSet.DbState = 'Browse')then
                    begin
                      tmpGrid.RowCount := 0;
                    end;//if...end!!
                end//if...end!!
              else    //RecordCount > 0
                begin
                  tmpGrid.FScrollPanel.Min := 1;
                  tmpGrid.FScrollPanel.Max := Self.FDataSet.RecDataSet.RecordCount;
                  if(self.FDataSet.RecordCount >= tmpGrid.FMaxGridRow)then
                    begin
                      if(self.FDataSet.IsDetailDB = TRUE)then
                        begin
                          tmpGrid.RowCount := 1;
                        end//if...end!!
                      else
                        begin
                          tmpGrid.RowCount := tmpGrid.FMaxGridRow;
                        end;//else...end!!
                      //-------------------------------------------------
                      if(self.FDataSet.RecDataSet.DbState = 'Insert')then
                        begin
                          FocusColWhenInsert := 0;
                          if(tmpGrid.Columns.Columns[FocusColWhenInsert].FFieldName = '')then
                            FocusColWhenInsert := FocusColWhenInsert+1;
                          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[FocusColWhenInsert]) = FALSE)then
                            tmpGrid.Columns.Columns[FocusColWhenInsert].DataCells[0].DataCellSetFocus(FALSE)
                          else tmpGrid.Columns.Columns[FocusColWhenInsert].DataCellsW[0].DataCellSetFocus(FALSE);
                        end;//if...end!!
                    end//if...end!!
                  else //if...self.FDataSet.RecordCount < tmpGrid.FMaxGridRow !!
                    begin
                      if(self.FDataSet.RecDataSet.DbState = 'Browse')then
                        begin
                          if(tmpGrid.RowCount <> self.FDataSet.RecDataSet.RecordCount)then
                            begin
                              if(tmpGrid.IsSelectUniCodeDataCell = FALSE)then
                                begin
                                  if(tmpGrid.SelectedCell <> nil)then
                                    if(tmpGrid.SelectedCell.Row > self.FDataSet.RecDataSet.RecordCount)then
                                      tmpGrid.SelectedCell := tmpGrid.Columns.Columns[0].DataCells[0];
                                end//if...end!!
                              else
                                begin
                                  if(tmpGrid.SelectedCellW <> nil)then
                                    if(tmpGrid.SelectedCellW.Row > self.FDataSet.RecDataSet.RecordCount)then
                                      tmpGrid.SelectedCellW := tmpGrid.Columns.Columns[0].DataCellsW[0];
                                end;//else...end!!
                              tmpGrid.RowCount := self.FDataSet.RecDataSet.RecordCount;
                            end;//if...end!!
                        end;//if...end!!
                    end;//else...end!!
                end;
              //------------------------------------------------------------
              if(tmpGrid.GridTopDataPos > 0)then
                begin
                  self.FDataSet.RecDataSet.CursorGoToBookMark(tmpGrid.GridTopDataPos);
                  GridFirstDataNodePosition := tmpGrid.GridTopDataPos;
                end
              else
                begin
                  if(tmpGrid.GridMoveDataCursor = TRUE)then
                    begin
                      if(tmpGrid.IsCursorDownChangeGridPostData = TRUE)then
                        begin
                          for j := 1 to tmpGrid.RowCount-1 do
                            self.FDataSet.RecDataSet.CursorPriorRecord;
                          GridFirstDataNodePosition := self.FDataSet.RecDataSet.GetBookMark;
                          tmpGrid.GridTopDataPos := GridFirstDataNodePosition;
                          tmpGrid.IsCursorDownChangeGridPostData := FALSE;
                        end; //if...end!!
                      //--------------------------------------------------------------------
                      if(tmpGrid.IsCursorUPChangeGridPostData = TRUE)then
                        begin
                          GridFirstDataNodePosition := self.FDataSet.RecDataSet.GetBookMark;
                          tmpGrid.GridTopDataPos := GridFirstDataNodePosition;
                          tmpGrid.IsCursorUPChangeGridPostData := FALSE;
                        end; //if...end!!
                      tmpGrid.GridMoveDataCursor := FALSE;
                    end //if...end!!
                  else//pGOGridDataCellWU!!
                    if(tmpGrid.NavigatorMoveDataCursor = TRUE)then
                      begin
                        if(tmpGrid.GridTopDataPos = -1)then
                          begin
                            for j := 1 to tmpGrid.RowCount-1 do
                              self.FDataSet.RecDataSet.CursorPriorRecord;
                            GridFirstDataNodePosition := self.FDataSet.RecDataSet.GetBookMark;
                            tmpGrid.GridTopDataPos := GridFirstDataNodePosition;
                          end;//if...end!!
                      end //if...end!!
                    else //pGODataSet-OpenɪƲ!!
                      begin
                        PostGridDataWhenDataSetFirstOpen := TRUE;
                        for j := 1 to tmpGrid.RowCount-1 do
                            self.FDataSet.RecDataSet.CursorPriorRecord;
                        GridFirstDataNodePosition := self.FDataSet.RecDataSet.GetBookMark;
                        tmpGrid.GridTopDataPos := GridFirstDataNodePosition;
                      end;//else...end!!
                end;//else...end!!
              //----------------------------------------------------------------
              if(self.FDataSet.RecDataSet.DbState = 'Insert')then
                begin
                  tmpGrid.ResetGridScrollView;
                  GridDisplayDataStartRowNo := 1;
                  self.FDataSet.RecDataSet.CursorGoToBookMark(GridFirstDataNodePosition);
                end//if...end!!
              else GridDisplayDataStartRowNo := 0;
              //------------------------------------------------------------------
              for k := GridDisplayDataStartRowNo to tmpGrid.RowCount-1 do
                begin
                  for j := 0 to tmpGrid.Columns.Count-1 do
                    begin
                      Fieldstr := trim(tmpGrid.Columns.Columns[j].FFieldName);
                      //------------------------------------------------------
                      if(self.FDataSet.RecDataSet.UseFilter = FALSE)then
                        begin
                          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[j]) = FALSE)then
                            begin
                              tmpGrid.Columns.Columns[j].DataCells[k].FilterRecPos := -1;
                              tmpGrid.Columns.Columns[j].DataCells[k].RecPos
                                := self.FDataSet.RecDataSet.GetBookMark;
                              tmpGrid.Columns.Columns[j].DataCells[k].PhysicalRecPos
                                := self.FDataSet.RecDataSet.GetBookMark;
                            end//if...end!!
                          else
                            begin
                              tmpGrid.Columns.Columns[j].DataCellsW[k].FilterRecPos := -1;
                              tmpGrid.Columns.Columns[j].DataCellsW[k].RecPos
                                := self.FDataSet.RecDataSet.GetBookMark;
                              tmpGrid.Columns.Columns[j].DataCellsW[k].PhysicalRecPos
                                := self.FDataSet.RecDataSet.GetBookMark;
                            end;//else...end!!
                        end//if...end!!
                      else
                        begin//UseFilter = TRUE;
                          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[j]) = FALSE)then
                            begin
                              tmpGrid.Columns.Columns[j].DataCells[k].RecPos := -1;
                              tmpGrid.Columns.Columns[j].DataCells[k].FilterRecPos
                                := self.FDataSet.RecDataSet.GetBookMark;
                              tmpGrid.Columns.Columns[j].DataCells[k].PhysicalRecPos
                                := self.FDataSet.RecDataSet.GetPhysicalBookMark;
                            end//if...end!!  
                          else
                            begin
                              tmpGrid.Columns.Columns[j].DataCellsW[k].RecPos := -1;
                              tmpGrid.Columns.Columns[j].DataCellsW[k].FilterRecPos
                                := self.FDataSet.RecDataSet.GetBookMark;
                              tmpGrid.Columns.Columns[j].DataCellsW[k].PhysicalRecPos
                                := self.FDataSet.RecDataSet.GetPhysicalBookMark;
                            end;//else...end!!
                        end;//else...end!!
                      //------------------------------------------------------
                      if(Fieldstr <> '')then
                      if(self.FDataSet.RecDataSet.IsThisFieldExists(Fieldstr) = TRUE)then
                        begin
                          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[j]) = FALSE)then
                            tmpGrid.Columns.Columns[j].DataCells[k].AsString
                             := self.FDataSet.RecDataSet.FieldByName[Fieldstr]
                          else
                            tmpGrid.Columns.Columns[j].DataCellsW[k].AsUniCodeStr
                             := self.FDataSet.RecDataSet.FieldByNameW[Fieldstr]
                        end;//if...end!!
                    end;//for...j...end!!
                  self.FDataSet.RecDataSet.CursorNextRecord;

                  if(Assigned(tmpGrid.FOnChkRecFlash) = TRUE)then
                    tmpGrid.Columns.Columns[0].DataCells[k].Invalidate;

                end;//for...K...end!!

              if(self.FDataSet.FDataSet.RecordCount >= RecPos)then
                self.FDataSet.RecDataSet.CursorGoToBookMark(RecPos);
              //-----------------------------------------------------
              tmpGrid.FScrollPanel.Position := RecPos;
              //-----------------------------------------------------
              if(tmpGrid.RowCount > 0)then
                begin
                  NewRow := tmpGrid.GetCurrentRecordInWhichRow;
                  if(tmpGrid.NavigatorMoveDataCursor = TRUE)then
                    begin
                      if(NewRow >= 0)then
                        begin
                          OldRow := -1;
                          if(tmpGrid.IsSelectUniCodeDataCell = FALSE)then
                            begin
                              if(tmpGrid.SelectedCell <> nil)then
                                OldRow := tmpGrid.SelectedCell.Row;
                                tmpGrid.SelectedCell := tmpGrid.Columns.GetDataCell(0,NewRow);
                            end//if...end!!
                          else
                            begin
                              OldRow := tmpGrid.SelectedCellW.Row;
                              tmpGrid.IsSelectUniCodeDataCell := FALSE;
                              tmpGrid.SelectedCellW := nil;
                              tmpGrid.SelectedCell  := tmpGrid.Columns.GetDataCell(0,NewRow);
                            end;//else...end!!
                          //------------------------------------------------------------
                          if(OldRow >= 0)then
                            tmpGrid.RepaintSelectedRowCells(OldRow);
                          tmpGrid.RepaintSelectedRowCells(NewRow);
                          tmpGrid.NavigatorMoveDataCursor := FALSE;
                        end;//if...end!!
                    end//if...end!!
                  else
                    begin
                      OldRow := 0;
                      if(PostGridDataWhenDataSetFirstOpen = TRUE)then
                        tmpGrid.RepaintSelectedRowCells(OldRow)
                      else
                        begin
                          if(tmpGrid.SelectedCell <> nil)then
                            OldRow := tmpGrid.SelectedCell.Row
                          else
                            if(tmpGrid.SelectedCellW <> nil)then
                             OldRow := tmpGrid.SelectedCellW.Row
                            else
                              OldRow := tmpGrid.GetCurrentRecordInWhichRow;
                          //------------------------------------------------
                          if(OldRow >= 0)then
                            tmpGrid.RepaintSelectedRowCells(OldRow);
                        end;//else...end!!
                    end;//else...end!!
                end;//if...end!!
              //==================================================================
              if(self.FDataSet.RecDataSet.DbState = 'Insert')then
                self.FDataSet.RecDataSet.ClearAllFieldsData;
              //==================================================================
            end//if...end!!
          else
            begin
              tmpGrid.RowCount := 0;
            end;//else...end!!
          tmpGrid := nil;
        end;//if...end!!
      //****************************************************************************
    end;//for...i...end!!
  DBRunTrigger(self.FDataSet,trgAfterScroll,msg,AbortYN);  
end;

procedure TAspFileDataSource.PostDisplayDataWithOutDbGird;
var i,j,k:integer;
    Fieldstr,ValueStr:string;
    ValueStrW:WideString;
    tmpEdit :TAspFileDBEdit;
    tmpMemo :TAspFileDBMemo;
    tmpCombo:TAspFileDBComboBox;
    tmpText :TAspFileDBText;
    tmpEditW:TAspFileDBWEdit;
    tmpTextW:TAspFileDBWText;
    msg:string;
    AbortYN:boolean;
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)then Exit;
  if(self.FDataSet.RecDataSet.DbState = 'Edit')then Exit;
  DBRunTrigger(self.FDataSet,trgBeforeScroll,msg,AbortYN);
  for i := 0 to self.FDataControls.Count-1 do
    begin
      Fieldstr := '';
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBEdit)then
        begin
          tmpEdit := TAspFileDBEdit(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
            begin
              Fieldstr := tmpEdit.DataField;
              if(trim(Fieldstr) <> '')then
                begin
                  ValueStr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                  if(assigned(tmpEdit.FBeforeGetData))then
                    tmpEdit.FBeforeGetData(tmpEdit,ValueStr);
                  tmpEdit.Text := ValueStr;
                  if(assigned(tmpEdit.FAfterGetData))then
                    tmpEdit.FAfterGetData(tmpEdit,ValueStr);
                end;//if...end!!
            end//if...end!!
          else tmpEdit.Text := '';
          tmpEdit := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBMemo)then
        begin
          tmpMemo := TAspFileDBMemo(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            begin
              tmpMemo.Value.Clear;
              tmpMemo.Lines.Clear;
            end
          else
            if(self.FDataSet.RecordCount > 0)then
              begin
                tmpMemo.Value.Clear;
                tmpMemo.Lines.Clear;
                Fieldstr := tmpMemo.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                    if(assigned(tmpMemo.FBeforeGetData))then
                      tmpMemo.FBeforeGetData(tmpMemo,ValueStr);
                    tmpMemo.Value.Add(ValueStr);
                    tmpMemo.Lines.Add(ValueStr);
                    if(assigned(tmpMemo.FAfterGetData))then
                      tmpMemo.FAfterGetData(tmpMemo,ValueStr);
                  end;//if...end!!
              end//if...end!!
            else tmpMemo.Lines.Clear;
          tmpMemo := nil;
        end;//if...end!!
      //------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBComboBox)then
        begin
          tmpCombo := TAspFileDBComboBox(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpCombo.Text := ''
          else
            if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
              begin
                Fieldstr := tmpCombo.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                    if(assigned(tmpCombo.FBeforeGetData))then
                      tmpCombo.FBeforeGetData(tmpCombo,ValueStr);
                    //old tmpCombo.Text := ValueStr;
                    for j := 0 to tmpCombo.Items.Count-1 do
                      begin
                        k := 0;
                        k := Pos(ValueStr,tmpCombo.Items[j]);
                        if(k = 1)then
                          begin
                            tmpCombo.ItemIndex := j;
                            Break;
                          end//if...end!!
                        else
                          //old  tmpCombo.ItemIndex := -1;
                          tmpCombo.Text := ValueStr;
                      end;//for...j...end!!
                    if(assigned(tmpCombo.FAfterGetData))then
                      tmpCombo.FAfterGetData(tmpCombo,ValueStr);
                  end;//if...end!!
              end//if...end!!
            else tmpCombo.Text := '';
          tmpCombo := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBText)then
        begin
          tmpText := TAspFileDBText(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
            begin
              Fieldstr := tmpText.DataField;
              if(trim(Fieldstr) <> '')then
                tmpText.Caption := self.FDataSet.RecDataSet.FieldByName[Fieldstr]; 
            end//if...end!!
          else tmpText.Caption := tmpText.Name;
          tmpText := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBWEdit)then
        begin
          tmpEditW := TAspFileDBWEdit(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpEditW.Text := #0
          else
            if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
              begin
                Fieldstr := tmpEditW.DataField;
                if(trim(Fieldstr) <> '')then
                  begin
                    ValueStr  := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                    ValueStrW := AnsiStrToUniCodeStr(ValueStr);
                    if(assigned(tmpEditW.FBeforeGetData))then
                      tmpEditW.FBeforeGetData(tmpEditW,ValueStrW);
                    tmpEditW.Text := ValueStrW;
                    if(assigned(tmpEditW.FAfterGetData))then
                      tmpEditW.FAfterGetData(tmpEditW,ValueStrW);
                  end;//if...end!!
              end//if...end!!
            else tmpEditW.Text := #0;
          tmpEditW := nil;
        end;//if...end!!
      //---------------------------------------------------------------------------
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBWText)then
        begin
          tmpTextW := TAspFileDBWText(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpTextW.Caption := #0
          else
            if(self.FDataSet.RecDataSet.IsOpened = TRUE)then
              begin
                Fieldstr := tmpText.DataField;
                if(trim(Fieldstr) <> '')then
                  Valuestr := self.FDataSet.RecDataSet.FieldByName[Fieldstr];
                  ValueStrW := AnsiStrToUniCodeStr(ValueStr);
                  tmpTextW.Caption := ValueStrW;
              end//if...end!!
            else tmpTextW.Caption := tmpTextW.Name;
          tmpTextW := nil;
        end;//if...end!!
      //*********************************************************    
    end;//for...i...end!!
  DBRunTrigger(self.FDataSet,trgAfterScroll,msg,AbortYN);  
end;

procedure TAspFileDataSource.RefreshNavigator;
var i:integer;
    tmpNav:TAspFileDBNavigator;
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)then Exit;
  for i := 0 to self.FDataControls.Count-1 do
    begin
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBNavigator)then
        begin
          tmpNav := TAspFileDBNavigator(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'InActive')then
            tmpNav.EnableButtons(FALSE,FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,FALSE,FALSE,FALSE);

          if(self.FDataSet.RecDataSet.DbState = 'Browse')then
            begin
              if(self.FDataSet.RecDataSet.IsReadOnly = FALSE)then
                begin
                  if(self.FDataSet.FDataSet.IsBof = TRUE)then
                    tmpNav.EnableButtons(FALSE,TRUE,TRUE,TRUE, TRUE,TRUE,TRUE,TRUE,FALSE,FALSE)
                  else
                    if(self.FDataSet.FDataSet.IsEof = TRUE)then
                      tmpNav.EnableButtons(TRUE,TRUE,TRUE,FALSE, TRUE,TRUE,TRUE,TRUE,FALSE,FALSE)
                    else
                      tmpNav.EnableButtons(TRUE,TRUE,TRUE,TRUE, TRUE,TRUE,TRUE,TRUE,FALSE,FALSE);
                end
              else
                tmpNav.EnableButtons(TRUE,TRUE,TRUE,TRUE,FALSE,FALSE,FALSE,TRUE,FALSE,FALSE);
            end;//if...end!!

          if(self.FDataSet.RecDataSet.DbState = 'Insert')then
            tmpNav.EnableButtons(FALSE,FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,FALSE,TRUE,TRUE);

          if(self.FDataSet.RecDataSet.DbState = 'Edit')then
            tmpNav.EnableButtons(FALSE,FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,FALSE,TRUE,TRUE);
        end;//if...end!!
    end;//for...i...end!!
  tmpNav := nil;
end;

procedure TAspFileDataSource.RefreshDBGrid;
var i,j,FocusColWhenInsert:integer;
    tmpGrid:TAspFileDBGrid;
begin
  if(self = nil)then Exit;
  if(self.FDataSet = nil)then Exit;
  for i := 0 to self.FDataControls.Count-1 do
    begin
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
        begin
          tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
          if(self.FDataSet.RecDataSet.DbState = 'InActive')then
            begin
              if(tmpGrid.FDataSource = nil)then
                begin
                  tmpGrid.DeleteRecordCells;
                  while(tmpGrid.Columns.Count > 0)do
                    tmpGrid.Columns.Delete(0);
                  tmpGrid.SelectedCell  := nil;
                  tmpGrid.SelectedCellW := nil;
                end;//if...end!!
            end;//if...end!!
          if(self.FDataSet.RecDataSet.DbState = 'Browse')then
            begin
              if(tmpGrid.Columns.Count = 0)then
                tmpGrid.RefreshWithDataSource;
              if(tmpGrid.RowCount = 0)then
                begin
                  tmpGrid.SelectedCell  := nil;
                  tmpGrid.SelectedCellW := nil;
                end;//if...end!!  
            end;
          if(self.FDataSet.RecDataSet.DbState = 'Insert')
            and(tmpGrid.IsReadOnly = FALSE)then
            begin
              FocusColWhenInsert := 0;
              tmpGrid.AddNewRecordCells;
              tmpGrid.ClearInsertRow;
              tmpGrid.CurrentEditRow := 0;
              //---------------------------------------------------------------------------
              for j := 0 to tmpGrid.Columns.Count-1 do
                begin
                  if(tmpGrid.Columns.Columns[FocusColWhenInsert].FWithOutFocus = FALSE)then
                    Break
                  else
                    FocusColWhenInsert := FocusColWhenInsert+1;
                end;//for...j...end!!    
              //---------------------------------------------------------------------------
              if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[FocusColWhenInsert]) = FALSE)then
                tmpGrid.Columns.Columns[FocusColWhenInsert].DataCells[0].DataCellSetFocus(FALSE)
              else
                tmpGrid.Columns.Columns[FocusColWhenInsert].DataCellsW[0].DataCellSetFocus(FALSE);
              tmpGrid.GridTopDataPos := -1;
            end;
          if(self.FDataSet.RecDataSet.DbState = 'Cancel')then
            begin
              tmpGrid.tmpEdit.Visible     := FALSE;
              tmpGrid.tmpEdit.Parent      := nil;
              tmpGrid.tmpEdit.OnKeyPress  := nil;

              tmpGrid.tmpCombo.OnChange   := nil;
              tmpGrid.tmpCombo.OnKeyPress := nil;
              tmpGrid.tmpCombo.Visible    := FALSE;
              tmpGrid.tmpCombo.Parent     := nil;

              tmpGrid.tmpBtn.Parent       := nil;
              tmpGrid.tmpBtn.OnClick      := nil;
              tmpGrid.tmpBtn.Visible      := FALSE;

              tmpGrid.tmpChkBox.Parent    := nil;
              tmpGrid.tmpChkBox.Visible   := FALSE;

              tmpGrid.tmpMemo.Parent      := nil;
              tmpGrid.tmpMemo.Visible     := FALSE;
              //-------------------------------------------
              tmpGrid.tmpEditW.Visible     := FALSE;
              tmpGrid.tmpEditW.Parent      := nil;
              tmpGrid.tmpEditW.OnKeyPress  := nil;

              tmpGrid.tmpComboW.OnChange   := nil;
              tmpGrid.tmpComboW.OnKeyPress := nil;
              tmpGrid.tmpComboW.Visible    := FALSE;
              tmpGrid.tmpComboW.Parent     := nil;

              tmpGrid.tmpBtnW.Parent       := nil;
              tmpGrid.tmpBtnW.OnClick      := nil;
              tmpGrid.tmpBtnW.Visible      := FALSE;

              tmpGrid.tmpChkBoxW.Parent    := nil;
              tmpGrid.tmpChkBoxW.Visible   := FALSE;

              tmpGrid.tmpMemoW.Parent      := nil;
              tmpGrid.tmpMemoW.Visible     := FALSE;
              tmpGrid.DeleteRecordCells;
            end;
        end;//if...end!!
      //-------------------------------------------------------------------------
    end;//for...i...end!!
  tmpGrid := nil;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWithNavigatorFirstClick;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        tmpGrid.SetNavigatorMoveDataCursor(TRUE);
        tmpGrid.NavigatorMoveDataFirst := TRUE;
        tmpGrid.NavigatorMoveDataPrior := FALSE;
        tmpGrid.NavigatorMoveDataNext  := FALSE;
        tmpGrid.NavigatorMoveDataLast  := FALSE;
      end;
  tmpGrid := nil;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWithNavigatorLastClick;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        tmpGrid.SetNavigatorMoveDataCursor(TRUE);
        tmpGrid.NavigatorMoveDataFirst := FALSE;
        tmpGrid.NavigatorMoveDataPrior := FALSE;
        tmpGrid.NavigatorMoveDataNext  := FALSE;
        tmpGrid.NavigatorMoveDataLast  := TRUE;
      end;
  tmpGrid := nil;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWithNavigatorNextClick;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        //tmpGrid.SetNavigatorMoveDataCursor;
        
        if(tmpGrid.SelectedCell <> nil)then
          begin
            if(tmpGrid.SelectedCell.Row = 9)then
              tmpGrid.SetNavigatorMoveDataCursor(TRUE)
            else tmpGrid.SetNavigatorMoveDataCursor(FALSE);
          end
        else tmpGrid.SetNavigatorMoveDataCursor(TRUE);

        tmpGrid.NavigatorMoveDataFirst := FALSE;
        tmpGrid.NavigatorMoveDataPrior := FALSE;
        tmpGrid.NavigatorMoveDataNext  := TRUE;
        tmpGrid.NavigatorMoveDataLast  := FALSE;
      end;
  tmpGrid := nil;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWithNavigatorPriorClick;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        //tmpGrid.SetNavigatorMoveDataCursor;

        if(tmpGrid.SelectedCell <> nil)then
          begin
            if(tmpGrid.SelectedCell.Row = 0)then
              tmpGrid.SetNavigatorMoveDataCursor(TRUE)
            else tmpGrid.SetNavigatorMoveDataCursor(FALSE);
          end
        else tmpGrid.SetNavigatorMoveDataCursor(TRUE);

        tmpGrid.NavigatorMoveDataFirst := FALSE;
        tmpGrid.NavigatorMoveDataPrior := TRUE;
        tmpGrid.NavigatorMoveDataNext  := FALSE;
        tmpGrid.NavigatorMoveDataLast  := FALSE;
      end;
  tmpGrid := nil;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWhenDataFilterChanged;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        tmpGrid.GridTopDataPos := -1;
      end;//if...end!!
  tmpGrid := nil;
end;

procedure TAspFileDataSource.ResetDBGridSelectCell(Sender:TAspFileDBGrid;
                                                   Col,NewRow: integer);
var i,OldRow:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    begin
      if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
        begin
          tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
          if(Sender = tmpGrid)then Continue
          else
            begin
              tmpGrid.tmpEdit  .Visible := FALSE;
              tmpGrid.tmpBtn   .Visible := FALSE;
              tmpGrid.tmpCombo .Visible := FALSE;
              tmpGrid.tmpEditW .Visible := FALSE;
              tmpGrid.tmpBtnW  .Visible := FALSE;
              tmpGrid.tmpComboW.Visible := FALSE;
            end;//if...else...end!!

          if(tmpGrid.IsSelectUniCodeDataCell = FALSE)then
            begin
              if(tmpGrid.SelectedCell <> nil)then
                OldRow := tmpGrid.SelectedCell.Row
              else OldRow := 0;
            end//if...end!!
          else
            begin
              if(tmpGrid.SelectedCellW <> nil)then
                OldRow := tmpGrid.SelectedCellW.Row
              else OldRow := 0;
            end;//else...end!!
            
          if(OldRow < 9)and(OldRow > 0)then
            begin
              if(tmpGrid.IsSelectUniCodeDataCell = FALSE)then
                begin
                  tmpGrid.SelectedCell := tmpGrid.Columns.DataCells[Col,NewRow];
                  tmpGrid.RepaintSelectedRowCells(OldRow);
                  if(tmpGrid.SelectedCell<> nil)then
                    tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
                end//if...end!!
              else
                begin
                  tmpGrid.SelectedCellW := tmpGrid.Columns.DataCellsW[Col,NewRow];
                  tmpGrid.RepaintSelectedRowCells(OldRow);
                  if(tmpGrid.SelectedCellW<> nil)then
                    tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
                end;//else...end!!
            end //if...end!!
          else
            begin
              tmpGrid.IsCursorPosInGridDisplayArea := FALSE;
              tmpGrid.GridTopDataPos  := -1;
              tmpGrid.SetDBGridMoveDataCursor;
              if(OldRow = 9)then
                begin
                  tmpGrid.IsCursorUpChangeGridPostData   := FALSE;
                  tmpGrid.IsCursorDownChangeGridPostData := TRUE;
                  tmpGrid.RepaintSelectedRowCells(OldRow);
                end;//if...end!!
              if(OldRow = 0)then
                begin
                  tmpGrid.IsCursorUpChangeGridPostData   := TRUE;
                  tmpGrid.IsCursorDownChangeGridPostData := FALSE;
                  tmpGrid.RepaintSelectedRowCells(OldRow);
                end;//if...end!!

              if(tmpGrid.IsSelectUniCodeDataCell = FALSE)then
                begin
                  tmpGrid.SelectedCell := tmpGrid.Columns.DataCells[Col,NewRow];
                  tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
                end//if...end!!
              else
                begin
                  tmpGrid.SelectedCellW := tmpGrid.Columns.DataCellsW[Col,NewRow];
                  tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
                end;//else...end!!
            end;//if...else...end!!
        end;//if...end!!
    end;//for...i...end!!
  tmpGrid := nil;
end;                  

procedure TAspFileDataSource.SetFDataSet(const Value: TAspFileDataSet);
begin
  if(FDataSet <> nil)then FDataSet.InternalDataSource := nil;
  FDataSet := Value;
  if(Value <> nil)then
    begin
      Value.InternalDataSource := self;
      RefreshAllDbControlDisplayData(Self);
    end;//if...end!!
end;

//TAspFileDBEdit.
Constructor TAspFileDBEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Text := '';
  self.ImeName := '';
end;

Destructor TAspFileDBEdit.Destroy;
begin
  inherited Destroy;
end;

procedure FocusNextTabStopEdit(CurrentEdit:TComponent);
var i,CurrentID:integer;
    tabList:TList;
begin
  if(CurrentEdit = nil)then Exit;
  try
    tabList := tlist.Create;
    TWinControl(CurrentEdit).Parent.GetTabOrderList(tabList);
    CurrentID := TWinControl(CurrentEdit).TabOrder;
    if(CurrentID = tabList.Count-1)then
      begin
        TWinControl(tabList[0]).SetFocus;
      end
    else
    for i := CurrentID+1 to tabList.Count-1 do
      begin
        if(TWinControl(tabList[i]).CanFocus = TRUE)then
          begin
            TWinControl(tabList[i]).SetFocus;
            Break;
          end;//if...end!!
      end;//for...i...end!!
  finally
    tabList.Free;
  end;//try...end!!
  Abort;    
end;

procedure TAspFileDBEdit.KeyPress(var Key: Char);
begin
  Inherited KeyPress(Key);
  if(Key = #13)then FocusNextTabStopEdit(self)
  else
    if(self.FDataSource <> nil)then
    if(self.FDataSource.FDataSet <> nil)then
    if(self.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then 
      begin
        if(self.FDataSource.FDataSet.RecDataSet.DbState = 'Browse')then
        if(self.FDataSource.FDataSet.RecDataSet.IsKeyField[self.DataField] = FALSE)then
          self.FDataSource.FDataSet.RecDataSet.RecEdit;
      end;//if...end!!
end;

procedure TAspFileDBEdit.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSource)then
      begin
        self.FFieldName  := '';
        self.FDataSource := nil;
      end;//if...end!!
end;

procedure TAspFileDBEdit.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then
    self.FDataSource.RemoveDBEdit(self);
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBEdit(self);
    end;//if...end!!
end;

procedure TAspFileDBEdit.SetFFieldName(
  const Value: TAspFileDbControlFieldStr);
begin
  FFieldName := Value;
  if(trim(FFieldName) = '')then Exit;
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
  if(self.FDataSource.DataSet.Active = TRUE)then
    self.Text := self.FDataSource.DataSet.RecDataSet.FieldByName[FFieldName];
end;

//TAspFileDBComboBox.
Constructor TAspFileDBComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Text := '';
  self.ImeName := '';
end;

Destructor TAspFileDBComboBox.Destroy;
begin
  inherited Destroy;
end;

procedure FocusNextTabStopComboBox(CurrentEdit:TComponent);
var i,CurrentID:integer;
    tabList:TList;       
begin
  if(CurrentEdit = nil)then Exit;
  try
    tabList := tlist.Create;
    TWinControl(CurrentEdit).Parent.GetTabOrderList(tabList);
    CurrentID := TWinControl(CurrentEdit).TabOrder;
    if(CurrentID = tabList.Count-1)then
      begin
        TWinControl(tabList[0]).SetFocus;
      end
    else
    for i := CurrentID+1 to tabList.Count-1 do
      begin
        if(TWinControl(tabList[i]).CanFocus = TRUE)then
          begin
            TWinControl(tabList[i]).SetFocus;
            Break;
          end;//if...end!!
      end;//for...i...end!!
  finally
    tabList.Free;
  end;//try...end!!
  Abort;    
end;

procedure TAspFileDBComboBox.KeyPress(var Key: Char);
begin
  Inherited KeyPress(Key);
  if(Key = #13)then FocusNextTabStopComboBox(self)
  else
    if(self.FDataSource <> nil)then
    if(self.FDataSource.FDataSet <> nil)then
    if(self.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then 
      begin
        if(self.FDataSource.FDataSet.RecDataSet.DbState = 'Browse')then
        if(self.FDataSource.FDataSet.RecDataSet.IsKeyField[self.DataField] = FALSE)then
          self.FDataSource.FDataSet.RecDataSet.RecEdit;
      end;//if...end!!
end;

procedure TAspFileDBComboBox.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSource)then
      begin
        self.FFieldName  := '';
        self.FDataSource := nil;
      end;//if...end!!
end;

procedure TAspFileDBComboBox.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then
    self.FDataSource.RemoveDBComboBox(self);
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBComboBox(self);
    end;//if...end!!
end;

procedure TAspFileDBComboBox.SetFFieldName(
  const Value: TAspFileDbControlFieldStr);
begin
  FFieldName := Value;
  if(trim(FFieldName) = '')then Exit;
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
  if(self.FDataSource.DataSet.Active = TRUE)then
    self.Text := self.FDataSource.DataSet.RecDataSet.FieldByName[FFieldName];
end;

//TAspFileDBText.
Constructor TAspFileDBText.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

Destructor TAspFileDBText.Destroy;
begin
  inherited Destroy;
end;

procedure TAspFileDBText.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSource)then self.FDataSource:= nil;
end;

procedure TAspFileDBText.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then self.FDataSource.RemoveDBText(self);
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBText(self);
    end;//if...end!!
end;

//TAspFileDBWEdit.
Constructor TAspFileDBWEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Text := '';
  self.ImeName := '';
end;

Destructor TAspFileDBWEdit.Destroy;
begin
  inherited Destroy;
end;

procedure FocusNextTabStopWEdit(CurrentEdit:TAspFileDBWEdit);
var i,CurrentID:integer;
    tabList:TList;
begin
  if(CurrentEdit = nil)then Exit;
  try
    tabList := tlist.Create;
    CurrentEdit.Parent.GetTabOrderList(tabList);
    CurrentID := CurrentEdit.TabOrder;
    if(CurrentID = tabList.Count-1)then
      begin
        TWinControl(tabList[0]).SetFocus;
      end
    else
    for i := CurrentID+1 to tabList.Count-1 do
      begin
        if(TWinControl(tabList[i]).CanFocus = TRUE)then
          begin
            TWinControl(tabList[i]).SetFocus;
            Break;
          end;//if...end!!
      end;//for...i...end!!
  finally
    tabList.Free;
  end;//try...end!!
end;

procedure TAspFileDBWEdit.KeyPress(var Key: Char);
begin
  Inherited KeyPress(Key);
  if(Key = #13)then FocusNextTabStopWEdit(self)
  else
    if(self.FDataSource <> nil)then
    if(self.FDataSource.FDataSet <> nil)then
    if(self.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then
      begin
        if(self.FDataSource.FDataSet.RecDataSet.DbState = 'Browse')then
        if(self.FDataSource.FDataSet.RecDataSet.IsKeyField[self.DataField] = FALSE)then
          self.FDataSource.FDataSet.RecDataSet.RecEdit;
      end;//if...end!!
end;

procedure TAspFileDBWEdit.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSource)then self.FDataSource:= nil;
end;

procedure TAspFileDBWEdit.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then self.FDataSource.RemoveDBWEdit(self);
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBWEdit(self);
    end;//if...end!!
end;

procedure TAspFileDBWEdit.SetFFieldName(
  const Value: TAspFileDbControlFieldStr);
begin
  FFieldName := Value;
  if(trim(FFieldName) = '')then Exit;
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
  if(self.FDataSource.DataSet.Active = TRUE)then
    self.Text := self.FDataSource.DataSet.RecDataSet.FieldByName[FFieldName];
end;

//TAspFileDBWText.
Constructor TAspFileDBWText.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

Destructor TAspFileDBWText.Destroy;
begin
  inherited Destroy;
end;

procedure TAspFileDBWText.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSource)then self.FDataSource:= nil;
end;

procedure TAspFileDBWText.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then self.FDataSource.RemoveDBWText(self);
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBWText(self);
    end;//if...end!!
end;

//TNavBtn.
Constructor TNavBtn.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Width  := 60;
  self.Height := 28;
  self.Top    := 2;
  self.NumGlyphs := 2;
  self.Align := alLeft;
end;

Destructor TNavBtn.Destroy;
begin
  inherited Destroy;
end;

//TAspFileDBNavigator.
Constructor TAspFileDBNavigator.Create(AOwner: TComponent);
var newLeft:integer;
begin           
  inherited Create(AOwner);
  self.AllBtnHeight := 28;
  self.Caption := ' ';
  self.Color   := $00B4F5F2;
  self.Width   := 630;
  self.Height  := 31;
  self.BevelInner := bvLowered;
  self.BevelOuter := bvRaised;

  self.FConfirmDelete := TRUE;
  
  self.BtnFirst := TNavBtn.Create(nil);
  self.BtnFirst.Caption := 'First';
  //self.BtnFirst.Left := 2;
  self.BtnFirst.Parent := self;
  self.BtnFirst.OnClick := self.RunFirstClick;
  self.BtnFirst.TabStop := FALSE;
  //newLeft := 2+60;

  self.BtnPrior := TNavBtn.Create(nil);
  self.BtnPrior.Caption := 'Prior';
  //self.BtnPrior.Left   := 1+newLeft;
  self.BtnPrior.Parent := self;
  self.BtnPrior.OnClick := self.RunPriorClick;
  self.BtnPrior.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnNext := TNavBtn.Create(nil);
  self.BtnNext.Caption := 'Next';
  //self.BtnNext.Left   := 1+newLeft;
  self.BtnNext.Parent := self;
  self.BtnNext.OnClick := self.RunNextClick;
  self.BtnNext.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnLast := TNavBtn.Create(nil);
  self.BtnLast.Caption := 'Last';
  //self.BtnLast.Left   := 1+newLeft;
  self.BtnLast.Parent := self;
  self.BtnLast.OnClick := self.RunLastClick;
  self.BtnLast.TabStop := FALSE;
  //newLeft := newLeft+60+23;

  self.SplitterPanel  := TPanel.Create(nil);
  self.SplitterPanel.Caption    :='';
  self.SplitterPanel.Align      := AlLeft;
  self.SplitterPanel.Parent     := self;
  self.SplitterPanel.BevelInner := bvNone;
  self.SplitterPanel.BevelOuter := bvNone;
  self.SplitterPanel.Width      := 28;

  self.BtnAdd := TNavBtn.Create(nil);
  self.BtnAdd.Caption := 'Insert';
  //self.BtnAdd.Left    := 1+newLeft;
  self.BtnAdd.Parent  := self;
  self.BtnAdd.OnClick := self.RunAddClick;
  self.BtnAdd.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnEdit := TNavBtn.Create(nil);
  self.BtnEdit.Caption := 'Edit';
  //self.BtnEdit.Left    := 1+newLeft;
  self.BtnEdit.Parent  := self;
  self.BtnEdit.OnClick := self.RunEditClick;
  self.BtnEdit.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnDelete := TNavBtn.Create(nil);
  self.BtnDelete.Caption := 'Delete';
  //self.BtnDelete.Left    := 1+newLeft;
  self.BtnDelete.Parent  := self;
  self.BtnDelete.OnClick := self.RunDeleteClick;
  self.BtnDelete.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnQuery := TNavBtn.Create(nil);
  self.BtnQuery.Align   := AlRight;
  self.BtnQuery.Caption := 'Query';
  //self.BtnQuery.Left    := 1+newLeft;
  self.BtnQuery.Parent  := self;
  self.BtnQuery.OnClick := self.RunQueryClick;
  self.BtnQuery.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnSave := TNavBtn.Create(nil);
  self.BtnSave.Caption := 'Post';
  //self.BtnSave.Left    := 1+newLeft;
  self.BtnSave.Parent  := self;
  self.BtnSave.OnClick := self.RunSaveClick;
  self.BtnSave.TabStop := FALSE;
  //newLeft := newLeft+60;

  self.BtnCancel := TNavBtn.Create(nil);
  self.BtnCancel.Caption := 'Cancel';
  //self.BtnCancel.Left    := 1+newLeft;
  self.BtnCancel.Parent  := self;
  self.BtnCancel.OnClick := self.RunCancelClick;
  self.BtnCancel.TabStop := FALSE;
end;

Destructor TAspFileDBNavigator.Destroy;
begin
  self.BtnFirst.Free;
  self.BtnPrior.Free;
  self.BtnNext.Free;
  self.BtnLast.Free;
  self.SplitterPanel.Free;
  self.BtnAdd.Free;
  self.BtnEdit.Free;
  self.BtnDelete.Free;
  self.BtnQuery.Free;
  self.BtnSave.Free;
  self.BtnCancel.Free;
  inherited Destroy;
end;

procedure TAspFileDBNavigator.Paint;
begin
  inherited Paint;
  self.SplitterPanel.Color := self.Color;
end;

procedure TAspFileDBNavigator.ReSize;
begin
  //
end;

procedure TAspFileDBNavigator.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then
    begin
      self.FDataSource.RefreshNavigator;
      self.FDataSource.RemoveDBNavigator(self);
    end;
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBNavigator(self);
      self.FDataSource.RefreshNavigator;
    end;//if...end!!
end;

procedure TAspFileDBNavigator.SetFConfirmDelete(const Value: boolean);
begin
  FConfirmDelete := Value;
end;

function TAspFileDBNavigator.GetAddPic: TBitMap;
begin
  result := self.BtnAdd.Glyph;
end;

function TAspFileDBNavigator.GetCancelPic: TBitMap;
begin
  result := self.BtnCancel.Glyph;
end;

function TAspFileDBNavigator.GetDeletePic: TBitMap;
begin
  result := self.BtnDelete.Glyph;
end;

function TAspFileDBNavigator.GetEditPic: TBitMap;
begin
  result := self.BtnEdit.Glyph;
end;

function TAspFileDBNavigator.GetFirstPic: TBitMap;
begin
 result := self.BtnFirst.Glyph;
end;

function TAspFileDBNavigator.GetLastPic: TBitMap;
begin
  result := self.BtnLast.Glyph;
end;

function TAspFileDBNavigator.GetNextPic: TBitMap;
begin
  result := self.BtnNext.Glyph;
end;

function TAspFileDBNavigator.GetPriorPic: TBitMap;
begin
  result := self.BtnPrior.Glyph;
end;

function TAspFileDBNavigator.GetQueryPic: TBitMap;
begin
  result := self.BtnQuery.Glyph;
end;

function TAspFileDBNavigator.GetSavePic: TBitMap;
begin
  result := self.BtnSave.Glyph;
end;

procedure TAspFileDBNavigator.SetAddPic(const Value: TBitMap);
begin
  self.BtnAdd.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetCancelPic(const Value: TBitMap);
begin
  self.BtnCancel.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetDeletePic(const Value: TBitMap);
begin
  self.BtnDelete.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetEditPic(const Value: TBitMap);
begin
  self.BtnEdit.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetFirstPic(const Value: TBitMap);
begin
  self.BtnFirst.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetLastPic(const Value: TBitMap);
begin
  self.BtnLast.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetNextPic(const Value: TBitMap);
begin
  self.BtnNext.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetPriorPic(const Value: TBitMap);
begin
  self.BtnPrior.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetQueryPic(const Value: TBitMap);
begin
  self.BtnQuery.Glyph.Assign(Value);
end;

procedure TAspFileDBNavigator.SetSavePic(const Value: TBitMap);
begin
  self.BtnSave.Glyph.Assign(Value);
end;

function TAspFileDBNavigator.GetAddCaption: string;
begin
  result := self.BtnAdd.Caption;
end;

function TAspFileDBNavigator.GetCancelCaption: string;
begin
  result := self.BtnCancel.Caption;
end;

function TAspFileDBNavigator.GetDeleteCaption: string;
begin
  result := self.BtnDelete.Caption;
end;

function TAspFileDBNavigator.GetEditCaption: string;
begin
  result := self.BtnEdit.Caption;
end;

function TAspFileDBNavigator.GetFirstCaption: string;
begin
  result := self.BtnFirst.Caption;
end;

function TAspFileDBNavigator.GetLastCaption: string;
begin
  result := self.BtnLast.Caption;
end;

function TAspFileDBNavigator.GetNextCaption: string;
begin
  result := self.BtnNext.Caption;
end;

function TAspFileDBNavigator.GetPriorCaption: string;
begin
  result := self.BtnPrior.Caption;
end;

function TAspFileDBNavigator.GetQueryCaption: string;
begin
  result := self.BtnQuery.Caption;
end;

function TAspFileDBNavigator.GetSaveCaption: string;
begin
  result := self.BtnSave.Caption;
end;

procedure TAspFileDBNavigator.SetAddCaption(const Value: string);
begin
  self.BtnAdd.Caption := Value;
end;

procedure TAspFileDBNavigator.SetCancelCaption(const Value: string);
begin
  self.BtnCancel.Caption := Value;
end;

procedure TAspFileDBNavigator.SetDeleteCaption(const Value: string);
begin
  self.BtnDelete.Caption := Value;
end;

procedure TAspFileDBNavigator.SetEditCaption(const Value: string);
begin
  self.BtnEdit.Caption := Value;
end;

procedure TAspFileDBNavigator.SetFirstCaption(const Value: string);
begin
  self.BtnFirst.Caption := Value;
end;

procedure TAspFileDBNavigator.SetLastCaption(const Value: string);
begin
  self.BtnLast.Caption := Value;
end;

procedure TAspFileDBNavigator.SetNextCaption(const Value: string);
begin
  self.BtnNext.Caption := Value;
end;

procedure TAspFileDBNavigator.SetPriorCaption(const Value: string);
begin
  self.BtnPrior.Caption := Value;
end;

procedure TAspFileDBNavigator.SetQueryCaption(const Value: string);
begin
  self.BtnQuery.Caption := Value;
end;

procedure TAspFileDBNavigator.SetSaveCaption(const Value: string);
begin
  self.BtnSave.Caption := Value;
end;

function TAspFileDBNavigator.GetAddEnabled: boolean;
begin
  result := self.BtnAdd.Enabled;
end;

function TAspFileDBNavigator.GetCancelEnabled: boolean;
begin
  result := self.BtnCancel.Enabled;
end;

function TAspFileDBNavigator.GetDeleteEnabled: boolean;
begin
  result := self.BtnDelete.Enabled;
end;

function TAspFileDBNavigator.GetEditEnabled: boolean;
begin
  result := self.BtnEdit.Enabled;
end;

function TAspFileDBNavigator.GetFirstEnabled: boolean;
begin
  result := self.BtnFirst.Enabled;
end;

function TAspFileDBNavigator.GetLastEnabled: boolean;
begin
  result := self.BtnLast.Enabled;
end;

function TAspFileDBNavigator.GetNextEnabled: boolean;
begin
  result := self.BtnNext.Enabled;
end;

function TAspFileDBNavigator.GetPriorEnabled: boolean;
begin
  result := self.BtnPrior.Enabled;
end;

function TAspFileDBNavigator.GetQueryEnabled: boolean;
begin
  result := self.BtnQuery.Enabled;
end;

function TAspFileDBNavigator.GetSaveEnabled: boolean;
begin
  result := self.BtnSave.Enabled;
end;

procedure TAspFileDBNavigator.SetAddEnabled(const Value: boolean);
begin
  self.BtnAdd.Enabled := value;
end;

procedure TAspFileDBNavigator.SetCancelEnabled(const Value: boolean);
begin
  self.BtnCancel.Enabled := value;
end;

procedure TAspFileDBNavigator.SetDeleteEnabled(const Value: boolean);
begin
  self.BtnDelete.Enabled := value;
end;

procedure TAspFileDBNavigator.SetEditEnabled(const Value: boolean);
begin
  self.BtnEdit.Enabled := value;
end;

procedure TAspFileDBNavigator.SetFirstEnabled(const Value: boolean);
begin
  self.BtnFirst.Enabled := value;
end;

procedure TAspFileDBNavigator.SetLastEnabled(const Value: boolean);
begin
  self.BtnLast.Enabled := value;
end;

procedure TAspFileDBNavigator.SetNextEnabled(const Value: boolean);
begin
  self.BtnNext.Enabled := value;
end;

procedure TAspFileDBNavigator.SetPriorEnabled(const Value: boolean);
begin
  self.BtnPrior.Enabled := value;
end;

procedure TAspFileDBNavigator.SetQueryEnabled(const Value: boolean);
begin
  self.BtnQuery.Enabled := value;
end;

procedure TAspFileDBNavigator.SetSaveEnabled(const Value: boolean);
begin
  self.BtnSave.Enabled := value;
end;

procedure TAspFileDBNavigator.EnableButtons(enFirst, enPrior, enNext,
  enLast, enAdd, enEdit, enDel, enQry, enSave, enCancel: boolean);
begin
  self.BtnFirst.Enabled := enFirst;
  self.BtnPrior.Enabled := enPrior;
  self.BtnNext .Enabled := enNext;
  self.BtnLast .Enabled := enLast;
  //-----------------------------------
  self.BtnAdd   .Enabled := enAdd;
  self.BtnEdit  .Enabled := enEdit;
  self.BtnDelete.Enabled := enDel;
  self.BtnQuery .Enabled := enQry;
  self.BtnSave  .Enabled := enSave;
  self.Btncancel.Enabled := enCancel;
end;

procedure TAspFileDBNavigator.RunCustomClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      if(Assigned(self.FBeforeCustomBtnClick))then
        self.FBeforeCustomBtnClick(TNavBtn(Sender),TNavBtn(Sender).Caption);
      if(Assigned(self.FAfterCustomBtnClick))then
        self.FAfterCustomBtnClick(TNavBtn(Sender),TNavBtn(Sender).Caption);
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunAddClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnAdd,'Add');
       self.FDataSource.DataSet.RecDataSet.RecInsert;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnAdd,'Add');
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunCancelClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnCancel,'Cancel');
      self.FDataSource.DataSet.RecDataSet.RecCancel;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnCancel,'Cancel');
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunDeleteClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnDelete,'Delete');
      if(self.FConfirmDelete = TRUE)then
      if(MessageDlg( 'Delete current record??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
        self.FDataSource.DataSet.RecDataSet.RecDelete;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnDelete,'Delete');
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunEditClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnEdit,'Edit');
      self.FDataSource.DataSet.RecDataSet.RecEdit;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnEdit,'Edit');
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunFirstClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      self.FDataSource.RefreshDBGridParamsWithNavigatorFirstClick;
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnFirst,'First');
      self.FDataSource.DataSet.RecDataSet.RecFirst;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnFirst,'First');
      self.FDataSource.RefreshNavigator;
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunLastClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      self.FDataSource.RefreshDBGridParamsWithNavigatorLastClick;
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnLast,'Last');
      self.FDataSource.DataSet.RecDataSet.RecLast;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnLast,'Last');
      self.FDataSource.RefreshNavigator;
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunNextClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      self.FDataSource.RefreshDBGridParamsWithNavigatorNextClick;
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnNext,'Next');
      self.FDataSource.DataSet.RecDataSet.recNext;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnNext,'Next');
      self.FDataSource.RefreshNavigator;
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunPriorClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      self.FDataSource.RefreshDBGridParamsWithNavigatorPriorClick;
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnPrior,'Prior');
      self.FDataSource.DataSet.RecDataSet.RecPrior;
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnPrior,'Prior');
      self.FDataSource.RefreshNavigator;
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunQueryClick(Sender: TObject);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnQuery,'Query');

      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnQuery,'Query');
    end;//if...end!!
end;

procedure TAspFileDBNavigator.RunSaveClick(Sender: TObject);
var IsPostSuccess:OleVariant;
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
    begin
      self.FDataSource.RefreshDBGridParamsWithNavigatorPostClick;
      if(Assigned(self.FBeforeNavBtnClick))then
        self.FBeforeNavBtnClick(self.BtnSave,'Post');
      self.FDataSource.DataSet.RecDataSet.RecPost(IsPostSuccess);
      if(Assigned(self.FAfterNavBtnClick))then
        self.FAfterNavBtnClick(self.BtnSave,'Post');
    end;//if...end!!
end;

//TGridCell.
Constructor TGridCell.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Width   := 64;
  self.Height  := 26;
  self.TabStop := TRUE;
  self.RecPos  := -1;
  self.FilterRecPos := -1;
  self.OwnerComp := nil;
end;

Destructor TGridCell.Destroy;
begin
  self.OwnerComp := nil;
  inherited Destroy;
end;

procedure TGridCell.DoKeyDowned(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
begin
  self.KeyDown(Key,Shift);
end;

procedure TGridCell.DoKeyPressed(Sender:TObject;var Key: Char);
begin
  self.KeyPress(Key);
end;

procedure TGridCell.DoOnButtonClick(Sender: TObject);
var str:string;
begin
  str := TGridColumns(self.OwnerComp.GetOwner).FGrid
            .FDataSource.FDataSet.DbState;
  if(Assigned(self.OwnerComp.FCellBtnPressed))then
    self.OwnerComp.FCellBtnPressed(str,self.OwnerComp,self);
end;

procedure SetActiveComboBox(DataCell:TGridCell;Comp:TComboBox;
                            inMaxLength:integer;
                            CallListInit_Event,
                            IsSelfCombo:boolean);
begin
  if(DataCell = nil)then Exit;
  if(Comp = nil)then Exit;   
  Comp.Parent   := DataCell;
  Comp.Style    := DataCell.OwnerComp.FEditComboStyle;
  Comp.ImeName  := DataCell.OwnerComp.ImeName;
  Comp.CharCase := DataCell.OwnerComp.ColumnCharCase;
  if(IsSelfCombo = FALSE)then Comp.Items.Clear;
  Comp.Font     := DataCell.Font;
  Comp.Align    := alClient;
  Comp.Text     := DataCell.FValue;
  Comp.OnKeyPress := DataCell.DoKeyPressed;
  Comp.OnKeyDown  := DataCell.DoKeyDowned;
  Comp.OnChange   := DataCell.DoOnComboBoxChange;
  Comp.Visible    := TRUE;
  Comp.MaxLength  := inMaxLength;
  if(CallListInit_Event = TRUE)and(Comp.Items.Count = 0)then
    begin
      //Call --> ListInit_Event
      if(Assigned(DataCell.OwnerComp.FCellPickListInit))then
        DataCell.OwnerComp.FCellPickListInit(DataCell.OwnerComp)
      else
        Comp.Items.AddStrings(DataCell.OwnerComp.FPickUpList);
    end;//if...end!!
  if(DataCell.Visible = TRUE)then Comp.SetFocus;
end;

procedure TGridCell.DataCellSetFocus(SeekCursorPos:boolean);
var tmpGrid:TAspFileDbGrid;
    EditMaxLength,i:integer;
begin
  //debug !!
  //ShowMessage( 'Col = '+IntToStr(self.FCol)
  //               +' , Row = '+IntToStr(self.FRow));
  if(self.FIsTitleCell = FALSE)then
  if(self.OwnerComp <> nil)then
    begin
      tmpGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
      tmpGrid.IsSelectUniCodeDataCell := FALSE;
      tmpGrid.SelectedCellW  := nil;
      tmpGrid.SelectedCell   := self;
      self.FIsModify         := FALSE;
      tmpGrid.CurrentEditRow := self.Row;
      //==================================================================================
      if(tmpGrid.FDataSource <> nil)then
      if(tmpGrid.FDataSource.FDataSet <> nil)then
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then
        begin
          if(self.RecPos >= 0)then
            begin
              if(SeekCursorPos = TRUE)then
                tmpGrid.FDataSource.FDataSet.RecDataSet.GoToBookMark(self.RecPos)
              else
                begin
                  tmpGrid.FDataSource.FDataSet.RecDataSet
                                            .CursorGoToBookMark(self.RecPos);
                  tmpGrid.FDataSource.PostDisplayDataWithOutDbGird;
                end;//if...else...end!!
            end //if...end!!
          else
            if(self.FilterRecPos >= 0)then
              begin
                if(SeekCursorPos = TRUE)then
                  tmpGrid.FDataSource.FDataSet.RecDataSet
                                            .GoToBookMark(self.FilterRecPos)
                else
                  begin
                    if(tmpGrid.FDataSource.FDataSet.RecordCount > 0)then
                      tmpGrid.FDataSource.FDataSet.RecDataSet
                                         .CursorGoToBookMark(self.FilterRecPos);
                    tmpGrid.FDataSource.PostDisplayDataWithOutDbGird;
                  end;
              end;//if...end!!
        end;//if...end!!
      //==================================================================================
      if(csDesigning in tmpGrid.ComponentState)then
        begin
          tmpGrid := nil;
          Exit;
        end;//if...end!!
      //--------------------------------------------------------------
      if(tmpGrid.tmpCombo.Parent <> nil)then
        begin
          tmpGrid.tmpCombo.Text   := '';
          tmpGrid.tmpCombo.ItemIndex := -1;
        end;//if...end!!
      //=================================================================
      tmpGrid.tmpEdit .Visible   := FALSE;
      tmpGrid.tmpCombo.Visible   := FALSE;
      tmpGrid.tmpBtn  .Visible   := FALSE;
      tmpGrid.tmpChkBox.Visible  := FALSE;
      tmpGrid.tmpMemo.Visible    := FALSE;
      //----------------------------------
      tmpGrid.tmpEditW .Visible  := FALSE;
      tmpGrid.tmpComboW.Visible  := FALSE;
      tmpGrid.tmpBtnW  .Visible  := FALSE;
      tmpGrid.tmpChkBoxW.Visible := FALSE;
      tmpGrid.tmpMemoW.Visible   := FALSE;
      //--------------------------------------------------------------
      EditMaxLength := 0;
      EditMaxLength := tmpGrid.FDataSource.FDataSet.RecDataSet
                              .FieldDataSize[self.OwnerComp.DataField];
      Application.ProcessMessages;
      //=================================================================
      self.FOldValue := self.FValue;
      if(tmpGrid.IsReadOnly = TRUE)then Exit;
      if(self.OwnerComp.FWithOutFocus = TRUE)then Exit;
      case self.OwnerComp.FEditStyle of
        CES_PickList:begin
                       if(tmpGrid.DataSource.DataSet.DbState = 'Browse')then
                         begin
                           if(self.OwnerComp.FPickUpList.Count <= 10)then
                             begin
                               SetActiveComboBox( self,tmpGrid.tmpCombo
                                                 ,EditMaxLength,TRUE,FALSE);
                             end//if...end!!
                           else
                             SetActiveComboBox( self,tmpGrid.tmpCombo
                                               ,EditMaxLength,FALSE,FALSE);
                         end//if...end!!
                       else//if DbState <> 'Browse'
                         if(self.OwnerComp.FUseSelfComboBox = TRUE)then
                           SetActiveComboBox( self,self.OwnerComp.ColumnCombo
                                             ,EditMaxLength,TRUE,TRUE)
                         else
                           SetActiveComboBox( self,tmpGrid.tmpCombo
                                             ,EditMaxLength,TRUE,FALSE);
                     end;
        CES_None:begin
                   tmpGrid.tmpEdit.EditMask   := self.OwnerComp.ColumnEditMask;
                   tmpGrid.tmpEdit.ImeName    := self.OwnerComp.ImeName;
                   tmpGrid.tmpEdit.CharCase   := self.OwnerComp.ColumnCharCase;
                   tmpGrid.tmpEdit.Parent     := self;
                   tmpGrid.tmpEdit.Visible    := TRUE;
                   tmpGrid.tmpEdit.OnKeyPress := self.DoKeyPressed;
                   tmpGrid.tmpEdit.OnKeyDown  := self.DoKeyDowned;
                   tmpGrid.tmpEdit.Font       := self.Font;
                   tmpGrid.tmpEdit.Text       := self.FValue;
                   tmpGrid.tmpEdit.Align      := alClient;
                   tmpGrid.tmpEdit.MaxLength  := EditMaxLength;
                   if(self.Visible = TRUE)then tmpGrid.tmpEdit.SetFocus;
                 end;
        CES_ClickBtn:begin
                       tmpGrid.tmpBtn.Align      := alClient;
                       tmpGrid.tmpBtn.Parent     := self;
                       tmpGrid.tmpBtn.Visible    := TRUE;
                       tmpGrid.tmpBtn.OnClick    := self.DoOnButtonClick;
                       if(tmpGrid.Parent.Visible = TRUE)then tmpGrid.tmpBtn.SetFocus;
                     end;
        CES_Ellipsis:begin
                       tmpGrid.tmpBtn.Width      := 20;
                       tmpGrid.tmpBtn.Align      := alRight;
                       tmpGrid.tmpBtn.Parent     := self;
                       tmpGrid.tmpBtn.Visible    := TRUE;
                       tmpGrid.tmpBtn.OnClick    := self.DoOnButtonClick;
                       if(tmpGrid.Parent.Visible = TRUE)then tmpGrid.tmpBtn.SetFocus;
                       //------------------------------------------------------------
                       tmpGrid.tmpEdit.ImeName    := self.OwnerComp.ImeName;
                       tmpGrid.tmpEdit.CharCase   := self.OwnerComp.ColumnCharCase;
                       tmpGrid.tmpEdit.OnKeyPress := self.DoKeyPressed;
                       tmpGrid.tmpEdit.OnKeyDown  := self.DoKeyDowned;
                       tmpGrid.tmpEdit.Font       := self.Font;
                       tmpGrid.tmpEdit.Text       := self.FValue;
                       tmpGrid.tmpEdit.Align      := alClient;
                       tmpGrid.tmpEdit.Parent     := self;
                       tmpGrid.tmpEdit.Visible    := TRUE;
                       tmpGrid.tmpEdit.MaxLength  := EditMaxLength;
                       if(self.Visible = TRUE)then tmpGrid.tmpEdit.SetFocus;
                     end;
            CES_Memo:begin
                       tmpGrid.tmpMemo.ImeName    := self.OwnerComp.ImeName;
                       tmpGrid.tmpMemo.Parent     := self;
                       tmpGrid.tmpMemo.Visible    := TRUE;
                       tmpGrid.tmpMemo.OnKeyPress := self.DoKeyPressed;
                       tmpGrid.tmpMemo.OnKeyDown  := self.DoKeyDowned;
                       tmpGrid.tmpMemo.Font       := self.Font;
                       tmpGrid.tmpMemo.Text       := self.FValue;
                       tmpGrid.tmpMemo.Align      := alClient;
                       tmpGrid.tmpMemo.MaxLength  := EditMaxLength;
                       if(self.Visible = TRUE)then tmpGrid.tmpMemo.SetFocus;
                     end;
        CES_CheckBox:begin
                       tmpGrid.tmpChkBox.OnClick := nil;
                       tmpGrid.tmpChkBox.Checked := FALSE;
                       if(self.OwnerComp.BeARecordSelectColumn = TRUE)then
                         begin
                           tmpGrid.tmpChkBox.Caption
                              := self.OwnerComp.SelectColumnCaption;
                           tmpGrid.tmpChkBox.Checked := self.FIsSelect;
                         end//if...end!!
                       else
                         begin
                           tmpGrid.tmpChkBox.Caption := '';
                           tmpGrid.tmpChkBox.Checked := FALSE;
                         end;//else...end!!
                       tmpGrid.tmpChkBox.OnClick    := self.DoOnCheckBoxClick;
                       tmpGrid.tmpChkBox.Parent     := self;
                       tmpGrid.tmpChkBox.Visible    := TRUE;
                       tmpGrid.tmpChkBox.OnKeyPress := self.DoKeyPressed;
                       tmpGrid.tmpChkBox.OnKeyDown  := self.DoKeyDowned;
                       tmpGrid.tmpChkBox.Font       := self.Font;
                       //-----------------------------------------------------
                       if(self.OwnerComp.BeARecordSelectColumn = FALSE)then
                         begin
                           if(self.FValue = 'Y')or(self.FValue = 'y')
                             or(self.FValue = 'YES')or(self.FValue = 'yes')
                             or(self.FValue = 'TRUE')or(self.FValue = 'true')
                             or(self.FValue = 'True')then
                             tmpGrid.tmpChkBox.Checked := TRUE
                           else tmpGrid.tmpChkBox.Checked := FALSE;
                         end;//if...end!!  
                       //-----------------------------------------------------
                       tmpGrid.tmpChkBox.Align := alClient;
                       if(self.Visible = TRUE)then tmpGrid.tmpChkBox.SetFocus;
                     end;
      end;//case...end!!
    end;//if...end!!
  tmpGrid := nil;
end;

procedure TGridCell.DoOnComboBoxChange(Sender: TObject);
var str:string;
begin
  str := TGridColumns(self.OwnerComp.GetOwner).FGrid
            .FDataSource.FDataSet.DbState;
  self.FIsModify := TRUE;
  self.InitDataCellValue;
  if(Assigned(self.OwnerComp.FCellComboBoxSelected))then
    self.OwnerComp.FCellComboBoxSelected(str,self.OwnerComp,self);
end;

function TGridCell.GetAsString: string;
begin
  result := self.FValue;
end;

procedure TGridCell.SetAsString(const Value: string);
var repaintYN:boolean;
    str:string;
begin
  str := TGridColumns(self.OwnerComp.GetOwner).FGrid
                          .DataSource.DataSet.DbState;
  if(self.FValue <> Value)then repaintYN := TRUE;
  self.FValue := Value;            
  //with TGridColumns(self.OwnerComp.GetOwner) do
  //if(FGrid.SelectedCell <> nil)then
  //  if(FGrid.SelectedCell.OwnerComp = self.OwnerComp)then
  //    FGrid.SelectedCell.FValue := Value;
  if(Assigned(self.OwnerComp.FCellGetValue))then
    self.OwnerComp.FCellGetValue(str,self.OwnerComp,self);
  //----------------------------------------------------  
  if(repaintYN = TRUE)then self.Invalidate;
end;

function TGridCell.GetEditOwner: TColumnItem;
begin
  result := self.OwnerComp;
end;

procedure TGridCell.PutCellData(inCell: TGridCell);
begin
  if(inCell = nil)then Exit;
  self.IsTitleCell := inCell.IsTitleCell;
  self.IsModify    := inCell.IsModify;
  self.Col         := inCell.Col;
  self.Row         := inCell.Row;
  self.RecPos      := inCell.RecPos;
  self.FilterRecPos:= inCell.FilterRecPos;
  self.FValue      := inCell.FValue;
  self.FOldValue   := inCell.FOldValue;
end;

procedure TGridCell.ClearCellData;
begin
  self.RecPos       := -1;
  Self.FilterRecPos := -1;
  self.FValue       := '';
  self.FOldValue    := '';
  self.Invalidate;
end;

function TGridCell.GetOldValue: string;
begin
  result := self.FOldValue;
end;

procedure TGridCell.SetOldValue(const Value: string);
begin
  self.FOldValue := Value;
end;

procedure TGridCell.InitDataCellValue;
var tmpGrid:TAspFileDBGrid;
    FieldStr,ValueStr:string;
begin
  if(self.FIsModify = TRUE)then
    begin
      FieldStr := trim(self.OwnerComp.DataField);
      tmpGrid  := TGridColumns(self.OwnerComp.GetOwner).FGrid;

      if(tmpGrid.DataSource <> nil)then
      if(tmpGrid.DataSource.DataSet <> nil)then
        begin
          if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Browse')then
            begin
              tmpGrid.DataSource.DataSet.RecDataSet.RecEdit;
            end;//if...end!!
        end;//if...end!!

      case self.OwnerComp.FEditStyle of
        CES_None,CES_Ellipsis
          :ValueStr := tmpGrid.tmpEdit.Text;
        CES_PickList
          :if(self.OwnerComp.FUseSelfComboBox = FALSE)then
             ValueStr := tmpGrid.tmpCombo.Text
           else ValueStr := self.OwnerComp.ColumnCombo.Text;
      end;//case...end!!

      self.FValue := ValueStr;

      if(Assigned(self.OwnerComp.FCellGetValue))then
        self.OwnerComp.FCellGetValue( tmpGrid.DataSource.DataSet.DbState
                                      ,self.OwnerComp,self);
      tmpGrid := nil;
      //self.FIsModify := FALSE;
    end;//if...end!!
end;

procedure TGridCell.KeyDown(var Key: Word; Shift: TShiftState);
var tmpGrid:TAspFileDBGrid;
    tmpCol,tmpRow,OldRow:integer;
    FieldName,valueStr:string;
    IsPostSuccess:OleVariant;
    procedure RefreshDetailData;
    var i,LoopCount:integer;
    begin
      //========================================================================
      LoopCount := tmpGrid.DataSource.DataSet.FDataSet.DetailDbCount;
      if(LoopCount > 0)then
      //for i := 0 to LoopCount-1 do
      //  begin
          tmpGrid.DataSource.DataSet.RecDataSet.RefreshAllDetailDBData;
      //  end;//for...i...end!!
      //========================================================================
    end;

    procedure DetectDataModified;
    begin
      if(tmpGrid = nil)then Exit;
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.DbState = 'Edit')then
        begin
          valueStr := '';
          if(tmpGrid.SelectedCell.IsModify = TRUE)then
            begin
              case tmpGrid.SelectedCell.OwnerComp.FEditStyle of
                CES_None,CES_Ellipsis: valueStr := tmpGrid.tmpEdit.Text;
                CES_PickList         : valueStr := tmpGrid.tmpCombo.Text;
              end;//case...end!!
              //if(trim(valueStr) <> '')then
             tmpGrid.SelectedCell.FValue := valueStr;
            end;//if...end!!
          if(MessageDlg( 'Data is modified, Save this record ??'
                        ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
            begin
              FieldName := tmpGrid.SelectedCell.OwnerComp.DataField;
              tmpGrid.FDataSource.FDataSet.RecDataSet
                                 .FieldByName[FieldName] := valueStr;
              tmpGrid.FDataSource.FDataSet.RecDataSet.RecPost(IsPostSuccess);
            end
          else tmpGrid.FDataSource.FDataSet.RecDataSet.RecCancel;
        end;//if...end!!
    end;
begin
  Application.ProcessMessages;
  tmpGrid := TGridcolumns(self.OwnerComp.GetOwner).FGrid;

  if(tmpGrid.IsReadOnly = TRUE)then Exit;

  OldRow := -1;
  if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row;
  if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
  if(Key = 38)then //VK_UP
    begin
      if(tmpGrid.FDataSource <> nil)then
      if(tmpGrid.FDataSource.FDataSet <> nil)then
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.DbState = 'Insert')then Exit;
      if(self.Row-1 >= 0)then
        begin
          DetectDataModified;
          OldRow := tmpGrid.SelectedCell.Row;
          tmpGrid.SelectedCell := self.OwnerComp.DataCells[self.Row-1];
          tmpGrid.RepaintSelectedRowCells(OldRow);
          tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
          self.OwnerComp.DataCells[self.Row-1].DataCellSetFocus(FALSE);
          tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row-1);
        end //if...end!!
      else
        begin
          if(tmpGrid.FDataSource <> nil)then
          if(tmpGrid.FDataSource.FDataSet <> nil)then
            begin
              tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,0);
              tmpGrid.GridTopDataPos := -1;
              tmpGrid.SetDBGridMoveDataCursor;
              tmpGrid.IsCursorUpChangeGridPostData   := TRUE;
              tmpGrid.IsCursorDownChangeGridPostData := FALSE;
              tmpGrid.FDataSource.FDataSet.RecDataSet.RecPrior;
              tmpGrid.SelectedCell := self.OwnerComp.DataCells[0];
              tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
              self.OwnerComp.DataCells[0].DataCellSetFocus(FALSE);
            end;//if...end!
        end;//else...end!
      tmpGrid.DataSource.ResetAllGridGridTopDataPos;
      RefreshDetailData;
      tmpGrid.FDataSource.RefreshNavigator;
    end;//if...end!!
  //---------------------------------------------------------------------------
  if(Key = 40)then //VK_DOWN
    begin
      if(tmpGrid.FDataSource <> nil)then
      if(tmpGrid.FDataSource.FDataSet <> nil)then
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.DbState = 'Insert')then Exit;

      if(self.Row+1 <= self.OwnerComp.FDataCellList.Count-1)then
        begin
          DetectDataModified;
          OldRow := tmpGrid.SelectedCell.Row;
          tmpGrid.SelectedCell := self.OwnerComp.DataCells[self.Row+1];
          tmpGrid.RepaintSelectedRowCells(OldRow);
          tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
          self.OwnerComp.DataCells[self.Row+1].DataCellSetFocus(FALSE);
          tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row+1);
        end //if...end!!
      else
        begin
          if(tmpGrid.FDataSource <> nil)then
          if(tmpGrid.FDataSource.FDataSet <> nil)then
            begin
              tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row);
              tmpGrid.IsCursorPosInGridDisplayArea := FALSE;
              tmpGrid.GridTopDataPos := -1;
              tmpGrid.SetDBGridMoveDataCursor;
              tmpGrid.IsCursorUpChangeGridPostData   := FALSE;
              tmpGrid.IsCursorDownChangeGridPostData := TRUE;
              tmpGrid.FDataSource.FDataSet.RecDataSet.RecNext;
              tmpGrid.SelectedCell := self.OwnerComp.DataCells[self.Row];
              tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
              self.OwnerComp.DataCells[self.Row].DataCellSetFocus(FALSE);
            end;//if...end!!
        end;//else...end!!
      tmpGrid.DataSource.ResetAllGridGridTopDataPos;  
      RefreshDetailData;
      tmpGrid.FDataSource.RefreshNavigator;
    end;//if...end!!
  //---------------------------------------------------------------------------
  if(Key = 36)then //VK_HOME
    begin
      tmpGrid := TGridcolumns(self.OwnerComp.GetOwner).FGrid;
      if(self.Col-1 >= 0)then
        begin
          tmpGrid.ResetGridScrollView;
          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[Self.Col-1]) = FALSE)then
            tmpGrid.Columns.DataCells[self.Col-1,self.Row].DataCellSetFocus(FALSE)
          else
            tmpGrid.Columns.DataCellsW[self.Col-1,self.Row].DataCellSetFocus(FALSE);
        end;//if...end!!
    end;//if...end!!
  //------------------------------------------------------------------------
  if(Key <> 13)then//VK_Enter:]wgBzEnter(bOnKeyPressed)
                   //ҥHƳBz
    begin
      case self.OwnerComp.FEditStyle of
        CES_None    :self.FValue := tmpGrid.tmpEdit.Text;
        CES_PickList
          :if(self.OwnerComp.FUseSelfComboBox = FALSE)then
             self.FValue := tmpGrid.tmpCombo.Text
           else self.FValue := self.OwnerComp.ColumnCombo.Text;
        CES_Ellipsis:self.FValue := tmpGrid.tmpEdit.Text;
        CES_Memo    :self.FValue := tmpGrid.tmpMemo.Text;
        CES_CheckBox:if(self.OwnerComp.FBeARecordSelectColumn = FALSE)then
                       if(tmpGrid.tmpChkBox.Checked = TRUE)then
                         self.FValue := 'TRUE'
                       else self.FValue := 'FALSE';
      end;//case...end!!
  end;//if...end!! 
  //------------------------------------------------------------------------
  tmpGrid := nil;
end;

procedure TGridCell.KeyPress(var Key: Char);
var IsChangeRow,HaveDataSet:boolean;
    nextCol,nextRow,OldRow:integer;
    tmpColumn:TColumnItem;
    tmpColumns:TGridColumns;
    tmpshift:TShiftstate;
    tmpGrid:TAspFileDBGrid;
    IsPostSuccess:OleVariant;
    tmpCh:Char;
    function FindNewFocusColumn(StartColID:integer):integer;
    var i,NewColID:integer;
    begin
      NewColID := StartColID;
      for i := StartColID to tmpColumns.Count-1 do
        begin
          if(tmpColumns.Columns[i].FWithOutFocus = FALSE)then Break
          else NewColID := NewColID+1;
        end;//for...i...end!!
      result := NewColID;  
    end;
begin
  tmpGrid := nil;
  HaveDataSet := FALSE;
  if(self.FIsTitleCell = TRUE)then Exit;
  //------------------------------------------------------
  tmpGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
  tmpColumns := TGridColumns(self.OwnerComp.GetOwner);
  //------------------------------------------------------
  if(key = #13)then
    begin
      if(tmpGrid.DataSource <> nil)then
      if(tmpGrid.DataSource.DataSet <> nil)then HaveDataSet := TRUE
      else
        begin
          tmpGrid := nil;
          tmpColumns := nil;
          Exit;
        end;//else...end!!
      IsChangeRow := FALSE;
      //-------------------------------------------------------------
      if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Browse')then
        begin
          nextCol := FindNewFocusColumn(self.Col+1);
          nextRow := self.Row;
          //-------------------------------------------------
          if(self.OwnerComp.Index = tmpColumns.Count-1)then
            begin
              nextCol := FindNewFocusColumn(0);
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;//if...end!!
          //-------------------------------------------------
          if(nextCol > tmpColumns.Count-1)then
            begin
              nextCol := FindNewFocusColumn(0);
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;
          //-------------------------------------------------
          //bDBGridRowCountd򤧤ʧ@
          if(nextRow < self.OwnerComp.FDataCellList.Count)then
            begin
              tmpColumn := tmpColumns.Columns[nextCol];
              if(IsChangeRow = TRUE)then//pG!!
                begin
                  //===========================================================================
                  if(Assigned(tmpGrid.FGridNewDataPage))then tmpGrid.FGridNewDataPage(tmpGrid);
                  //===========================================================================
                  OldRow := -1;
                  if(IsColumnItemLinkUniCodeField(tmpColumn) = FALSE)then
                    begin
                      if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
                      else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
                      //----------------------------------------------------------------------------
                      if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.SelectedCellW := nil;
                      tmpGrid.SelectedCell  := self.OwnerComp.DataCells[nextRow];
                      tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.ResetGridScrollView;
                      TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
                    end//if...end!!
                  else
                    begin
                      if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
                      else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
                      //----------------------------------------------------------------------------
                      if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.SelectedCell  := nil;
                      tmpGrid.SelectedCellW := self.OwnerComp.DataCellsW[nextRow];
                      tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.ResetGridScrollView;
                      TGridCellW(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
                    end;//else...end!!
                end //if...end!!
              else
                if(IsColumnItemLinkUniCodeField(tmpColumn) = FALSE)then
                  TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(FALSE)
                else
                  TGridCellW(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(FALSE);
            end //if...end!!
          else
            begin
              tmpColumn := tmpColumns.Columns[nextCol];
              nextRow := 0;
              //===========================================================================
              if(Assigned(tmpGrid.FGridNewDataPage))then tmpGrid.FGridNewDataPage(tmpGrid);
              //===========================================================================
              OldRow := -1;
              if(IsColumnItemLinkUniCodeField(tmpColumn) = FALSE)then
                begin
                  if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
                  else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
                  //----------------------------------------------------------------------------
                  if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
                  tmpGrid.SelectedCellW := nil;
                  tmpGrid.SelectedCell  := self.OwnerComp.DataCells[nextRow];
                  tmpGrid.RepaintSelectedRowCells(OldRow);
                  TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
                end//if...end!!
              else
                begin
                  if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
                  else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
                  //----------------------------------------------------------------------------
                  if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
                  tmpGrid.SelectedCell  := nil;
                  tmpGrid.SelectedCellW := self.OwnerComp.DataCellsW[nextRow];
                  tmpGrid.RepaintSelectedRowCells(OldRow);
                  TGridCellW(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
                end;//else...end!!
            end;//else...end!!
        end;//if....Browse....end!!
      //-------------------------------------------------------------
      if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Insert')
        or((tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Edit'))then
        begin
          if(self.FIsModify = TRUE)then
            begin
              case self.OwnerComp.FEditStyle of
                CES_None    :self.FValue := tmpGrid.tmpEdit.Text;
                CES_PickList
                  :if(self.OwnerComp.FUseSelfComboBox = FALSE)then
                     self.FValue := tmpGrid.tmpCombo.Text
                   else self.FValue := self.OwnerComp.ColumnCombo.Text;
                CES_Ellipsis:self.FValue := tmpGrid.tmpEdit.Text;
                CES_Memo    :self.FValue := tmpGrid.tmpMemo.Text;
                CES_CheckBox:if(self.OwnerComp.FBeARecordSelectColumn = FALSE)then
                               if(tmpGrid.tmpChkBox.Checked = TRUE)then
                                 self.FValue := 'TRUE'
                               else self.FValue := 'FALSE';
              end;//case...end!!
            end;//if...end!!
          //------------------------------------------------------------------
          nextCol := FindNewFocusColumn(self.Col+1);
          nextRow := self.Row;
          //-------------------------------------------------
          if(self.OwnerComp.Index = tmpColumns.Count-1)then
            begin
              nextCol := FindNewFocusColumn(0);
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;//if...end!!
          //-------------------------------------------------
          if(nextCol > tmpColumns.Count-1)then
            begin
              nextCol := FindNewFocusColumn(0);
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;
          //------------------------------------------------------------------
          //bDBGridRowCountd򤧤ʧ@
          if(nextRow < self.OwnerComp.FDataCellList.Count)then
            begin
              tmpColumn := tmpColumns.Columns[nextCol];
              if(IsChangeRow = TRUE)then
                begin
                  self.InitDataCellValue;
                  //=======================================================================
                  if(Assigned(tmpGrid.FGridNewRecord))then tmpGrid.FGridNewRecord(tmpGrid);
                  //=======================================================================
                  tmpGrid.DataSource.DataSet.RecDataSet.RecPost(IsPostSuccess);
                end //if...end!!
              else self.InitDataCellValue;
              //--------------------------------------------
              if(IsColumnItemLinkUniCodeField(tmpColumn) = FALSE)then
                TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE)
              else
                TGridCellW(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
            end //if...end!!
          else
            if(nextRow = self.OwnerComp.FDataCellList.Count)then
              begin
                if(IsChangeRow = TRUE)then
                  begin
                    self.InitDataCellValue;
                    //=======================================================================
                    if(Assigned(tmpGrid.FGridNewRecord))then tmpGrid.FGridNewRecord(tmpGrid);
                    //=======================================================================
                    tmpGrid.DataSource.DataSet.RecDataSet.RecPost(IsPostSuccess);
                  end
                else self.InitDataCellValue;
              end;//if...end!!
        end;//if....Insert....end!!
      //----------------------------------------------
      if(self.OwnerComp.FUseSelfComboBox = TRUE)then
        self.OwnerComp.ColumnCombo.Visible := FALSE;
      //----------------------------------------------
      Abort;//Abort The KeyPressed #13 Message;
    end
  else
    begin
      if(tmpGrid.IsReadOnly = TRUE)then Exit;
      if(tmpGrid.DataSource <> nil)then
      if(tmpGrid.DataSource.DataSet <> nil)then
      if(tmpGrid.DataSource.DataSet.RecDataSet.IsReadOnly = FALSE)then
        begin
          self.FIsModify := TRUE;
          //--------------------------------------------------------------
          if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Browse')then
            begin
              if(tmpGrid.DataSource.DataSet.RecDataSet.CurrentRecordIsChanged = FALSE)
                and(tmpGrid.IsThisRowDataIsDifferentWithFieldData(self.Row) = FALSE)then
                begin
                  tmpGrid.DataSource.DataSet.RecDataSet.RecEdit;
                  if(trim(Key) <> '')then
                    begin
                      tmpGrid.tmpEdit.Text := tmpGrid.tmpEdit.Text+Key;
                      tmpGrid.tmpEdit.SelStart := Length(tmpGrid.tmpEdit.Text);
                    end;//if...end!!
                  Key := tmpCh;
                end
              else
                begin
                  self.FIsModify := FALSE;
                  ShowMessage( 'This record is modified by anther user !!'
                              +#10+#13
                              +'Prepareing refresh this record !!' );
                  if(tmpGrid.DataSource.DataSet.RecDataSet.UseFilter = FALSE)then
                    tmpGrid.SelectedCell.DataCellSetFocus(TRUE)
                  else
                    begin
                      tmpGrid.DataSource.DataSet.RecDataSet.UseFilter := FALSE;
                      tmpGrid.DataSource.DataSet.RecDataSet.UseFilter := TRUE;
                    end;//if...else...end!!
                  tmpGrid.tmpEdit.Visible   := FALSE;
                  tmpGrid.tmpCombo.Visible  := FALSE;
                  tmpGrid.tmpEditW.Visible  := FALSE;
                  tmpGrid.tmpComboW.Visible := FALSE;

                end;//if...else...end!!
            end;//if...end!!
        end;//if...end!!
    end;//else...end!!
  tmpGrid   := nil;
  tmpColumns:= nil;
  tmpColumn := nil;
end;

function TGridCell.IsSelected: boolean;
begin
  result := self.FIsSelect;
end;

procedure TGridCell.MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
var tmpGrid:TAspFileDbGrid;
    i,LoopCount,OldRow:integer;
    valueStr,FieldName,str:string;
    IsPostSuccess:OleVariant; 
begin
  OldRow  := -1;
  if(self.FIsTitleCell = TRUE)then Exit;
  //------------------------------------------------------
  if(self.OwnerComp.FBeARecordSelectColumn = FALSE)
    and(trim(self.OwnerComp.FFieldName) = '')
    and(self.OwnerComp.EditStyle <> CES_ClickBtn)then
    Exit;
  //------------------------------------------------------
  tmpGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
  tmpGrid.IsSelectUniCodeDataCell := FALSE;
  tmpGrid.tmpEditW.Visible  := FALSE;
  tmpGrid.tmpBtnW.Visible   := FALSE;
  tmpGrid.tmpComboW.Visible := FALSE;
  //---------------------------------------
  OldRow := -1;
  if(tmpGrid.SelectedCell <> nil)then
    OldRow := tmpGrid.SelectedCell.Row
  else
    if(tmpGrid.SelectedCellW <> nil)then
      OldRow := tmpGrid.SelectedCellW.Row;
  //============================================================================
  if(tmpGrid.DataSource <> nil)then
  if(tmpGrid.DataSource.DataSet <> nil)then
  if(tmpGrid.DataSource.DataSet.Active  = TRUE)then
  if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Edit')
    or(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Insert')then
  if(OldRow <> -1)and(OldRow <> self.Row)then
    begin
      valueStr := '';
      if(tmpGrid.SelectedCell.IsModify = TRUE)then
        begin
          case tmpGrid.SelectedCell.OwnerComp.FEditStyle of
            CES_None,CES_Ellipsis:
              begin
                valueStr := tmpGrid.tmpEdit.Text;
                tmpGrid.SelectedCell.FValue := valueStr;
              end;
            CES_PickList:
              begin
                str := '';
                valueStr := tmpGrid.tmpCombo.Text;
                for i := 1 to Length(valueStr) do
                  if(valueStr[i] <> ':')then
                    str := str+valueStr[i]
                  else
                    begin
                      valueStr := trim(str);
                      Break;
                    end;//else...end!!
                tmpGrid.SelectedCell.FValue := valueStr;
              end;
          end;//case...end!!
        end;//if...end!!
      //----------------------------------------------------------
      if(MessageDlg( 'Data is modified , Save this record ??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
        begin
          if(tmpGrid.SelectedCell.IsModify = TRUE)then
            begin
              FieldName := tmpGrid.SelectedCell.OwnerComp.DataField;
              tmpGrid.FDataSource.FDataSet.RecDataSet
                     .FieldByName[FieldName] := valueStr;
            end;//if...end!!         
          tmpGrid.FDataSource.FDataSet.RecDataSet.RecPost(IsPostSuccess);
        end
      else tmpGrid.FDataSource.FDataSet.RecDataSet.RecCancel;
    end;//if...end!!
  //==================================================================
  tmpGrid.SelectedCellW := nil;
  tmpGrid.SelectedCell  := self;
  if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
  tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCell.Row);
  tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row);
  self.DataCellSetFocus(FALSE);
  //==================================================================
  if(tmpGrid.DataSource <> nil)then
  if(tmpGrid.DataSource.DataSet <> nil)then
  if(tmpGrid.DataSource.DataSet.Active  = TRUE)then
    begin
      if(tmpGrid.DataSource.DataSet.RecDataSet.UseFilter = FALSE)then
        begin
          if(self.RecPos >= 0)then
            begin
              tmpGrid.DataSource.DataSet.RecDataSet
                                           .CursorGoToBookMark(self.RecPos);
              tmpGrid.DataSource.PostDisplayDataWithOutDbGird;
            end;//if...end!!
        end//if...end!!
      else
        if(self.FilterRecPos > 0)then
          begin
            tmpGrid.DataSource.DataSet.RecDataSet
                                         .CursorGoToBookMark(self.FilterRecPos);
            tmpGrid.DataSource.PostDisplayDataWithOutDbGird;
          end;//if...end!!
      //========================================================================
      LoopCount := tmpGrid.DataSource.DataSet.FDataSet.DetailDbCount;
      if(LoopCount > 0)then
      //for i := 0 to LoopCount-1 do
      //  begin
          tmpGrid.DataSource.DataSet.RecDataSet.RefreshAllDetailDBData;
      //  end;//for...i...end!!
      //========================================================================
    end;//if...end!!
  tmpGrid.DataSource.ResetAllGridGridTopDataPos;  
  tmpGrid.FDataSource.RefreshNavigator;
  tmpGrid := nil;
end;

procedure TGridCell.Paint;
Const txtOfs = 5;
      TitleOfs = 12;
var tx,ty,txtWidth,txtHeight,SelectCellRowID:integer;
    tgCanvas:TCanvas;
    tgGrid:TAspFileDBGrid;
    IsDoFlash:boolean;
    CompareData,ShowValue:string;
    i,pid:integer;
begin
  if(self.FIsTitleCell = TRUE)then
    begin
      if(self.OwnerComp <> nil)then
        begin
          self.Font.Assign(self.OwnerComp.FTitleFont);
          if(self.OwnerComp.FHaveLinkControl = TRUE)then
            self.OwnerComp.LinkControl
                .Font.Assign(self.OwnerComp.FLinkControlFont);
        end;//if...end!!
    end;//if...end!!
  //----------------------------------------------
  self.Canvas.Font := self.Font;
  if(self.FIsTitleCell = TRUE)then
    begin
      txtWidth := self.Canvas.TextWidth(self.OwnerComp.Title);
      if(self.Width <= TxtWidth)then
        self.OwnerComp.ColumnTitleFixColumnWidth(TxtWidth+TitleOfs);
      //-------------------------------------------------------------
      txtHeight := self.Canvas.TextHeight(self.OwnerComp.FTitle);
      if(self.Height < txtHeight)then self.Height := txtHeight;
      //----------------------------------------------------------
      inherited;
      if(trim(self.OwnerComp.FTitle) <> '')then
        begin
          case self.OwnerComp.FTitleAlign of
            TA_LEFT  :begin
                        tx := 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,self.OwnerComp.FTitle);
                      end;
            TA_Center:begin
                        tx := self.Width  div 2 - txtWidth  div 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,self.OwnerComp.FTitle);
                      end;
            TA_Right :begin
                        tx := self.Width - txtWidth-2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,self.OwnerComp.FTitle);
                      end;
          end;//case...end!!
        end;//if...end!!
    end
  else
    begin
      tgGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
      if(Assigned(tgGrid.FOnChkRecFlash) = TRUE)then
        begin
          tgGrid.FOnChkRecFlash(self.FRow,IsDoFlash,CompareData);
          if(IsDoFlash = TRUE)then
            begin
              tgGrid.Columns.Columns[0].DataCells[self.FRow].IsFlashByUser    := TRUE;
              tgGrid.Columns.Columns[0].DataCells[self.FRow].FlashCheckIsTrue := TRUE;
            end//if...end!!
          else
            begin
              tgGrid.Columns.Columns[0].DataCells[self.FRow].IsFlashByUser    := TRUE;
              tgGrid.Columns.Columns[0].DataCells[self.FRow].FlashCheckIsTrue := FALSE;
            end;//else...end!!
        end;
      //-----------------------------------------------------------------
      if(self.IsFlashByUser = TRUE)then
        begin
          inherited;
          if(Assigned(tgGrid.FOnDoRecFlash) = TRUE)then
             begin
              tgCanvas := self.Canvas;
              tgGrid.FOnDoRecFlash(self.FlashCheckIsTrue,CompareData,tgCanvas);
              tgCanvas := nil;
            end;//if...end!!
          Exit;                     
        end;//if...end!!
      Self.Canvas.Font.Color := self.OwnerComp.ColumnFontColor;
      Self.Canvas.Font.Style := self.OwnerComp.ColumnFontStyles;
      //---------------------------------------------------------------
      ShowValue := self.FValue;
      if(Assigned(self.OwnerComp.FOnFormatDisplayValue))then
        self.OwnerComp.FOnFormatDisplayValue(self.OwnerComp,ShowValue);
      //---------------------------------------------------------------
      if(self.OwnerComp.FEditStyle = CES_PickList)then
        if(self.OwnerComp.FShowPickUpListItem = TRUE)then
          begin
            for i := 0 to self.OwnerComp.PickList.Count-1 do
              begin
                if(Pos(ShowValue,self.OwnerComp.PickList[i]) = 1)then
                  begin
                    pid := i;
                    ShowValue := self.OwnerComp.PickList[i];
                    Break;
                  end;//if...end!!
              end;//for...i...end!!
          end;//if...end!!
      //-------------------------------------------------
      txtWidth  := self.Canvas.TextWidth (ShowValue);
      txtHeight := self.Canvas.TextHeight(ShowValue);
      //--------------------------------------------------------
      if(self.Width < self.OwnerComp.TitleCell.Width)then
        self.Width := self.OwnerComp.TitleCell.Width;
      if(self.Height < txtHeight)then self.Height := txtHeight;
      //--------------------------------------------------------
      if(self.OwnerComp.FUseColumnColor = TRUE)then
        Self.Canvas.Brush.Color := self.OwnerComp.FColumnColor
      else self.Canvas.Brush.Color := ClWhite;
      //--------------------------------------------------------------------------
      if(tgGrid.UseIntervalColor = TRUE)then
        if(((self.Row+1) mod 2) = 0)then
          self.Canvas.Brush.Color := $00E1F5DC;
      //--------------------------------------------------------------------------------
      SelectCellRowID := -1;
      if(tgGrid.SelectedCell <> nil)then
        SelectCellRowID := tgGrid.SelectedCell.Row
      else
        if(tgGrid.SelectedCellW <> nil)then
          SelectCellRowID := tgGrid.SelectedCellW.Row;
      //--------------------------------------------------------------------------------
      self.Canvas.Pen.Color := ClSilver;
      if(SelectCellRowID <> -1)then
      if(self.OwnerComp <> nil)then
      if(self.OwnerComp.GetOwner <> nil)then
      if(tgGrid <> nil)then
      if(self.Row < tgGrid.RowCount)then
        if(self.Row = SelectCellRowID)then
          self.Canvas.Brush.Color := tgGrid.FRecordFocusColor;
      //---------------------------------------------------
      if(self.OwnerComp.TitleCell.Width >= txtWidth)then
        self.Width := self.OwnerComp.TitleCell.Width
      else
        if(self.Width < txtWidth)then
          begin
            self.Width := txtWidth+txtOfs;
            self.OwnerComp.OffsetCellLeftPos( txtWidth+txtOfs
                                              -self.OwnerComp.TitleCell.Width);
            self.OwnerComp.TitleCell.Width := self.Width;
            self.OwnerComp.ResetDataCellsWidth(self.Width);
          end;//if...end!!
      //--------------------------------------------------------
      self.Canvas.Rectangle(0,0,self.Width,self.Height);

      if(self.OwnerComp.BeARecordSelectColumn = TRUE)then
      if(self.FIsSelect = TRUE)then
        begin
          tx := 2;  
          ty := 2;
          self.Canvas.TextOut(tx,ty,'#Selected');
        end;//if...end!!

      if(ShowValue <> '')then
        begin
          txtHeight  := self.Canvas.TextHeight(ShowValue);
          case self.OwnerComp.FColumnAlign of
            CA_Left  :begin
                        tx := 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,ShowValue);
                      end;
            CA_Center:begin
                        tx := self.Width  div 2 - txtWidth  div 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,ShowValue);
                      end;
            CA_Right :begin
                        tx := self.Width - txtWidth-2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,ShowValue);
                      end;
          end;//case...end!!
        end; //if...end!!
    end;//else...end!!
  tgGrid := nil;  
end;

procedure TGridCell.SetFCol(const Value: integer);
begin
  FCol := Value;
end;

procedure TGridCell.SetFIsModify(const Value: boolean);
begin
  FIsModify := Value;
end;

procedure TGridCell.SetFIsTitleCell(const Value: boolean);
begin
  FIsTitleCell := Value;
  if(Value = TRUE)then
    begin
      self.TabStop := FALSE;
      self.OnEnter := nil;
      self.OnExit  := nil;
    end;//if...end!!
end;

procedure TGridCell.SetFRow(const Value: integer);
begin
  FRow := Value;
end;

//TGridCellW.
Constructor TGridCellW.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Width   := 64;
  self.Height  := 26;
  self.TabStop := TRUE;
  self.RecPos  := -1;
  self.FilterRecPos := -1;
  self.OwnerComp   := nil;
end;

Destructor TGridCellW.Destroy;
begin
  self.OwnerComp := nil;
  inherited Destroy;
end;

procedure TGridCellW.DoKeyDowned(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
begin
  self.KeyDown(Key,Shift);
end;

procedure TGridCellW.DoKeyPressed(Sender:TObject;var Key: Char);
begin
  self.KeyPress(Key);
end;

procedure TGridCellW.DoOnButtonClick(Sender: TObject);
var str:string;
begin
  str := TGridColumns(self.OwnerComp.GetOwner).FGrid
            .FDataSource.FDataSet.DbState;
  if(Assigned(self.OwnerComp.FCellWBtnPressed))then
    self.OwnerComp.FCellWBtnPressed(str,self.OwnerComp,self);
end;

procedure TGridCellW.DataCellSetFocus(SeekCursorPos:boolean);
var tmpGrid:TAspFileDbGrid;
    EditMaxLength:integer;
    procedure SetActiveComboBoxW(Comp:TTntComboBox;initList:boolean);
    begin
      Comp.Style    := self.OwnerComp.FEditComboStyle;
      Comp.ImeName  := self.OwnerComp.ImeName;
      Comp.CharCase := self.OwnerComp.ColumnCharCase;
      Comp.Font     := self.Font;
      Comp.Parent   := self;
      Comp.Align    := alClient;
      Comp.Text     := self.FValue;
      Comp.OnKeyPress := self.DoKeyPressed;
      Comp.OnKeyDown  := self.DoKeyDowned;
      Comp.OnChange   := self.DoOnComboBoxChange;
      Comp.Visible    := TRUE;
      Comp.MaxLength  := EditMaxLength;
      if(initList = TRUE)and(Comp.Items.Count = 0)then
        begin
          if(Assigned(self.OwnerComp.FCellPickListInit))then
            self.OwnerComp.FCellPickListInit(self.OwnerComp)
          else
            Comp.Items.AddStrings(self.OwnerComp.FPickUpListW);
        end;//if...end!!
      if(tmpGrid.Parent.Visible = TRUE)then Comp.SetFocus;
    end;
begin
  //debug !!
  //ShowMessage( 'Col = '+IntToStr(self.FCol)
  //               +' , Row = '+IntToStr(self.FRow));
  if(self.FIsTitleCell = FALSE)then
    begin
      tmpGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
      tmpGrid.IsSelectUniCodeDataCell := TRUE;
      tmpGrid.SelectedCell   := nil;
      tmpGrid.SelectedCellW  := self;
      self.FIsModify         := FALSE;
      tmpGrid.CurrentEditRow := self.Row;
      //==================================================================================
      if(tmpGrid.FDataSource <> nil)then
      if(tmpGrid.FDataSource.FDataSet <> nil)then
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then
        begin
          if(self.RecPos >= 0)then
            begin
              if(SeekCursorPos = TRUE)then
                tmpGrid.FDataSource.FDataSet.RecDataSet.GoToBookMark(self.RecPos)
              else
                begin
                  tmpGrid.FDataSource.FDataSet.RecDataSet
                                            .CursorGoToBookMark(self.RecPos);
                  tmpGrid.FDataSource.PostDisplayDataWithOutDbGird;
                end;//if...else...end!!
            end //if...end!!
          else
            if(self.FilterRecPos >= 0)then
              begin
                if(SeekCursorPos = TRUE)then
                  tmpGrid.FDataSource.FDataSet.RecDataSet
                                            .GoToBookMark(self.FilterRecPos)
                else
                  begin
                    tmpGrid.FDataSource.FDataSet.RecDataSet
                                      .CursorGoToBookMark(self.FilterRecPos);
                    tmpGrid.FDataSource.PostDisplayDataWithOutDbGird;
                  end;
              end;//if...end!!
        end;//if...end!!
      //==================================================================================
      if(csDesigning in tmpGrid.ComponentState)then
        begin
          tmpGrid := nil;
          Exit;
        end;//if...end!!
      //--------------------------------------------------------------
      if(tmpGrid.tmpComboW.Parent <> nil)then
        begin
          tmpGrid.tmpComboW.Text   := #0;
          tmpGrid.tmpComboW.ItemIndex := -1;
        end;//if...end!!
      //--------------------------------------------------------------
      tmpGrid.tmpEdit .Visible   := FALSE;
      tmpGrid.tmpCombo.Visible   := FALSE;
      tmpGrid.tmpBtn  .Visible   := FALSE;
      tmpGrid.tmpChkBox.Visible  := FALSE;
      tmpGrid.tmpMemo.Visible    := FALSE;
      //----------------------------------
      tmpGrid.tmpEditW .Visible  := FALSE;
      tmpGrid.tmpComboW.Visible  := FALSE;
      tmpGrid.tmpBtnW  .Visible  := FALSE;          
      tmpGrid.tmpChkBoxW.Visible := FALSE;
      tmpGrid.tmpMemoW.Visible   := FALSE;
      if(self.OwnerComp.ColumnCombo <> nil)then
        self.OwnerComp.ColumnCombo.Visible := FALSE;
      if(self.OwnerComp.ColumnComboW <> nil)then
        self.OwnerComp.ColumnComboW.Visible := FALSE;
      //---------------------------------
      EditMaxLength := 0;
      EditMaxLength
        := tmpGrid.FDataSource.FDataSet.RecDataSet
                  .FieldDataSize[self.OwnerComp.DataField];
      Application.ProcessMessages;
      //--------------------------------------------------------------
      self.FOldValue := self.FValue; 
      if(tmpGrid.IsReadOnly = TRUE)then Exit;
      if(self.OwnerComp.FWithOutFocus = TRUE)then Exit;
      case self.OwnerComp.FEditStyle of
        CES_None:begin
                   tmpGrid.tmpEditW.ImeName    := self.OwnerComp.ImeName;
                   tmpGrid.tmpEditW.CharCase   := self.OwnerComp.ColumnCharCase;
                   tmpGrid.tmpEditW.Parent     := self;
                   tmpGrid.tmpEditW.Visible    := TRUE;
                   tmpGrid.tmpEditW.OnKeyPress := self.DoKeyPressed;
                   tmpGrid.tmpEditW.OnKeyDown  := self.DoKeyDowned;
                   tmpGrid.tmpEditW.Font       := self.Font;
                   tmpGrid.tmpEditW.Text       := self.FValue;
                   tmpGrid.tmpEditW.Align      := alClient;
                   tmpGrid.tmpEditW.MaxLength  := EditMaxLength;
                   if(tmpGrid.Parent.Visible = TRUE)then tmpGrid.tmpEditW.SetFocus;
                 end;
        CES_PickList:begin
                       if(tmpGrid.DataSource.DataSet.DbState = 'Browse')then
                         begin
                           if(self.OwnerComp.FPickUpListW.Count <= 10)then
                             begin
                               SetActiveComboBoxW(tmpGrid.tmpComboW,TRUE);
                             end//if...end!!
                           else
                             SetActiveComboBoxW(tmpGrid.tmpComboW,FALSE);
                         end//if...end!!
                       else SetActiveComboBoxW(self.OwnerComp.ColumnComboW,TRUE);
                     end;
        CES_Ellipsis:begin
                       tmpGrid.tmpBtnW.Parent     := self;
                       tmpGrid.tmpBtnW.Visible    := TRUE;
                       tmpGrid.tmpBtnW.Width      := 20;
                       tmpGrid.tmpBtnW.Align      := alRight;
                       tmpGrid.tmpBtnW.OnClick := self.DoOnButtonClick;
                       if(tmpGrid.Parent.Visible = TRUE)then tmpGrid.tmpBtnW.SetFocus;
                       //---------------------------------------------------------------
                       tmpGrid.tmpEditW.ImeName    := self.OwnerComp.ImeName;
                       tmpGrid.tmpEditW.CharCase   := self.OwnerComp.ColumnCharCase;
                       tmpGrid.tmpEditW.Parent     := self;
                       tmpGrid.tmpEditW.Visible    := TRUE;
                       tmpGrid.tmpEditW.OnKeyPress := self.DoKeyPressed;
                       tmpGrid.tmpEditW.OnKeyDown  := self.DoKeyDowned;
                       tmpGrid.tmpEditW.Font       := self.Font;
                       tmpGrid.tmpEditW.Text       := self.FValue;
                       tmpGrid.tmpEditW.Align      := alClient;
                       tmpGrid.tmpEditW.MaxLength  := EditMaxLength;
                       if(tmpGrid.Parent.Visible = TRUE)then tmpGrid.tmpEditW.SetFocus;
                     end;
            CES_Memo:begin
                       tmpGrid.tmpMemoW.ImeName    := self.OwnerComp.ImeName;
                       tmpGrid.tmpMemoW.Parent     := self;
                       tmpGrid.tmpMemoW.Visible    := TRUE;
                       tmpGrid.tmpMemoW.OnKeyPress := self.DoKeyPressed;
                       tmpGrid.tmpMemoW.OnKeyDown  := self.DoKeyDowned;
                       tmpGrid.tmpMemoW.Font       := self.Font;
                       tmpGrid.tmpMemoW.Text       := self.FValue;
                       tmpGrid.tmpMemoW.Align      := alClient;
                       tmpGrid.tmpMemoW.MaxLength  := EditMaxLength;
                       if(tmpGrid.Parent.Visible = TRUE)then
                         tmpGrid.tmpMemoW.SetFocus;
                     end;
        CES_CheckBox:begin
                       tmpGrid.tmpChkBoxW.Parent     := self;
                       tmpGrid.tmpChkBoxW.Visible    := TRUE;
                       tmpGrid.tmpChkBoxW.OnKeyPress := self.DoKeyPressed;
                       tmpGrid.tmpChkBoxW.OnKeyDown  := self.DoKeyDowned;
                       tmpGrid.tmpChkBoxW.Font       := self.Font;
                       if(self.FValue = 'Y')or(self.FValue = 'y')
                         or(self.FValue = 'YES')or(self.FValue = 'yes')
                         or(self.FValue = 'TRUE')or(self.FValue = 'true')
                         or(self.FValue = 'True')then
                         tmpGrid.tmpChkBoxW.Checked := TRUE
                       else tmpGrid.tmpChkBoxW.Checked := FALSE;
                       //------------------------------------------------
                       tmpGrid.tmpChkBoxW.Align := alClient;
                       if(tmpGrid.Parent.Visible = TRUE)then
                         tmpGrid.tmpChkBoxW.SetFocus;
                     end;
      end;//case...end!!
    end;//if...end!!
  tmpGrid := nil;
end;

procedure TGridCellW.DoOnComboBoxChange(Sender: TObject);
var str:string;
begin
  str := TGridColumns(self.OwnerComp.GetOwner).FGrid
            .FDataSource.FDataSet.DbState;
  self.FIsModify := TRUE;
  self.InitDataCellValue;
  if(Assigned(self.OwnerComp.FCellWComboBoxSelected))then
    self.OwnerComp.FCellWComboBoxSelected(str,self.OwnerComp,self);
end;

function TGridCellW.GetAsUniCodeStr:WideString;
begin
  result := self.FValue;
end;

procedure TGridCellW.SetAsUniCodeStr(const Value:WideString);
var repaintYN:boolean;
    str:string;
begin
  str := TGridColumns(self.OwnerComp.GetOwner).FGrid
            .FDataSource.FDataSet.DbState;
  if(self.FValue <> Value)then repaintYN := TRUE;
  self.FValue := Value;
  if(Assigned(self.OwnerComp.FCellWGetValue))then
    self.OwnerComp.FCellWGetValue(str,self.OwnerComp,self);
  //----------------------------------------------------
  if(repaintYN = TRUE)then self.Invalidate;
end;

function TGridCellW.GetEditOwner: TColumnItem;
begin
  result := self.OwnerComp;
end;

procedure TGridCellW.PutCellData(inCell: TGridCell);
begin
  if(inCell = nil)then Exit;
  self.IsTitleCell := inCell.IsTitleCell;
  self.IsModify    := inCell.IsModify;
  self.Col         := inCell.Col;
  self.Row         := inCell.Row;
  self.RecPos      := inCell.RecPos;
  self.FilterRecPos:= inCell.FilterRecPos;
  self.FValue      := inCell.FValue;
  self.FOldValue   := inCell.FOldValue;
end;

procedure TGridCellW.ClearCellData;
begin
  self.RecPos       := -1;
  Self.FilterRecPos := -1;
  self.FValue       := '';
  self.FOldValue    := '';
  self.Invalidate;
end;

function TGridCellW.GetOldValue:WideString;
begin
  result := self.FOldValue;
end;

procedure TGridCellW.SetOldValue(const Value:WideString);
begin
  self.FOldValue := Value;
end;

procedure TGridCellW.InitDataCellValue;
var tmpGrid:TAspFileDBGrid;
    FieldStr:string;
    ValueStr:WideString;
begin
  if(self.FIsModify = TRUE)then
    begin
      FieldStr := trim(self.OwnerComp.DataField);
      tmpGrid  := TGridColumns(self.OwnerComp.GetOwner).FGrid;

      if(tmpGrid.DataSource <> nil)then
      if(tmpGrid.DataSource.DataSet <> nil)then
        begin
          if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Browse')then
            begin
              tmpGrid.DataSource.DataSet.RecDataSet.RecEdit;
            end;//if...end!!
        end;//if...end!!

      case self.OwnerComp.FEditStyle of
        CES_None,CES_Ellipsis : ValueStr := tmpGrid.tmpEditW.Text;
        CES_PickList
          :if(self.OwnerComp.FUseSelfComboBox = FALSE)then
             ValueStr := tmpGrid.tmpComboW.Text
           else ValueStr := self.OwnerComp.ColumnComboW.Text; 
      end;//case...end!!

      self.FValue := ValueStr;

      if(Assigned(self.OwnerComp.FCellWGetValue))then
        self.OwnerComp.FCellWGetValue(tmpGrid.DataSource.DataSet.DbState
                                       ,self.OwnerComp,self);
      tmpGrid := nil;
      //self.FIsModify := FALSE;
    end;//if...end!!
end;

procedure TGridCellW.KeyDown(var Key: Word; Shift: TShiftState);
var tmpGrid:TAspFileDBGrid;
    tmpCol,tmpRow,OldRow:integer;
    FieldName:string;
    valueStr:WideString;
    IsPostSuccess:OleVariant;
    procedure RefreshDetailData;
    var i,LoopCount:integer;
    begin
      //========================================================================
      LoopCount := tmpGrid.DataSource.DataSet.FDataSet.DetailDbCount;
      if(LoopCount > 0)then
      //for i := 0 to LoopCount-1 do
      //  begin
          tmpGrid.DataSource.DataSet.RecDataSet.RefreshAllDetailDBData;
      //  end;//for...i...end!!
      //========================================================================
    end;

    procedure DetectDataModified;
    begin
      if(tmpGrid = nil)then Exit;
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.DbState = 'Edit')then
        begin
          valueStr := #0;
          if(tmpGrid.SelectedCellW.IsModify = TRUE)then
            begin
              case tmpGrid.SelectedCellW.OwnerComp.FEditStyle of
                CES_None,CES_Ellipsis: valueStr := tmpGrid.tmpEditW.Text;
                CES_PickList         : valueStr := tmpGrid.tmpComboW.Text;
              end;//case...end!!
              //if(trim(valueStr) <> '')then
             tmpGrid.SelectedCellW.FValue := valueStr;
            end;//if...end!!
          if(MessageDlg( 'Data is modified , save this record ??'
                        ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
            begin
              FieldName := tmpGrid.SelectedCellW.OwnerComp.DataField;
              tmpGrid.FDataSource.FDataSet.RecDataSet
                                 .FieldByNameW[FieldName] := valueStr;
              tmpGrid.FDataSource.FDataSet.RecDataSet.RecPost(IsPostSuccess);
            end
          else tmpGrid.FDataSource.FDataSet.RecDataSet.RecCancel;
        end;//if...end!!
    end;
begin
  Application.ProcessMessages;
  tmpGrid := TGridcolumns(self.OwnerComp.GetOwner).FGrid;
  
  if(tmpGrid.IsReadOnly = TRUE)then Exit;

  OldRow := -1;
  if(tmpGrid.SelectedCellW <> nil)then
    OldRow := tmpGrid.SelectedCellW.Row;
  if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
  if(Key = 38)then //VK_UP
    begin
      if(tmpGrid.FDataSource <> nil)then
      if(tmpGrid.FDataSource.FDataSet <> nil)then
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.DbState = 'Insert')then Exit;
      if(self.Row-1 >= 0)then
        begin
          tmpGrid.IsSelectUniCodeDataCell := TRUE;
          DetectDataModified;
          OldRow := tmpGrid.SelectedCellW.Row;
          tmpGrid.SelectedCellW := self.OwnerComp.DataCellsW[self.Row-1];
          tmpGrid.RepaintSelectedRowCells(OldRow);
          tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
          self.OwnerComp.DataCellsW[self.Row-1].DataCellSetFocus(FALSE);
          tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row-1);
        end //if...end!!
      else
        begin
          if(tmpGrid.FDataSource <> nil)then
          if(tmpGrid.FDataSource.FDataSet <> nil)then
            begin
              tmpGrid.IsSelectUniCodeDataCell := TRUE;
              tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,0);
              tmpGrid.GridTopDataPos := -1;
              tmpGrid.SetDBGridMoveDataCursor;
              tmpGrid.IsCursorUpChangeGridPostData   := TRUE;
              tmpGrid.IsCursorDownChangeGridPostData := FALSE;
              tmpGrid.FDataSource.FDataSet.RecDataSet.RecPrior;
              tmpGrid.SelectedCellW := self.OwnerComp.DataCellsW[0];
              tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
              self.OwnerComp.DataCellsW[0].DataCellSetFocus(FALSE);
            end;//if...end!
        end;//else...end!
      tmpGrid.DataSource.ResetAllGridGridTopDataPos;
      RefreshDetailData;
      tmpGrid.FDataSource.RefreshNavigator;
    end;//if...end!!
  //---------------------------------------------------------------------------
  if(Key = 40)then //VK_DOWN
    begin
      if(tmpGrid.FDataSource <> nil)then
      if(tmpGrid.FDataSource.FDataSet <> nil)then
      if(tmpGrid.FDataSource.FDataSet.RecDataSet.DbState = 'Insert')then Exit;

      if(self.Row+1 <= self.OwnerComp.FDataCellList.Count-1)then
        begin
          tmpGrid.IsSelectUniCodeDataCell := TRUE;
          DetectDataModified;
          OldRow := tmpGrid.SelectedCellW.Row;
          tmpGrid.SelectedCellW := self.OwnerComp.DataCellsW[self.Row+1];
          tmpGrid.RepaintSelectedRowCells(OldRow);
          tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
          self.OwnerComp.DataCellsW[self.Row+1].DataCellSetFocus(FALSE);
          tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row+1);
        end //if...end!!
      else
        begin
          if(tmpGrid.FDataSource <> nil)then
          if(tmpGrid.FDataSource.FDataSet <> nil)then
            begin
              tmpGrid.IsSelectUniCodeDataCell := TRUE;
              tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row);
              tmpGrid.IsCursorPosInGridDisplayArea := FALSE;
              tmpGrid.GridTopDataPos := -1;
              tmpGrid.SetDBGridMoveDataCursor;
              tmpGrid.IsCursorUpChangeGridPostData   := FALSE;
              tmpGrid.IsCursorDownChangeGridPostData := TRUE;
              tmpGrid.FDataSource.FDataSet.RecDataSet.RecNext;
              tmpGrid.SelectedCellW := self.OwnerComp.DataCellsW[self.Row];
              tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
              self.OwnerComp.DataCellsW[self.Row].DataCellSetFocus(FALSE);
            end;//if...end!!
        end;//else...end!!
      tmpGrid.DataSource.ResetAllGridGridTopDataPos;
      RefreshDetailData;
      tmpGrid.FDataSource.RefreshNavigator;
    end;//if...end!!
  //---------------------------------------------------------------------------
  if(Key = 36)then //VK_HOME
    begin
      tmpGrid := TGridcolumns(self.OwnerComp.GetOwner).FGrid;
      if(self.Col-1 >= 0)then
        begin
          tmpGrid.ResetGridScrollView;
          if(IsColumnItemLinkUniCodeField(tmpGrid.Columns.Columns[Self.Col-1]) = FALSE)then
            begin
              tmpGrid.IsSelectUniCodeDataCell := FALSE;
              tmpGrid.Columns.DataCells[self.Col-1,self.Row].DataCellSetFocus(FALSE);
            end//if...end
          else
            begin
              tmpGrid.IsSelectUniCodeDataCell := TRUE;
              tmpGrid.Columns.DataCellsW[self.Col-1,self.Row].DataCellSetFocus(FALSE);
            end;//else...end!!
        end;//if...end!!
    end;//if...end!!
  tmpGrid := nil;
end;

procedure TGridCellW.KeyPress(var Key: Char);
var IsChangeRow,HaveDataSet:boolean;
    nextCol,nextRow,OldRow:integer;
    tmpColumn:TColumnItem;
    tmpColumns:TGridColumns;
    tmpshift:TShiftstate;
    tmpGrid:TAspFileDBGrid;  
    IsPostSuccess:OleVariant;
    tmpCh:Char;
    function FindNewFocusColumn(StartColID:integer):integer;
    var i,NewColID:integer;
    begin
      NewColID := StartColID;
      for i := StartColID to tmpColumns.Count-1 do
        begin
          if(tmpColumns.Columns[i].FWithOutFocus = FALSE)then Break
          else NewColID := NewColID+1;
        end;//for...i...end!!
      result := NewColID;  
    end;
begin
  tmpGrid := nil;
  HaveDataSet := FALSE;
  if(self.FIsTitleCell <> FALSE)then Exit;
  //------------------------------------------------------
  tmpGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
  tmpColumns := TGridColumns(self.OwnerComp.GetOwner);
  //------------------------------------------------------
  if(key = #13)then
    begin
      if(tmpGrid.DataSource <> nil)then
      if(tmpGrid.DataSource.DataSet <> nil)then HaveDataSet := TRUE
      else
        begin
          tmpGrid := nil;
          tmpColumns := nil;
          Exit;
        end;//else...end!!
      IsChangeRow := FALSE;
      //-------------------------------------------------------------
      if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Browse')then
        begin
          nextCol := FindNewFocusColumn(self.Col+1);
          nextRow := self.Row;
          //-------------------------------------------------
          if(self.OwnerComp.Index = tmpColumns.Count-1)then
            begin
              nextCol := FindNewFocusColumn(0);
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;//if...end!!
          //-------------------------------------------------  
          if(nextCol > tmpColumns.Count-1)then
            begin
              nextCol := FindNewFocusColumn(0);
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;
          //------------------------------------------------------------  
          if(nextRow < self.OwnerComp.FDataCellList.Count)then
            begin
              tmpColumn := tmpColumns.Columns[nextCol];
              if(IsChangeRow = TRUE)then
                begin
                  //===========================================================================
                  if(Assigned(tmpGrid.FGridNewDataPage))then tmpGrid.FGridNewDataPage(tmpGrid);
                  //===========================================================================
                  OldRow := -1;
                  if(IsColumnItemLinkUniCodeField(tmpColumn) = FALSE)then
                    begin
                      if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
                      else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
                      //----------------------------------------------------------------------------
                      if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.SelectedCellW := nil;
                      tmpGrid.SelectedCell  := self.OwnerComp.DataCells[nextRow];
                      tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.ResetGridScrollView;
                      TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
                    end//if...end!!
                  else
                    begin
                      if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
                      else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
                      //----------------------------------------------------------------------------
                      if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.SelectedCellW := nil;
                      tmpGrid.SelectedCell  := self.OwnerComp.DataCells[nextRow];
                      tmpGrid.RepaintSelectedRowCells(OldRow);
                      tmpGrid.ResetGridScrollView;
                      TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
                    end;//else...end!!
                end //if...end!!
              else
                if(IsColumnItemLinkUniCodeField(tmpColumn) = FALSE)then
                  TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(FALSE)
                else
                  TGridCellW(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(FALSE);
            end //if...end!!
          else
            begin
              tmpColumn := tmpColumns.Columns[nextCol];
              nextRow := 0;
              //===========================================================================
              if(Assigned(tmpGrid.FGridNewDataPage))then tmpGrid.FGridNewDataPage(tmpGrid);
              //===========================================================================
              OldRow := -1;
              if(tmpGrid.SelectedCell <> nil)then OldRow := tmpGrid.SelectedCell.Row
              else if(tmpGrid.SelectedCellW <> nil)then OldRow := tmpGrid.SelectedCellW.Row;
              //----------------------------------------------------------------------------
              if(OldRow >= 0)then tmpGrid.RepaintSelectedRowCells(OldRow);
              tmpGrid.SelectedCell := self.OwnerComp.DataCells[nextRow];
              tmpGrid.RepaintSelectedRowCells(OldRow);
              TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
            end;//else...end!!
        end;//if....Browse....end!!
      //-------------------------------------------------------------
      if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Insert')
        or((tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Edit'))then
        begin
          if(self.FIsModify = TRUE)then
            begin
              case self.OwnerComp.FEditStyle of
                CES_None    :self.FValue := tmpGrid.tmpEditW.Text;
                CES_PickList
                  :if(self.OwnerComp.FUseSelfComboBox = FALSE)then
                     self.FValue := tmpGrid.tmpComboW.Text
                   else self.FValue := self.OwnerComp.ColumnComboW.Text;
                CES_Ellipsis:self.FValue := tmpGrid.tmpEditW.Text;
                CES_Memo    :self.FValue := tmpGrid.tmpMemoW.Text;
                CES_CheckBox:if(self.OwnerComp.FBeARecordSelectColumn = FALSE)then
                               if(tmpGrid.tmpChkBoxW.Checked = TRUE)then
                                 self.FValue := PChar('TRUE')
                               else self.FValue := PChar('FALSE');
              end;//case...end!!
            end;//if...end!!
          //-------------------------------------------------------
          nextCol := self.Col+1;
          nextRow := self.Row;
          if(self.OwnerComp.Index = tmpColumns.Count-1)then
            begin
              nextCol := 0;
              nextRow := self.Row+1;
              IsChangeRow := TRUE;
            end;//if...end!!
          //-------------------------------------------------------
          if(nextRow < self.OwnerComp.FDataCellList.Count)then
            begin
              tmpColumn := tmpColumns.Columns[nextCol];
              if(IsChangeRow = TRUE)then
                begin
                  self.InitDataCellValue;
                  //=======================================================================
                  if(Assigned(tmpGrid.FGridNewRecord))then tmpGrid.FGridNewRecord(tmpGrid);
                  //=======================================================================
                  tmpGrid.DataSource.DataSet.RecDataSet.RecPost(IsPostSuccess);
                end //if...end!!
              else self.InitDataCellValue;
              TGridCell(tmpColumn.FDataCellList.Objects[nextRow]).DataCellSetFocus(TRUE);
            end //if...end!!
          else
            if(nextRow = self.OwnerComp.FDataCellList.Count)then
              begin
                if(IsChangeRow = TRUE)then
                  begin
                    self.InitDataCellValue;
                    //=======================================================================
                    if(Assigned(tmpGrid.FGridNewRecord))then tmpGrid.FGridNewRecord(tmpGrid);
                    //=======================================================================
                    tmpGrid.DataSource.DataSet.RecDataSet.RecPost(IsPostSuccess);
                  end
                else self.InitDataCellValue;
              end;//if...end!!
        end;//if....Insert....end!!
      //----------------------------------------------
      if(self.OwnerComp.FUseSelfComboBox = TRUE)then
        self.OwnerComp.ColumnComboW.Visible := FALSE; 
      //----------------------------------------------  
      Abort;//Abort The KeyPressed #13 Message;
    end
  else
    begin
      if(tmpGrid.IsReadOnly = TRUE)then Exit;
      if(tmpGrid.DataSource <> nil)then
      if(tmpGrid.DataSource.DataSet <> nil)then
      if(tmpGrid.DataSource.DataSet.RecDataSet.IsReadOnly = FALSE)then
        begin
          self.FIsModify := TRUE;
          if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Browse')then
            begin
              if(tmpGrid.DataSource.DataSet.RecDataSet.CurrentRecordIsChanged = FALSE)
                and(tmpGrid.IsThisRowDataIsDifferentWithFieldData(self.Row) = FALSE)then
                begin
                  tmpGrid.DataSource.DataSet.RecDataSet.RecEdit;
                  if(trim(Key) <> '')then
                    begin
                      tmpGrid.tmpEdit.Text := tmpGrid.tmpEdit.Text+Key;
                      tmpGrid.tmpEdit.SelStart := Length(tmpGrid.tmpEdit.Text);
                    end;//if...end!!
                  Key := tmpCh;
                end
              else
                begin
                  self.FIsModify := FALSE;
                  (*
                  ShowMessage( 'nק諸oƤwgQLϥΪ̭קLF!!'
                              +#10+#13
                              +'ǳƧsثe̷s!!' );
                  *)
                  ShowMessage( 'This record is modified by anther user !!'
                              +#10+#13
                              +'Prepareing refresh this record !!' );            
                  if(tmpGrid.DataSource.DataSet.RecDataSet.UseFilter = FALSE)then
                    tmpGrid.SelectedCell.DataCellSetFocus(TRUE)
                  else
                    begin
                      tmpGrid.DataSource.DataSet.RecDataSet.UseFilter := FALSE;
                      tmpGrid.DataSource.DataSet.RecDataSet.UseFilter := TRUE;
                    end;//if...else...end!!
                  tmpGrid.tmpEdit.Visible    := FALSE;
                  tmpGrid.tmpCombo.Visible   := FALSE;
                  tmpGrid.tmpEditW.Visible    := FALSE;
                  tmpGrid.tmpComboW.Visible   := FALSE;
                end;//if...else...end!!
            end;//if...end!!
        end;//if...end!!
    end;//else...end!!
  tmpGrid    := nil;
  tmpColumns := nil;
  tmpColumn  := nil;
end;

procedure TGridCellW.MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
var tmpGrid:TAspFileDbGrid;
    i,LoopCount,OldRow:integer;
    valueStr :WideString;
    FieldName:string;
    IsPostSuccess:OleVariant;
begin
  OldRow  := -1;
  if(self.FIsTitleCell = TRUE)then Exit;
  tmpGrid := TGridColumns(self.OwnerComp.GetOwner).FGrid;
  tmpGrid.IsSelectUniCodeDataCell := TRUE;
  //---------------------------------------
  tmpGrid.tmpEdit .Visible := FALSE;
  tmpGrid.tmpBtn  .Visible := FALSE;
  tmpGrid.tmpCombo.Visible := FALSE;
  //---------------------------------------
  OldRow := -1;
  if(tmpGrid.SelectedCell <> nil)then
    OldRow := tmpGrid.SelectedCell.Row
  else
    if(tmpGrid.SelectedCellW <> nil)then
      OldRow := tmpGrid.SelectedCellW.Row;
  //============================================================================
  if(tmpGrid.DataSource <> nil)then
  if(tmpGrid.DataSource.DataSet <> nil)then
  if(tmpGrid.DataSource.DataSet.Active  = TRUE)then
  if(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Edit')
    or(tmpGrid.DataSource.DataSet.RecDataSet.DbState = 'Insert')then
  if(OldRow <> -1)and(OldRow <> self.Row)then
    begin
      valueStr := #0;
      if(tmpGrid.SelectedCellW.IsModify = TRUE)then
        begin
          case tmpGrid.SelectedCellW.OwnerComp.FEditStyle of
            CES_None,CES_Ellipsis: valueStr := tmpGrid.tmpEditW.Text;
            CES_PickList         : valueStr := tmpGrid.tmpComboW.Text;
          end;//case...end!!
          //if(trim(valueStr) <> '')then
          tmpGrid.SelectedCellW.FValue := valueStr;
        end;//if...end!!
      //----------------------------------------------------------
      if(MessageDlg( 'Data is modified , Save this record ??'
                    ,mtConfirmation, [mbYes,mbNo],0) = mrYes)then
        begin
          if(tmpGrid.SelectedCellW.IsModify = TRUE)then
            begin
              FieldName := tmpGrid.SelectedCellW.OwnerComp.DataField;
              tmpGrid.FDataSource.FDataSet.RecDataSet
                     .FieldByNameW[FieldName] := valueStr;
            end;//if...end!!         
          tmpGrid.FDataSource.FDataSet.RecDataSet.RecPost(IsPostSuccess);
        end
      else tmpGrid.FDataSource.FDataSet.RecDataSet.RecCancel;
    end;//if...end!!
  //============================================================================
  tmpGrid.SelectedCell  := nil;
  tmpGrid.SelectedCellW := self;
  if(OldRow >= 0)then
    tmpGrid.RepaintSelectedRowCells(OldRow);
  tmpGrid.RepaintSelectedRowCells(tmpGrid.SelectedCellW.Row);
  tmpGrid.DataSource.ResetDBGridSelectCell(tmpGrid,self.Col,self.Row);
  self.DataCellSetFocus(FALSE);

  if(tmpGrid.DataSource <> nil)then
  if(tmpGrid.DataSource.DataSet <> nil)then
  if(tmpGrid.DataSource.DataSet.Active  = TRUE)then
    begin
      if(tmpGrid.DataSource.DataSet.RecDataSet.UseFilter = FALSE)then
        begin
          if(self.RecPos >= 0)then
            begin
              tmpGrid.DataSource.DataSet.RecDataSet
                                           .CursorGoToBookMark(self.RecPos);
              tmpGrid.DataSource.PostDisplayDataWithOutDbGird;
            end;//if...end!!
        end//if...end!!
      else
        if(self.FilterRecPos > 0)then
          begin
            tmpGrid.DataSource.DataSet.RecDataSet
                                         .CursorGoToBookMark(self.FilterRecPos);
            tmpGrid.DataSource.PostDisplayDataWithOutDbGird;
          end;//if...end!!
      //========================================================================
      LoopCount := tmpGrid.DataSource.DataSet.FDataSet.DetailDbCount;
      if(LoopCount > 0)then
      //for i := 0 to LoopCount-1 do
      //  begin
          tmpGrid.DataSource.DataSet.RecDataSet.RefreshAllDetailDBData;
      //  end;//for...i...end!!
      //========================================================================
    end;//if...end!!
  tmpGrid.DataSource.ResetAllGridGridTopDataPos;
  tmpGrid.FDataSource.RefreshNavigator;
  tmpGrid := nil;
end;

procedure TGridCellW.Paint;
Const txtOfs = 5;
      TitleOfs = 12;
var ShowValue:WideString;
    tx,ty,txtWidth,txtHeight,SelectCellRowID,i:integer;
begin
  self.Canvas.Font := self.Font;
  if(self.FIsTitleCell = TRUE)then
    begin
      txtWidth := self.Canvas.TextWidth(self.OwnerComp.Title);
      if(self.Width <= TxtWidth)then
        self.OwnerComp.ColumnTitleFixColumnWidth(TxtWidth+TitleOfs);
      //----------------------------------------------------------------------
      txtHeight := self.Canvas.TextHeight(self.OwnerComp.FTitle);
      if(self.Height < txtHeight)then self.Height := txtHeight;
      //----------------------------------------------------------------------
      inherited;
      if(trim(self.OwnerComp.FTitle) <> '')then
        begin
          case self.OwnerComp.FTitleAlign of
            TA_LEFT  :begin
                        tx := 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,self.OwnerComp.FTitle);
                      end;
            TA_Center:begin
                        tx := self.Width  div 2 - txtWidth  div 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,self.OwnerComp.FTitle);
                      end;
            TA_Right :begin
                        tx := self.Width - txtWidth-2;
                        ty := self.Height div 2 - txtHeight div 2;
                        self.Canvas.TextOut(tx,ty,self.OwnerComp.FTitle);
                      end;
          end;//case...end!!
        end;//if...end!!
    end
  else
    begin
      Self.Canvas.Font.Color := self.OwnerComp.ColumnFontColor;
      Self.Canvas.Font.Style := self.OwnerComp.ColumnFontStyles;
      //---------------------------------------------------------------
      ShowValue := self.FValue;
      if(Assigned(self.OwnerComp.FOnFormatDisplayValue))then
        self.OwnerComp.FOnFormatDisplayValueW(self.OwnerComp,ShowValue);
      //---------------------------------------------------------------
      txtWidth  := WideCanvasTextWidth(self.Canvas,ShowValue);
      txtHeight := WideCanvasTextHeight(self.Canvas,ShowValue);
      //----------------------------------------------------------
      if(self.Width < self.OwnerComp.TitleCell.Width)then
        self.Width := self.OwnerComp.TitleCell.Width;
      if(self.Height < txtHeight)then self.Height := txtHeight;
      //--------------------------------------------------------
      if(self.OwnerComp.FUseColumnColor = TRUE)then
        Self.Canvas.Brush.Color := self.OwnerComp.FColumnColor
      else self.Canvas.Brush.Color := ClWhite;
      //--------------------------------------------------------------------------
      if(TGridColumns(self.OwnerComp.GetOwner).FGrid.UseIntervalColor = TRUE)then
        if(((self.Row+1) mod 2) = 0)then
          self.Canvas.Brush.Color := $00E1F5DC;
      //--------------------------------------------------------------------------------
      SelectCellRowID := -1;
      if(TGridColumns(self.OwnerComp.GetOwner).FGrid.SelectedCell <> nil)then
        SelectCellRowID := TGridColumns(self.OwnerComp.GetOwner).FGrid.SelectedCell.Row
      else
        if(TGridColumns(self.OwnerComp.GetOwner).FGrid.SelectedCellW <> nil)then
          SelectCellRowID := TGridColumns(self.OwnerComp.GetOwner).FGrid.SelectedCellW.Row;
      //--------------------------------------------------------------------------------
      self.Canvas.Pen.Color := ClSilver;
      if(SelectCellRowID <> -1)then
      if(self.OwnerComp <> nil)then
      if(self.OwnerComp.GetOwner <> nil)then
      if(TGridColumns(self.OwnerComp.GetOwner).FGrid <> nil)then
      if(self.Row < TGridColumns(self.OwnerComp.GetOwner).FGrid.RowCount)then
        if(self.Row = SelectCellRowID)then
          self.Canvas.Brush.Color
            := TGridColumns(self.OwnerComp.GetOwner).FGrid.FRecordFocusColor;
      //------------------------------------------------------------------------
      if(self.OwnerComp.TitleCell.Width >= txtWidth)then
        self.Width := self.OwnerComp.TitleCell.Width
      else
        if(self.Width < txtWidth)then
          begin
            self.Width := txtWidth+txtOfs;
            self.OwnerComp.OffsetCellLeftPos( txtWidth+txtOfs
                                              -self.OwnerComp.TitleCell.Width);
            self.OwnerComp.TitleCell.Width := self.Width;
            self.OwnerComp.ResetDataCellsWidth(self.Width);
          end;//if...end!!
      //--------------------------------------------------------
      self.Canvas.Rectangle(0,0,self.Width,self.Height);
      if(ShowValue <> '')then
        begin
          txtHeight  := self.Canvas.TextHeight(ShowValue);
          case self.OwnerComp.FColumnAlign of
            CA_Left  :begin
                        tx := 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        WideCanvasTextOut(self.Canvas,tx,ty,ShowValue);
                      end;
            CA_Center:begin
                        tx := self.Width  div 2 - txtWidth  div 2;
                        ty := self.Height div 2 - txtHeight div 2;
                        WideCanvasTextOut(self.Canvas,tx,ty,ShowValue);
                      end;
            CA_Right :begin
                        tx := self.Width - txtWidth-2;
                        ty := self.Height div 2 - txtHeight div 2;
                        WideCanvasTextOut(self.Canvas,tx,ty,ShowValue);
                      end;
          end;//case...end!!
        end; //if...end!!
    end;//else...end!!
end;

procedure TGridCellW.SetFCol(const Value: integer);
begin
  FCol := Value;
end;

procedure TGridCellW.SetFIsModify(const Value: boolean);
begin
  FIsModify := Value;
end;

procedure TGridCellW.SetFIsTitleCell(const Value: boolean);
begin
  FIsTitleCell := Value;
  if(Value = TRUE)then
    begin
      self.TabStop := FALSE;
      self.OnEnter := nil;
      self.OnExit  := nil;
    end;//if...end!!
end;

procedure TGridCellW.SetFRow(const Value: integer);
begin
  FRow := Value;
end;

//TColumnItem.
Constructor TColumnItem.Create(Collection: TCollection);
var i:integer;
begin
  Inherited Create(Collection);
  self.FImeName      := '';
  self.FWidth        := 64;
  self.FTitleColor   := $00F7D9CC;
  self.FDataCellList := TStringList.Create;
  self.FPickUpList   := TStringList.Create;
  self.FPickUpListW  := TTntStringList.Create;
  self.FPickListRefFields := TColumnPickListRefFields
                               .Create(nil,TPickListRefFieldItem);
  //--------------------------------------------------------------
  self.SetDisplayName(self.GetColumnStateStr);
  self.LinkControl           := TPanel.Create(nil);
  self.LinkControl.Visible   := FALSE;
  self.LinkControl.Parent    := TGridColumns(self.GetOwner).FGrid;
  self.FLinkControlFont      := TFont.Create;
  self.FLinkControlFont.Name := 'Arial';
  self.FLinkControlFont.Size := 8;
  //-------------------------------------------------------------
  self.TitleCell             := TGridCell.Create(nil);
  self.TitleCell.Color       := $00F7D9CC;
  self.TitleCell.OwnerComp   := self;
  self.TitleCell.Col         := self.Index;
  self.TitleCell.Row         := 0;
  self.TitleCell.IsTitleCell := TRUE;
  self.TitleCell.Top    := TGridColumns(self.GetOwner).FGrid.TitleCellStartY;
  self.TitleCell.Height := TGridColumns(self.GetOwner).FGrid.TitleCellHeight;
  self.TitleCell.Left   := self.CalcNewTitleCellLeftPos;
  self.TitleCell.Parent := TGridColumns(self.GetOwner).FGrid;
  self.FTitleFont := TFont.Create;
  self.FTitleFont.Name := 'Arial';
  self.FTitleFont.Size := 8;
end;

Destructor TColumnItem.Destroy;
var tmpGridColumns:TGridColumns;
    i,j,LeftPos:integer;
begin
  if(ColumnCombo  <> nil)then
    begin
      ColumnCombo.Parent := nil;
      ColumnCombo.Free;
    end;
  if(ColumnComboW <> nil)then
    begin                        
      ColumnComboW.Parent := nil;
      ColumnComboW.Free;
    end;   
  tmpGridColumns := nil;
  tmpGridColumns := TGridColumns(self.GetOwner);
  //----------------------------------------------
  self.LinkControl.Free;
  self.FLinkControlFont.Free;
  self.TitleCell .Free;
  self.FTitleFont.Free;
  //----------------------------------------------
  if(self.FPickUpList <> nil)then
    begin
      self.FPickUpList.Clear;
      self.FPickUpList.Free;
      self.FPickUpList := nil;
    end;//if...end!!
  //-------------------------------------
  if(self.FPickListRefFields <> nil)then
    self.FPickListRefFields.Free;
  //-------------------------------------
  if(self.FDataCellList <> nil)then
    begin
      for i := 0 to self.FDataCellList.Count-1 do
        begin
          if(IsColumnItemLinkUniCodeField(self) = FALSE)then
            TGridCell(self.FDataCellList.Objects[i]).Free
          else TGridCellW(self.FDataCellList.Objects[i]).Free;
          self.FDataCellList.Objects[i] := nil;
        end;//for...i...end!!
       self.FDataCellList.Free;
       self.FDataCellList := nil;
    end;//if...end!!
  inherited Destroy;
  for i := 0 to tmpGridColumns.Count-1 do
    begin
      LeftPos := tmpGridColumns.Columns[i].CalcNewTitleCellLeftPos;
      tmpGridColumns.Columns[i].TitleCell.Left := LeftPos;
      for j := 0 to tmpGridColumns.Columns[i].FDataCellList.Count-1 do
        TControl(tmpGridColumns.Columns[i].FDataCellList.Objects[j]).Left := LeftPos;
    end;
  tmpGridColumns := nil;
end;

procedure TColumnItem.Assign(Source: TPersistent);
begin
  if(Source Is TColumnItem)then
    begin
      self.FTitle     := TColumnItem(Source).Title;
      self.FEditStyle := TColumnItem(Source).EditStyle;
    end
   else Inherited Assign(Source);
end;

procedure TColumnItem.ResetDataCellsWidth(NewWidth: integer);
var i:integer;
begin
  for i := 0 to self.FDataCellList.Count-1 do
    if(IsColumnItemLinkUniCodeField(self) = FALSE)then
      self.DataCells[i].Width := NewWidth
    else self.DataCellsW[i].Width := NewWidth;
end;

procedure TColumnItem.OffsetCellLeftPos(offset:integer);
var i,j,LoopCount,startId,tmpX:Integer;
    tmpColumns:TGridColumns;
    tmpColItem:TColumnItem;
begin
  startId := self.Index+1;
  tmpColumns := TGridColumns(self.GetOwner);
  if(startId > tmpColumns.Count-1)Then Exit
  else LoopCount := tmpColumns.Count-1;
  tmpX := 0;
  for i := startId to LoopCount do
    begin
      tmpColItem := tmpColumns.Columns[i];
      tmpColItem.TitleCell.Left := tmpColItem.TitleCell.Left + offset;
      for j := 0 to tmpColItem.FDataCellList.Count-1 do
        if(IsColumnItemLinkUniCodeField(tmpColItem) = FALSE)then
          tmpColItem.DataCells[j].Left
            := tmpColItem.DataCells[j].Left + offset
        else
          tmpColItem.DataCellsW[j].Left
            := tmpColItem.DataCellsW[j].Left + offset;
    end;//for...i...end!!
  tmpColItem := nil;
  tmpColumns := nil;
end;

function TColumnItem.CalcNewTitleCellLeftPos:integer;
var i,tmpX:Integer;
begin
  if(self.Index = 0)then
    result := TGridColumns(self.GetOwner).FGrid.LeftStartX
  else
    begin
      tmpX   := 0;
      for i := 0 to self.Index-1 do
        tmpX := tmpx+TGridColumns(self.GetOwner)
                                      .Columns[i].TitleCell.Width;
      result := TGridColumns(self.GetOwner).FGrid.LeftStartX+tmpX;
    end;//else...end!!
end;

function TColumnItem.CalcNewDataCellTopPos(Index:integer): integer;
var i,id,startY,tmpY,GridStartY:integer;
    StdDataCellStart:integer;
begin
  id := Index-1;
  GridStartY := TGridColumns(self.GetOwner).FGrid.DataCellStartY;
  StdDataCellStart := TGridColumns(self.GetOwner).FGrid.TitleCellStartY
                     +TGridColumns(self.GetOwner).FGrid.TitleCellHeight+1;
  //---------------------------------------------------------------------                   
  if(GridStartY <> StdDataCellStart)then
    StartY := GridStartY
  else StartY := StdDataCellStart;
  //---------------------------------------------------------------------
  tmpy := 0;
  if(Index > 1)then
    begin
      for i := 0 to id-1 do
        begin
          tmpy := tmpy+TControl(self.FDataCellList.Objects[i]).Height;
        end;//for...i...end!!
    end;
  result := StartY+tmpy;
end;

procedure TColumnItem.AddNewDataCell;
var id:integer;
    tmpDataCell:TGridCell;
    tmpDataCellW:TGridCellW;
begin
  id := self.FDataCellList.Count+1;
  if(IsColumnItemLinkUniCodeField(self) = FALSE)then
    begin
      tmpDataCell := TGridCell.Create(nil);
      tmpDataCell.OwnerComp := self;
      tmpDataCell.Col        := self.Index;
      tmpDataCell.Row        := id-1;
      tmpDataCell.Left       := self.TitleCell.Left;
      tmpDataCell.Width      := self.TitleCell.Width;
      tmpDataCell.Height     := TGridColumns(self.GetOwner).FGrid.FDataCellHeight;
      tmpDataCell.Top        := self.CalcNewDataCellTopPos(id);
      tmpDataCell.Parent     := TGridColumns(self.GetOwner).FGrid;
      self.FDataCellList.AddObject('',tmpDataCell);
      tmpDataCell := nil;
    end//if...end!!
  else
    begin
      tmpDataCellW := TGridCellW.Create(nil);
      tmpDataCellW.OwnerComp := self;
      tmpDataCellW.Col        := self.Index;
      tmpDataCellW.Row        := id-1;
      tmpDataCellW.Left       := self.TitleCell.Left;
      tmpDataCellW.Width      := self.TitleCell.Width;
      tmpDataCellW.Height     := TGridColumns(self.GetOwner).FGrid.FDataCellHeight;
      tmpDataCellW.Top        := self.CalcNewDataCellTopPos(id);
      tmpDataCellW.Parent     := TGridColumns(self.GetOwner).FGrid;
      self.FDataCellList.AddObject('',tmpDataCellW);
      tmpDataCellW := nil;
    end;//else...end!!        
end;

procedure TColumnItem.DeleteDataCell;
var id:integer;
    tmpDataCell:TGridCell;
    tmpDataCellW:TGridCellW;
begin
  if(self.FDataCellList.Count = 0)then Exit;
  id := self.FDataCellList.Count-1;
  if(IsColumnItemLinkUniCodeField(self) = FALSE)then
    begin
      tmpDataCell := TGridCell(self.FDataCellList.Objects[id]);
      tmpDataCell.Parent := nil;
      tmpDataCell.OwnerComp := nil;
      tmpDataCell.Free;
    end//if...end!!
  else
    begin
      tmpDataCellW := TGridCellW(self.FDataCellList.Objects[id]);
      tmpDataCellW.Parent := nil;
      tmpDataCellW.OwnerComp := nil;
      tmpDataCellW.Free;
    end;//else...end!!
  self.FDataCellList.Objects[id] := nil;
  self.FDataCellList.Delete(id);
  tmpDataCell  := nil;
  tmpDataCellW := nil;
end;

function TColumnItem.GetColumnStateStr: string;
var tmpstr:string;
begin
  if(trim(self.FTitle) = '')then tmpstr := 'NewGrigColumn'
  else tmpstr :=  '[ '+self.FTitle+' ]';
  result := tmpstr;
end;

function TColumnItem.GetDisplayName: string;
var tmpWidth,NewLeft:integer;
begin
  result := self.FDisPlayName;
  //---------------------------------------
  tmpWidth := self.FWidth;
  self.SetFWidth(tmpWidth);
  NewLeft := self.CalcNewTitleCellLeftPos;
  self.TitleCell.Left := NewLeft;
end;

procedure TColumnItem.SetDisplayName(const Value: string);
begin
  self.FDisPlayName := Value;
end;

procedure TColumnItem.ColumnTitleFixColumnWidth(FixWidth: integer);
var LastWidth,i:integer;
begin
  LastWidth := self.FWidth;
  if(self.FWidth < FixWidth)then LastWidth := FixWidth;
  if(LastWidth   > 6000)then LastWidth := 6000;
  self.FWidth := LastWidth;
  for i := 0 to self.FDataCellList.Count-1 do
    if(TControl(self.FDataCellList.Objects[i]).Width <> self.FWidth)then
      TControl(self.FDataCellList.Objects[i]).Width :=  self.FWidth;
end;

procedure TColumnItem.SetFTitle(value: string);
begin
  self.FTitle := value;
  self.SetDisplayName(self.GetColumnStateStr);
  self.TitleCell.Invalidate;
end;

procedure TColumnItem.SetFTitleAlign(const Value: TTitleAlignType);
begin
  self.FTitleAlign := Value;
  self.TitleCell.Invalidate;
end;

procedure TColumnItem.SetFColumnAlign(const Value: TColumnAlignType);
var i:integer;
begin
  self.FColumnAlign := Value;
  for i := 0 to self.FDataCellList.Count-1 do
    TControl(self.FDataCellList.Objects[i]).Invalidate;
end;

procedure TColumnItem.SetFColumnColor(const Value: TColor);
var i:integer;
begin
  FColumnColor := Value;
  for i := 0 to self.FDataCellList.Count-1 do
    TControl(self.FDataCellList.Objects[i]).Invalidate;
end;

procedure TColumnItem.SetFColumnFontColor(const Value: TColor);
var i:integer;
begin
  FColumnFontColor := Value;
  for i := 0 to self.FDataCellList.Count-1 do
    TControl(self.FDataCellList.Objects[i]).Invalidate;
end;

procedure TColumnItem.SetFColumnFontStyles(const Value: TFontStyles);
var i:integer;
begin
  FColumnFontStyles := Value;
  for i := 0 to self.FDataCellList.Count-1 do
    TControl(self.FDataCellList.Objects[i]).Invalidate;
end;

procedure TColumnItem.SetFUseColumnColor(const Value: boolean);
var i:integer;
begin
  FUseColumnColor := Value;
  for i := 0 to self.FDataCellList.Count-1 do
    TControl(self.FDataCellList.Objects[i]).Invalidate;
end;

procedure TColumnItem.SetFUseSelfComboBox(const Value: boolean);
begin
  if(Value = FUseSelfComboBox)then Exit;
  FUseSelfComboBox := Value;
  if(Value = TRUE)then
  if not(csDesigning in TGridColumns(self.GetOwner).FGrid.ComponentState)then
    begin
      if(self.ColumnCombo = nil)then
        begin
          self.ColumnCombo := TComboBox.Create(nil);
          self.ColumnCombo.Sorted := TRUE;
        end;
      if(self.ColumnComboW = nil)then
        begin
          self.ColumnComboW := TTntComboBox.Create(nil);
          self.ColumnComboW.Sorted := TRUE;
        end;
    end;//if...end!!
end;

procedure TColumnItem.SetFTitleColor(const Value: Tcolor);
begin
  self.FTitleColor := Value;
  self.TitleCell.Color := self.FTitleColor;
end;

procedure TColumnItem.SetFEditStyle(const Value: TColumnEditStyle);
begin
  self.FEditStyle := Value;
end;

function TColumnItem.GetFPickUpList:TStrings;
begin
  result := self.FPickUpList;
end;

procedure TColumnItem.SetFPickUpList(const Value: TStrings);
begin
  self.FPickUpList.BeginUpdate;
  self.FPickUpList.Assign(Value);
  self.FPickUpList.EndUpdate;
end;

procedure TColumnItem.setFWidth(const Value: integer);
var i,j,id,newLeftPos:integer;
begin
  if(self.FWidth = Value)then Exit;
  id := self.Index;
  self.FWidth := Value;
  self.TitleCell.Width := FWidth;
  for i := 0 to self.FDataCellList.Count-1 do
    TControl(self.FDataCellList.Objects[i]).Width := FWidth;
  //---------------------------------------------------------
  newLeftPos := self.TitleCell.Left+FWidth;
  for i := id+1 to TGridColumns(self.GetOwner).Count-1 do
    begin
      TGridColumns(self.GetOwner).Columns[i].TitleCell.Left := newLeftPos;
      for j := 0 to TGridColumns(self.GetOwner).Columns[i].FDataCellList.Count-1 do
        TControl(TGridColumns(self.GetOwner).Columns[i].
                  FDataCellList.Objects[j]).Left := newLeftPos;
      newLeftPos := TGridColumns(self.GetOwner).Columns[i].TitleCell.Left
                   +TGridColumns(self.GetOwner).Columns[i].TitleCell.Width;
    end;//for...i...end!!
  //-----------------------------------------------------------------------------
end;

procedure TColumnItem.SetFTitleHint(const Value: string);
begin
  FTitleHint := Value;
  self.TitleCell.ShowHint := TRUE;
  self.TitleCell.Hint := FTitleHint;
end;

function TColumnItem.GetDataCell(Row: Integer): TGridCell;
begin
  result := nil;
  if(Row <= (self.FDataCellList.Count-1))then
    result := TGridCell(self.FDataCellList.Objects[Row]);
end;

function TColumnItem.GetDataCellW(Row: Integer): TGridCellW;
begin
  result := nil;
  if(Row <= (self.FDataCellList.Count-1))then
    result := TGridCellW(self.FDataCellList.Objects[Row]);
end;

//TGridColumns.
Constructor TGridColumns.Create(TheOwner: TComponent; ItemClass: TColumnItemClass);
begin
  inherited Create(TheOwner,ItemClass);
end;

Destructor TGridColumns.Destroy;
begin
  inherited Destroy;
end;

function TGridColumns.Add: TColumnItem;
begin
  result := TColumnItem(inherited Add);
end;

function TGridColumns.GeTColumnItem(Index: Integer): TColumnItem;
begin
  Result := TColumnItem(inherited Items[Index]);
end;

function TGridColumns.GetCount: Integer;
begin
  Result := inherited Count;
end;

procedure TGridColumns.SeTColumnItem(Index: Integer; value: TColumnItem);
begin
  Columns[Index].Assign(value);
end;

function TGridColumns.GetDataCell(Col, Row: Integer): TGridCell;
begin
  result := nil;
  if(Col <= (self.Count-1))then
    if(Row <= (self.Columns[Col].FDataCellList.Count-1))then
      result := TGridCell(self.Columns[Col].FDataCellList.Objects[Row]);
end;

function TGridColumns.GetDataCellW(Col, Row: Integer): TGridCellW;
begin
  result := nil;
  if(Col <= (self.Count-1))then
    if(Row <= (self.Columns[Col].FDataCellList.Count-1))then
      result := TGridCellW(self.Columns[Col].FDataCellList.Objects[Row]);
end;

//TAspFileDBGrid.
Constructor TAspFileDBGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.FMaxGridRow       := 10;
  self.TabStop           := FALSE;
  self.Color             := ClSilver;
  self.Width             := 460;
  self.Height            := 310;
  self.FColumns          := TGridColumns.Create(Self,TColumnItem);
  self.FColumns.FGrid    := Self;
  LeftStartX             := 19;
  self.FRowCount         := 0;
  self.FRecordFocusColor := $00E98B63;
  self.FKeyFieldColor    := $0078E7D9;
  self.FTitleCellStartY  := 1;
  self.FTitleCellHeight  := 25;
  self.FDataCellStartY   := 27;
  self.FDataCellHeight   := 25;   
  //============================================
  self.FScrollPanel := TScrollBar.Create(nil);
  self.FScrollPanel.TabStop  := FALSE;
  self.FScrollPanel.Kind     := sbVertical;
  self.FScrollPanel.Width    := 16;
  self.FScrollPanel.Parent   := self;
  self.FScrollPanel.Align    := alLeft;
  self.FScrollPanel.OnScroll := self.ScrollData;
  //============================================
  self.tmpChkBox := TCheckBox.Create(nil);
  self.tmpChkBox.Name := 'CellCheckBox';
  //------------------------------------------
  self.tmpMemo := TMemo.Create(nil);
  self.tmpMemo.Name      := 'CellMemo';
  self.tmpMemo.ImeName   := '';
  //------------------------------------------
  self.tmpEdit := TMaskEdit.Create(nil);
  self.tmpEdit.Name      := 'CellEdit';
  self.tmpEdit.ImeName   := '';
  //------------------------------------------
  self.tmpCombo := TComboBox.Create(nil);
  self.tmpCombo.Sorted   := TRUE;
  self.tmpCombo.Name     := 'CellComboBox';
  self.tmpCombo.ImeName  := '';
  //-------------------------------------------------
  self.tmpBtn   := TButton.Create(nil);
  self.tmpBtn.Name       := 'CellBtn';
  self.tmpBtn.Font.Name  := 'Arial';
  self.tmpBtn.Font.Style := [];
  self.tmpBtn.Font.Size  := 4;
  self.tmpBtn.Caption    := '...';
  //==========================================
  self.tmpChkBoxW := TTntCheckBox.Create(nil);
  self.tmpChkBoxW.Name := 'CellCheckBoxW';
  //------------------------------------------
  self.tmpMemoW := TTntMemo.Create(nil);
  self.tmpMemoW.Name := 'CellMemoW';
  self.tmpMemoW.ImeName := '';
  //------------------------------------------
  self.tmpEditW   := TTntEdit.Create(nil);
  self.tmpEditW.Name    := 'CellEditW';
  self.tmpEditW.ImeName := '';
  //------------------------------------------
  self.tmpComboW := TTntComboBox.Create(nil);
  self.tmpComboW.Name    := 'CellComboBoxW';
  self.tmpComboW.ImeName := '';
  //------------------------------------------
  self.tmpBtnW   := TTntButton.Create(nil);
  self.tmpBtnW.Name       := 'CellBtnW';
  self.tmpBtnW.Font.Name  := 'Arial';
  self.tmpBtnW.Font.Style := [];
  self.tmpBtnW.Font.Size  := 4;
  self.tmpBtnW.Caption    := '...';
  //==========================================
  self.Font.Name          := 'Arial';
  self.Font.Size          := 8;
  self.FAutoSize          := TRUE;
  self.CurrentEditRow     := -1;
  self.FReadOnly          := FALSE;
  self.IsRefreshWithDataSource := FALSE;
  self.IsCursorUpChangeGridPostData   := FALSE;
  Self.IsCursorDownChangeGridPostData := FALSE;
end;                      

Destructor TAspFileDBGrid.Destroy;
begin
  SelectedCell := nil;
  //------------------
  self.tmpEdit.Free;
  self.tmpCombo.Free;
  self.tmpBtn.Free;
  self.tmpChkBox.Free;
  self.tmpMemo.Free;
  //-----------------------
  self.tmpEditW.Free;
  self.tmpComboW.Free;
  self.tmpBtnW.Free;
  self.tmpChkBoxW.Free;
  self.tmpMemoW.Free;
  //------------------
  self.FColumns.Free;
  self.FScrollPanel.Free;
  inherited Destroy;
end;                    

procedure TAspFileDBGrid.ReSize;
var id,wd:integer;
begin
  inherited Resize;
  if(self.FAutoSize = TRUE)then
  if(self.Columns.Count > 0)then
    begin
      id := self.Columns.Count-1;
      wd := self.Columns.Columns[id].CalcNewTitleCellLeftPos
            +self.Columns.Columns[id].ColumnWidth;
      if((wd+self.FScrollPanel.Width+5) > self.Width)then
        self.Width := wd+self.FScrollPanel.Width+5;
    end;//if...end!!
end;

procedure TAspFileDBGrid.Notification(AComponent: TComponent;
                                      Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    begin
      if(AComponent = self.FDataSource)then self.FDataSource := nil;
      if(AComponent = self.FPopupMenu )then
        begin
          self.FPopupMenu         := nil;
          self.tmpEdit .PopupMenu := nil;
          self.tmpCombo.PopupMenu := nil;
          self.tmpBtn  .PopupMenu := nil;
        end;//if...end!!
      if(AComponent = self.tmpEdit.Parent)then
        begin
          self.tmpEdit.Visible := FALSE;
          self.tmpEdit.Parent  := nil;
        end;//if...end!!
      if(AComponent = self.tmpCombo.Parent)then
        begin
          self.tmpCombo.Visible := FALSE;
          self.tmpCombo.Parent  := nil;
        end;//if...end!!
      if(AComponent = self.tmpBtn.Parent)then
        begin
          self.tmpBtn.Visible := FALSE;
          self.tmpBtn.Parent  := nil;
        end;//if...end!!
    end;//if...end!!
end;

function TAspFileDBGrid.ColumnByTitle(inTitleName: string): TColumnItem;
var i:integer;
begin
  result := nil;
  for i := 0 to self.Columns.Count-1 do
    begin
      if(self.FColumns.Columns[i].FTitle = inTitleName)then
        begin
          result := self.FColumns.Columns[i];
          Break;
        end;//if...end!!
    end;//for...i...end!!
end;

procedure TAspFileDBGrid.RefreshWithDataSource;
var i,FdDataSize,TitleWidth,ValueWidth:integer;
    thisProcActive,DataSetSelfActive:boolean;
    tmpColumn:TColumnItem;
    fieldStr:string;
begin
  if(self.IsRefreshWithDataSource = TRUE)then Exit;
  if(self.FDataSource <> nil)then
    begin
      self.IsRefreshWithDataSource := TRUE;
      DataSetSelfActive := FALSE;
      self.IsCursorUpChangeGridPostData   := FALSE;
      Self.IsCursorDownChangeGridPostData := FALSE;
      self.FDataSource.AddNewDBGrid(self);
      tmpColumn := nil;
      if(self.FDataSource.FDataSet <> nil)then
      if(self.FDataSource.FDataSet.RecDataSet <> nil)then
        begin
          if(self.FDataSource.FDataSet.AccessUser = '')then Exit;
          //-------------------------------------------------------------
          if(self.FDataSource.FDataSet.AccessFile = '')
            and(self.FDataSource.FDataSet.SchemaFileName = '')then Exit;
          //-------------------------------------------------------------
          if(self.FDataSource.FDataSet.RecDataSet.IsOpened = FALSE)then
            begin
              if(self.FDataSource.FDataSet.AccessFile <> '')then
                begin
                  if(self.FDataSource.FDataSet.AccessUser <> '')then
                    try
                      thisProcActive := FALSE;
                      self.FDataSource.FDataSet.Active := TRUE;
                      thisProcActive := TRUE;
                    except
                    end;//try...end!!
                end//if...end!!
              else
                begin
                  if(self.FDataSource.FDataSet.SchemaFileName <> '')then
                  if(self.FDataSource.FDataSet.AccessUser <> '')then
                    try
                      thisProcActive := FALSE;
                      self.FDataSource.FDataSet.Active := TRUE;
                      thisProcActive := TRUE;
                    except
                    end;//try...end!!
                end;//else...end!!
            end //if...end!!
          else DataSetSelfActive := TRUE;
          //----------------------------------------------------------------
          if(self.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then
            begin
              if(self.Columns.Count = 0)then
              for i := 0 to self.FDataSource.FDataSet.RecDataSet.FieldCount-1 do
                begin
                  fieldStr  := self.FDataSource.FDataSet.RecDataSet.FieldName[i];
                  tmpColumn := self.Columns.Add;
                  if(self.FDataSource.FDataSet.RecDataSet.IsKeyField[fieldStr] = TRUE)then
                    begin
                      tmpColumn.ColumnColor := self.KeyFieldColor;
                      tmpColumn.UseColumnColor := TRUE;
                    end;//if...end!!
                  if(trim(tmpColumn.Title) = '')then tmpColumn.Title := fieldStr;
                  tmpColumn.DataField := fieldStr;
                  FdDataSize := self.FDataSource.FDataSet.RecDataSet.FieldDataSize[tmpColumn.DataField];
                  TitleWidth := tmpColumn.TitleCell.Canvas.TextWidth(tmpColumn.Title);
                  ValueWidth := tmpColumn.TitleCell.Canvas.TextWidth('A')*FdDataSize;
                  if(TitleWidth > ValueWidth)then
                    tmpColumn.TitleCell.Width := TitleWidth+8
                  else tmpColumn.TitleCell.Width := ValueWidth;
                  tmpColumn.ColumnTitleFixColumnWidth(tmpColumn.TitleCell.Width);
                end;//for...i...end!!
              //=============================================================
              if(DataSetSelfActive = TRUE)then
                self.RowCount := self.FMaxGridRow;
              //=============================================================
              if(thisProcActive = TRUE)or(DataSetSelfActive = TRUE)then
                begin
                  if(thisProcActive = TRUE)then
                    self.FDataSource.FDataSet.Active := FALSE
                  else self.FDataSource.PostDisplayData;  
                end;//if...end!!
            end;//if...end!!
        end;//if...end!!
      tmpColumn := nil;
      self.IsRefreshWithDataSource := FALSE;
    end;//if...end!!
end;

procedure TAspFileDBGrid.DisableRefreshData;
begin
  BreakDataRefreshLink := TRUE;
end;

procedure TAspFileDBGrid.AddNewRecordCells;
var i:integer;
begin
  for i := 0 to self.FColumns.Count-1 do
    self.FColumns.Columns[i].AddNewDataCell;
end;

procedure TAspFileDBGrid.DeleteRecordCells;
var i,ct:integer;
begin
  if(self.FColumns.Columns[0].FDataCellList.Count = 0)then Exit;
  ct := self.FColumns.Count-1;
   for i := 0 to ct do
    self.FColumns.Columns[i].DeleteDataCell;
end;

procedure TAspFileDBGrid.DoOnExit(Sender: TObject);
begin
  
end;

procedure TAspFileDBGrid.ClearInsertRow;
var i:integer;
begin
  for i := 0 to self.Columns.count-1 do
    if(IsColumnItemLinkUniCodeField(self.Columns.Columns[i]) = FALSE)then
      self.Columns.Columns[i].DataCells[0].ClearCellData
    else self.Columns.Columns[i].DataCellsW[0].ClearCellData;
end;

procedure TAspFileDBGrid.DeleteInsertRowDataCell;
var i:integer;
begin
  for i := 0 to self.Columns.count-1 do
    self.Columns.Columns[i].FDataCellList.Delete(0);
end;

function TAspFileDBGrid.GetFRowCount: integer;
begin
  result := 0;
  if(self.Columns.Count = 0)then Exit;
  result := self.Columns.Columns[0].FDataCellList.Count;
end;

procedure TAspFileDBGrid.SetFRowCount(const Value: integer);
var i,j,oldCount,ct:integer;
begin
  oldCount := self.RowCount;
  if(oldCount = Value)then Exit;
  //---------------------------------
  if(oldCount > Value)then
    begin
      self.tmpChkBox.Parent  := nil;
      self.tmpMemo.Parent    := nil;
      self.tmpEdit.Parent    := nil;
      self.tmpCombo.Parent   := nil;
      self.tmpBtn.Parent     := nil;
      self.tmpChkBoxW.Parent := nil;
      self.tmpMemoW.Parent   := nil;
      self.tmpEditW.Parent   := nil;
      self.tmpComboW.Parent  := nil;
      self.tmpBtnW.Parent    := nil;
      //-------------------------------------------------------------
      for i := 1 to (oldCount-Value) do
        self.DeleteRecordCells
    end//if...end!!
  else
    begin
      self.tmpChkBox.Parent  := nil;
      self.tmpMemo.Parent    := nil;
      self.tmpEdit.Parent    := nil;
      self.tmpCombo.Parent   := nil;
      self.tmpBtn.Parent     := nil;
      self.tmpChkBoxW.Parent := nil;
      self.tmpMemoW.Parent   := nil;
      self.tmpEditW.Parent   := nil;
      self.tmpComboW.Parent  := nil;
      self.tmpBtnW.Parent    := nil;
      for i := 1 to (Value-oldCount) do
        self.AddNewRecordCells;
    end;//else...end!!
  //-----------------------------------------------------------------
  FRowCount := Value;
  for i := 0 to self.Columns.Count-1 do
  for j := 0 to Value-1 do
    if(IsColumnItemLinkUniCodeField(self.Columns.Columns[i]) = FALSE)then
      self.Columns.Columns[i].DataCells[j].ClearCellData
    else self.Columns.Columns[i].DataCellsW[j].ClearCellData;
  //----------------------------------------------------------------------
end;

procedure TAspFileDBGrid.SetFTitleCellHeight(const Value: Integer);
var i,j:integer;
begin
  if(FTitleCellHeight = Value)then Exit;
  FTitleCellHeight := Value;
  self.FDataCellStartY := FTitleCellStartY+FTitleCellHeight+1;
  for i := 0 to self.Columns.Count-1 do
    begin
      self.Columns.Columns[i].TitleCell.Height := FTitleCellHeight;
      self.Columns.Columns[i].TitleCell.Invalidate;
      for j := 0 to self.FRowCount-1 do
        begin
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Top
            := self.Columns.Columns[i].CalcNewDataCellTopPos(j+1);
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Invalidate;
        end;  
    end;//for...i...end!!
end;                       

procedure TAspFileDBGrid.SetFTitleCellStartY(const Value: integer);
var i,j:integer;
begin
  if(FTitleCellStartY = Value)then Exit;
  FTitleCellStartY := Value;
  self.FDataCellStartY := FTitleCellStartY+FTitleCellHeight+1;
  for i := 0 to self.Columns.Count-1 do
    begin
      self.Columns.Columns[i].TitleCell.Top := FTitleCellStartY;
      self.Columns.Columns[i].TitleCell.Invalidate;
      for j := 0 to self.FRowCount-1 do
        begin
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Top
            := self.Columns.Columns[i].CalcNewDataCellTopPos(j+1);
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Invalidate;
        end;
    end;//for...i...end!!
end;

procedure TAspFileDBGrid.SetFUseIntervalColor(const Value: Boolean);
begin
  self.FUseIntervalColor := Value;
  self.Invalidate;
end;

procedure TAspFileDBGrid.SetFAutoSize(const Value: boolean);
begin
  FAutoSize := Value;
end;

procedure TAspFileDBGrid.ScrollData(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  if(self.FDataSource <> nil)then
  if(self.FDataSource.FDataSet <> nil)then
  if(self.FDataSource.FDataSet.Active = TRUE)then
    begin
      case ScrollCode of
        scLineUp:
          begin
            self.NavigatorMoveDataCursor := TRUE;
            self.NavigatorMoveDataPrior  := TRUE;
            self.FDataSource.FDataSet.Prior;
          end;
        scLineDown:
          begin
            self.NavigatorMoveDataCursor := TRUE;
            self.NavigatorMoveDataNext   := TRUE;
            self.FDataSource.FDataSet.Next;
          end;
        scPosition,scPageDown,scPageUp:
          begin
            self.NavigatorMoveDataCursor := TRUE;
            self.FDataSource.FDataSet.GotoBookMark(ScrollPos);
          end;
      end;//case....end!!
    end;//if...end!!
end;

procedure TAspFileDBGrid.SetFDataCellStartY(const Value: integer);
var i,j:integer;
begin
  if(FDataCellStartY = Value)then Exit;
  if(Value < (self.FTitleCellStartY+self.FTitleCellHeight+1))then
    FDataCellStartY := self.FTitleCellStartY+self.FTitleCellHeight+1;
  //------------------------------------------------------------------
  FDataCellStartY := Value;
  for i := 0 to self.Columns.Count-1 do
    begin
      self.Columns.Columns[i].TitleCell.Top := FTitleCellStartY;
      self.Columns.Columns[i].TitleCell.Invalidate;
      for j := 0 to self.FRowCount-1 do
        begin
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Top
            := self.Columns.Columns[i].CalcNewDataCellTopPos(j+1);
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Invalidate;
        end;
    end;//for...i...end!!
end;

procedure TAspFileDBGrid.SetFDataCellHeight(const Value: Integer);
var i,j:integer;
begin
  if(FDataCellHeight = Value)then Exit;
  if((Value * self.RowCount) > self.Height)then
    self.Height := (Value * self.RowCount)+1;
  //------------------------------------------------------------------
  FDataCellHeight := Value;
  for i := 0 to self.Columns.Count-1 do
    begin
      for j := 0 to self.FRowCount-1 do
        begin
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Height
            := Value;
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Top
            := self.Columns.Columns[i].CalcNewDataCellTopPos(j+1);
          TControl(self.Columns.Columns[i].FDataCellList.Objects[j]).Invalidate;
        end;
    end;//for...i...end!!
end;

procedure TAspFileDBGrid.SetFReadOnly(const Value: boolean);
begin
  FReadOnly := Value;
end;

procedure TAspFileDBGrid.SetFRecordFocusColor(const Value: TColor);
begin
  FRecordFocusColor := Value;
end;

procedure TAspFileDBGrid.SetFKeyFieldColor(const Value: TColor);
begin
  FKeyFieldColor := Value;
end;

procedure TAspFileDBGrid.SetFDataSource(const Value: TAspFileDataSource);
var i:integer;
begin
  if not (csLoading in self.ComponentState)then
  if(self.FDataSource <> Value)
    and(self.FDataSource <> nil)then
    begin
      self.IsRefreshWithDataSource := FALSE;
      self.FDataSource.RemoveDBGrid(self);
      if(csDesigning in self.ComponentState)then
        begin
          for i := 0 to self.Columns.Count-1 do
            self.Columns.Columns[i].DeleteDataCell;
          while(self.Columns.Count > 0)do self.Columns.Delete(0);
        end;//if...end!!
    end; //if...end!!
  FDataSource := Value;
  if(FDataSource <> nil)then
    self.RefreshWithDataSource;
end;

procedure TAspFileDBGrid.SetFPopupMenu(const Value: TPopUpMenu);
var i:integer;
begin
  FPopupMenu := Value;
  if(Value <> nil)then
    begin
      for i := 0 to Value.Items.Count-1 do
        Value.Items[i].OnClick := self.RunPopUpMenuClick;
      //--------------------------------------------------
      self.tmpEdit .PopupMenu := Value;
      self.tmpCombo.PopupMenu := Value;
      self.tmpBtn  .PopupMenu := Value;
    end;//if...end!!
end;

procedure TAspFileDBGrid.SetDBGridMoveDataCursor;
begin
  self.GridMoveDataCursor := TRUE;
  self.NavigatorMoveDataCursor := FALSE;
end;

procedure TAspFileDBGrid.SetNavigatorMoveDataCursor(IsMoveCursor:boolean);
begin
  self.GridMoveDataCursor := FALSE;
  self.NavigatorMoveDataCursor := TRUE;
  if(IsMoveCursor = TRUE)then
  //FLݩۦPDataSourceDBGridƸ۲
  //@HUʧ@ ==> self.GridTopDataPos := -1;
  if(self.FDataSource <> nil)then
  if(self.FDataSource.FDataSet.RecDataSet.DbState <> 'Edit')then
    self.GridTopDataPos := -1;
end;

procedure TAspFileDBGrid.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var tp:TPoint;
begin
  inherited MouseDown(Button,Shift,X,Y);
  if(Button = mbRight)then
    begin
      if(self.FPopupMenu <> nil)then
        self.FPopupMenu.Popup( self.Parent.Left+self.Left+X
                              ,self.Parent.Top +self.Top +Y);
    end
  else
    begin
      tp.X := X;
      tp.Y := Y;
      ///\\\self.ScreenToClient(tp);
    end;
end;

procedure TAspFileDBGrid.RunPopUpMenuClick(Sender: TObject);
begin
  if(Sender <> nil)then
  if(Assigned(self.FGridPopUpMenuClick))then
    self.FGridPopUpMenuClick(Sender,TMenuitem(Sender).Caption);
end;

procedure TAspFileDBGrid.RepaintSelectedRowCells(SelectedRow:integer);
var i:integer;
begin
  if(SelectedRow < 0)then Exit;
  if(SelectedRow > self.RowCount-1)then Exit;
  for i := 0 to self.Columns.Count-1 do
    if(IsColumnItemLinkUniCodeField(self.Columns.Columns[i]) = FALSE)then
      self.Columns.GetDataCell(i,SelectedRow).Invalidate
    else
      self.Columns.GetDataCellW(i,SelectedRow).Invalidate;
end;

function TAspFileDBGrid.GetCurrentRecordInWhichRow: integer;
var i,RecordPos:integer;
begin
  result := -1;
  for i := 0 to self.RowCount-1 do
    begin
      if(IsColumnItemLinkUniCodeField(self.Columns.Columns[0]) = FALSE)then
        begin
          RecordPos := self.Columns.GetDataCell(0,i).RecPos;
          if(RecordPos = -1)then
            RecordPos := self.Columns.GetDataCell(0,i).FilterRecPos;
          if(RecordPos = self.DataSource.FDataSet.RecDataSet.GetBookMark)then
            begin
              result := i;
              Break;
            end;//if...end!!
        end//if...end!!
      else
        begin
          RecordPos := self.Columns.GetDataCellW(0,i).RecPos;
          if(RecordPos = -1)then
            RecordPos := self.Columns.GetDataCellW(0,i).FilterRecPos;
          if(RecordPos = self.DataSource.FDataSet.RecDataSet.GetBookMark)then
            begin
              result := i;
              Break;
            end;//if...end!!
        end;//else...end!!
    end;//for...i...end!!
end;

function TAspFileDBGrid.IsThisRowDataIsDifferentWithFieldData(
  ThisRow: integer): boolean;
var i:integer;
    FieldName:string;
begin
  result := FALSE;
  if(ThisRow < 0)then Exit;
  if(ThisRow > 9)then Exit;
  if(self.DataSource = nil)then Exit;
  if(self.DataSource.DataSet = nil)then Exit;
  if(self.DataSource.DataSet.RecDataSet.IsOpened = FALSE)then Exit;
  //---------------------------------------------------------------
  for i := 0 to self.Columns.Count-1 do
    begin
      FieldName := self.Columns.Columns[i].FFieldName;
      if(FieldName <> '')then
      if(IsColumnItemLinkUniCodeField(self.Columns.Columns[i]) = FALSE)then
        begin
          if(self.DataSource.DataSet.RecDataSet.FieldByName[FieldName]
             <> self.Columns.GetDataCell(i,ThisRow).FValue)then
            begin
              result := TRUE;
              Break;
            end;//if...end!!
        end//if...end!!
      else
        begin
          if(self.DataSource.DataSet.RecDataSet.FieldByNameW[FieldName]
             <> self.Columns.GetDataCellW(i,ThisRow).FValue)then
            begin
              result := TRUE;
              Break;
            end;//if...end!!
        end;//else...end!!      
    end;//for...i...end!!  
end;

procedure TAspFileDBGrid.ResetGridScrollView;
var tmpLeft:integer;
begin
  if(self.Columns.Count <= 0)then Exit;
  self.ScrollInView(self.Columns.GetDataCell(0,0));
  tmpLeft := self.Columns.GetDataCell(0,0).Left;
  while(tmpLeft < self.LeftStartX)do
    begin
      self.ScrollBy(1,0);
      tmpLeft := self.Columns.GetDataCell(0,0).Left;
    end;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWithNavigatorDeleteClick;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        tmpGrid.SetNavigatorMoveDataCursor(TRUE);
        tmpGrid.NavigatorMoveDataFirst := FALSE;
        tmpGrid.NavigatorMoveDataPrior := FALSE;
        tmpGrid.NavigatorMoveDataNext  := FALSE;
        tmpGrid.NavigatorMoveDataLast  := FALSE;
      end;
  tmpGrid := nil;
end;

procedure TAspFileDataSource.RefreshDBGridParamsWithNavigatorPostClick;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        tmpGrid.SetNavigatorMoveDataCursor(TRUE);
        tmpGrid.NavigatorMoveDataFirst := FALSE;
        tmpGrid.NavigatorMoveDataPrior := FALSE;
        tmpGrid.NavigatorMoveDataNext  := FALSE;
        tmpGrid.NavigatorMoveDataLast  := FALSE;
      end;
  tmpGrid := nil;
end;

procedure TAspFileDataSource.ResetAllGridGridTopDataPos;
var i:integer;
    tmpGrid:TAspFileDBGrid;
begin
  for i := 0 to self.FDataControls.Count-1 do
    if(TComponent(self.FDataControls.Objects[i]).ClassType = TAspFileDBGrid)then
      begin
        tmpGrid := TAspFileDBGrid(self.FDataControls.Objects[i]);
        if(tmpGrid.IsSelectUniCodeDataCell = FALSE)then
          tmpGrid.GridTopDataPos := tmpGrid.Columns.DataCells[0,0].RecPos
        else tmpGrid.GridTopDataPos := tmpGrid.Columns.DataCellsW[0,0].RecPos;
      end;
  tmpGrid := nil;
end;

//------------------------------------------------------------------------------

function TAspFileDataSet.AddNewField(FieldName: string; Size: integer;
  IsKey, CanNull,IsUniCodeField, IsLookUpField: boolean;
  LookUpDataSet: TAspFileDataSet;
  MasterFieldName, LookUpKeyField, LookUpResultField: string): boolean;
var IsSuccess:OleVariant;
begin
  result := FALSE;
  if(LookUpDataSet <> nil)then
    self.RecDataSet.AddNewField( FieldName,Size,IsKey,CanNull,IsUniCodeField,
                                 IsLookUpField,
                                 LookUpDataSet.RecDataSet,
                                 MasterFieldName,LookUpKeyField,
                                 LookUpResultField,IsSuccess)
  else
    self.RecDataSet.AddNewField( FieldName,Size,IsKey,CanNull,IsUniCodeField,
                                 IsLookUpField,
                                 nil,
                                 MasterFieldName,LookUpKeyField,
                                 LookUpResultField,IsSuccess);
  result := IsSuccess;
end;

function TAspFileDataSet.AddDetailDb(DetailOBJ: TAspFileDataSet;
  MasterKeyFields, DetailForginKeyFields: string;
  IsMultiFieldsRelation: boolean): boolean;
var IsSuccess:OleVariant;
    l:integer;
    mfields,dfields:string;
begin
  result := FALSE;
  if(DetailOBJ = nil)then Exit;
  //-----------------------------
  if(IsMultiFieldsRelation = TRUE)then
    begin
      l := Length(MasterKeyFields);
      if(MasterKeyFields[l] <> ';')then
        mfields := MasterKeyFields+';'
      else mfields := MasterKeyFields;
      //--------------------------------
      l := Length(DetailForginKeyFields);
      if(DetailForginKeyFields[l] <> ';')then
        dfields := DetailForginKeyFields+';'
      else dfields := DetailForginKeyFields;
    end//if...end!!
  else
    begin
      mfields := MasterKeyFields;
      dfields := DetailForginKeyFields;
    end;//else...end!!  
  //-------------------------------------------
  self.RecDataSet.AddDetailDb( DetailOBJ.RecDataSet,
                               mfields,
                               dfields,
                               IsMultiFieldsRelation,IsSuccess);
  result := IsSuccess;
end;

function TAspFileDataSet.IsBof: boolean;
begin
  result := self.RecDataSet.IsBof;
end;

function TAspFileDataSet.IsEof: boolean;
begin
  result := self.RecDataSet.IsEof;
end;

function TAspFileDataSet.IsEmpty: boolean;
begin
  result := self.RecDataSet.IsEmpty;
end;

function TAspFileDataSet.IsDetailDB: boolean;
begin
  result := self.RecDataSet.IsDetailDB;
end;

function TAspFileDataSet.IsUseFilter: boolean;
begin
  result := self.RecDataSet.UseFilter;
end;

function TAspFileDataSet.IsDataField(FieldName:string): boolean;
begin
  result := self.RecDataSet.IsDataField[FieldName];
end;

function TAspFileDataSet.IsNotNullField(FieldName:string): boolean;
begin
  result := self.RecDataSet.IsNotNullField[FieldName];
end;

function TAspFileDataSet.FieldDataSize(FieldName: string): integer;
begin
  result := self.RecDataSet.FieldDataSize[FieldName];
end;

function TAspFileDataSet.DeleteAllFields: boolean;
begin
  result := self.RecDataSet.DeleteAllFields;
end;

function TAspFileDataSet.DeleteField(FieldName: string): boolean;
begin
  result := self.RecDataSet.DeleteField(FieldName);
end;

function TAspFileDataSet.IsThisFieldExists(FieldName: string): boolean;
begin
  result := self.RecDataSet.IsThisFieldExists(FieldName);
end;

function TAspFileDataSet.IsKeyField(FieldName:string): boolean;
begin
  result := self.RecDataSet.IsKeyField[FieldName];
end;

procedure TAspFileDataSet.SetUseFilter(Value: boolean);
begin
  self.RecDataSet.UseFilter := Value;
end; 

function TAspFileDataSet.FieldCount: integer;
begin
  result := self.RecDataSet.FieldCount;
end;

function TAspFileDataSet.RecordCount: integer;
begin
  result := self.RecDataSet.RecordCount;
end;

function TAspFileDataSet.DetailDbCount: integer;
begin
  result := self.RecDataSet.DetailDbCount;
end;

function TAspFileDataSet.DataFilterCount: integer;
begin
  result := self.RecDataSet.DataFilterCount;
end;

procedure TAspFileDataSet.Delete;
begin
  self.RecDataSet.RecDelete;
end;

procedure TAspFileDataSet.Edit;
begin
  self.RecDataSet.RecEdit;
end;

procedure TAspFileDataSet.First;
begin
  self.RecDataSet.RecFirst;
end;

procedure TAspFileDataSet.Insert;
begin
  self.RecDataSet.RecInsert;
end;

procedure TAspFileDataSet.Last;
begin
  self.RecDataSet.RecLast;
end;

procedure TAspFileDataSet.Next;
begin
  self.RecDataSet.RecNext;
end;

procedure TAspFileDataSet.Prior;
begin
  self.RecDataSet.RecPrior;
end;

function TAspFileDataSet.Post: boolean;
var IsSuccess:OleVariant;
begin
  self.RecDataSet.RecPost(IsSuccess);
  result := IsSuccess;
end;

procedure TAspFileDataSet.Cancel;
begin
  self.RecDataSet.RecCancel;
end;

function TAspFileDataSet.LocateByKeyValues(KeyValues:TStringList): boolean;
var i,idx,fdSize:integer;
    fdStr,tempStr,ValueStr:string;
    IsSuccess:OleVariant;
begin
  result := FALSE;
  if(KeyValues = nil)then Exit;
  if(KeyValues.Count = 0)then Exit;
  if(self.RecDataSet.KeyFieldCount <> KeyValues.Count)then Exit;
  //----------------------------------------------------------------
  idx := -1; ValueStr := '';
  for i := 0 to self.RecDataSet.FieldCount-1 do
    begin
      if(self.RecDataSet.IsKeyField[fdStr] = TRUE)then
        begin
          tempStr := ''; fdSize := 0;
          idx := idx +1;
          fdStr   := self.RecDataSet.FieldName[i];
          fdSize  := self.RecDataSet.FieldDataSize[fdStr];
          tempStr := KeyValues[idx];
          while(Length(tempStr) < fdSize)do
            tempStr := tempStr+' ';
          ValueStr := ValueStr+tempStr;
          tempStr := '';
        end;//if...end!!
    end;//for...i...end!!
  //------------------------------------------------------------
  result := self.RecDataSet.FindData(ValueStr);
end;

function TAspFileDataSet.LocateByKeyValues(KeyValues: String): boolean;
var value:Variant;
begin
  value  := KeyValues;
  result := self.RecDataSet.FindData(value);
end;

function TAspFileDataSet.DbState: string;
begin
  result := self.RecDataSet.DbState;
end;

function TAspFileDataSet.FieldName(Index: integer): string;
begin
  result := '';
  result := self.RecDataSet.FieldName[Index];
end;

function TAspFileDataSet.CreateDataFile(NewTableName: string): boolean;
var IsSuccess:OleVariant;
    tmpStr,tbstr:string;
    i:integer;
begin
  result := FALSE;
  if(trim(NewTableName) = '')then Exit;
  tmpStr := self.RecDataSet.AccessFile;
  tbstr  := '';
  for i := 1 to Length(NewTableName) do
    if(NewTableName[i] = '.')then
      Break
    else tbstr := tbstr+NewTableName[i];
  //------------------------------------
  self.RecDataSet.AccessFile := tbstr+'.XDB';
  self.RecDataSet.CreateTable(IsSuccess);
  tmpStr := self.RecDataSet.AccessFile;
  result := IsSuccess;
end;

function TAspFileDataSet.GetBookMark: integer;
begin
  result := self.RecDataSet.GetBookMark;
end;

procedure TAspFileDataSet.GotoBookMark(BookMark: integer);
begin
  self.RecDataSet.GotoBookMark(BookMark);
end;

function TAspFileDataSet.AddNewDataFilterItem(FilterCommandStr: string):boolean;
begin
  result := self.RecDataSet.AddDataFilterWithCommandStr(FilterCommandStr);
end;

procedure TAspFileDataSet.DeleteAllDataFilters;
begin
  self.RecDataSet.DeleteAllDataFilters;
end;

function TAspFileDataSet.DeleteDataFilterItem(
  FilterItemName: string): boolean;
begin
  result := self.RecDataSet.DeleteDataFilterItem(FilterItemName);
end;

function TAspFileDataSet.LockCurrentRecord(LockReasonStr: string): boolean;
begin
  result := self.RecDataSet.LockCurrentRecord(LockReasonStr);
end;

function TAspFileDataSet.UnLockCurrentRecord: boolean;
begin
  result := self.RecDataSet.UnLockCurrentRecord;
end;

procedure TAspFileDataSet.SaveSchema(FileName: string);
begin
  self.RecDataSet.SaveSchema(FileName);
end;

function TAspFileDataSet.DataFileSize: integer;
begin
  result := self.RecDataSet.DataFileSize;
end;

function TAspFileDataSet.FieldByName(inFieldName: string): TWarpField;
var id:integer;
begin
  result := nil;
  id := self.FWarpFieldList.IndexOf(inFieldName);
  if(id >= 0)then
    result := TWarpField(self.FWarpFieldList.Objects[id]);
end;

function TAspFileDataSet.SumTotalValueWithFilter(FieldName: string): double;
var startidx,endidx:integer;
    i,j:integer;
    rvalue,tmpValue:double;
    MetaDataStr,rData:string;
    V1,V2:OleVariant;
begin
  result := 0.0;
  if(self.IsThisFieldExists(FieldName) = FALSE)then Exit
  else
    begin
      startidx := 0;
      endidx   := 0;
      rvalue   := 0;
      self.FDataSet.GetFieldDataScopeID(FieldName,V1,V2);
      startidx := V1;
      endidx   := V2;
      if(startidx <> 0)and(endidx <> 0)then
      for i := 1 to self.FDataSet.RecordCount do
        begin
          tmpValue    := 0.0;
          MetaDataStr := '';
          MetaDataStr := self.FDataSet.GetMetaDtaWithFilterByRecNo(i);
          if(MetaDataStr <> '')then
            begin
              rData := '';
              for j := startidx to endidx do
                rData := rData+MetaDataStr[j];
              //-------------------------------
              try
                if(trim(rData) = '*')then tmpValue := 0
                else tmpValue := StrToFloat(rData);
                rvalue := rvalue+tmpValue;
              except
                tmpValue := 0;
              end;//try...end!!
            end;//if...end!!
        end;//if...end!!
      result := rvalue;
    end;//else..end!!
end;

function TAspFileDataSet.GetOrderByValue: boolean;
begin
  result := self.RecDataSet.OrderByDesc;
end;

procedure TAspFileDataSet.SetOrderByValue(const Value: boolean);
begin
  self.RecDataSet.OrderByDesc := Value;
end;

procedure TAspFileDataSet.CallFieldEditorProc;
var i:integer;
    fdStr:string;
begin
  try            
    if(UStdFdEditor.fFdEditor = nil)then
      UStdFdEditor.fFdEditor := UStdFdEditor.TfFdEditor.Create(nil);
    UStdFdEditor.fFdEditor.UseFileName   := '';
    UStdFdEditor.fFdEditor.UseSchemaFile := FALSE;
    UStdFdEditor.fFdEditor.UseDataFile   := FALSE;
    UStdFdEditor.fFdEditor.fdList.Items.Clear;
    if(self.Active = FALSE)then
      begin 
        try
          if(FileExists(self.AccessFile) = TRUE)then self.Active := TRUE;
          if(FileExists(self.SchemaFileName) = TRUE)then
            begin
              self.FDataSet.LoadSchema(self.SchemaFileName);
              self.Active := TRUE;
            end;//if...end!!  
          UStdFdEditor.fFdEditor.StartFieldCount := self.FieldCount;
          for i := 0 to self.FieldCount-1 do
            begin
              fdStr := self.FieldName(i);
              UStdFdEditor.fFdEditor.fdList.Items.Add(fdStr);
              FdInfoList[i].Name := fdStr;
              FdInfoList[i].DataType := 'VARCHAR';
              FdInfoList[i].Size := self.FieldDataSize(fdStr);
              FdInfoList[i].Key  := self.IsKeyField(fdStr);
              FdInfoList[i].Null := not self.RecDataSet.IsNotNullField[fdStr];
              FdInfoList[i].UniCodeField := self.RecDataSet.IsUniCodeField[fdStr];
            end;//for...i...end!!
          self.Active := FALSE;
          //-------------------------------------------------------------------
          UStdFdEditor.fFdEditor.SpeedButton1.Enabled := FALSE;
          UStdFdEditor.fFdEditor.SpeedButton2.Enabled := FALSE;
          UStdFdEditor.fFdEditor.Button1.Enabled := FALSE;
          UStdFdEditor.fFdEditor.Button2.Enabled := FALSE;
          UStdFdEditor.fFdEditor.Button4.Enabled := FALSE;
          UStdFdEditor.fFdEditor.Button5.Enabled := FALSE;
          if(trim(self.AccessFile) = '')then
            begin
              UStdFdEditor.fFdEditor.Button1.Enabled := TRUE;
              UStdFdEditor.fFdEditor.Button2.Enabled := TRUE;
              UStdFdEditor.fFdEditor.Button4.Enabled := TRUE;
              UStdFdEditor.fFdEditor.Button5.Enabled := TRUE;
              UStdFdEditor.fFdEditor.SpeedButton1.Enabled := TRUE;
              UStdFdEditor.fFdEditor.SpeedButton2.Enabled := TRUE;
            end;//if...end!!
          if(trim(self.SchemaFileName) = '')then
            begin
              UStdFdEditor.fFdEditor.Button1.Enabled := TRUE;
              UStdFdEditor.fFdEditor.Button2.Enabled := TRUE;
              UStdFdEditor.fFdEditor.Button4.Enabled := TRUE;
              UStdFdEditor.fFdEditor.Button5.Enabled := TRUE;
              UStdFdEditor.fFdEditor.SpeedButton1.Enabled := TRUE;
              UStdFdEditor.fFdEditor.SpeedButton2.Enabled := TRUE;
            end;//if...end!!
          //-------------------------------------------------------------------
          UStdFdEditor.fFdEditor.Panel5.Caption := 'Field Count : '+IntToStr(self.FieldCount);
          UStdFdEditor.fFdEditor.ShowModal;
        except
          Exit;
        end;//try...end!!
      end//if...end!!
    else
      begin
        UStdFdEditor.fFdEditor.StartFieldCount := 0;
        UStdFdEditor.fFdEditor.Panel1.Caption  := 'Field Count : 0';
        UStdFdEditor.fFdEditor.ShowModal;
      end;//if...else...end!!  
  finally
    if(UStdFdEditor.fFdEditor.UseFileName <> '')then
      if(UStdFdEditor.fFdEditor.UseDataFile = TRUE)then
        begin
          self.AccessFile := UStdFdEditor.fFdEditor.UseFileName;
          self.SchemaFileName := '';
        end//if...end!!
      else
        if(UStdFdEditor.fFdEditor.UseSchemaFile = TRUE)then
          begin
            self.AccessFile := '';
            self.SchemaFileName := UStdFdEditor.fFdEditor.UseFileName;
          end;//if...end!!  
    UStdFdEditor.fFdEditor.Free;
    UStdFdEditor.fFdEditor := nil;
  end;//try...end!!
end;

function TAspFileDataSet.GetCallFieldEditor: boolean;
begin
  result := FALSE;
end;

procedure TAspFileDataSet.SetCallFieldEditor(const Value: boolean);
begin
  if(Value = TRUE)then self.CallFieldEditorProc;
end;

procedure TAspFileDataSet.SetFCallEditor(const Value: boolean);
begin
  if(Value = TRUE)then self.CallFieldEditorProc;
end;

procedure TColumnItem.DoLinkControlClick(Sender: TObject);
begin
  if(TGridColumns(self.GetOwner).FGrid <> nil)then
  if(Assigned(TGridColumns(self.GetOwner).FGrid.FOnLinkControlClick))then
    TGridColumns(self.GetOwner).FGrid
      .FOnLinkControlClick(Sender,self.LinkControl.Caption);
end;

procedure TColumnItem.SetFHaveLinkControl(const Value: boolean);
begin
  FHaveLinkControl := Value;
  self.LinkControl.Left := self.TitleCell.Left;
  self.LinkControl.Top  := 1;
  self.LinkControl.Visible := Value;
  if(Value = TRUE)then  
    self.LinkControl.OnClick := self.DoLinkControlClick
  else self.LinkControl.OnClick := nil;
end;

procedure TColumnItem.SetFLinkControlCaption(const Value: string);
begin
  FLinkControlCaption := Value;
  self.LinkControl.Caption := Value;
end;

procedure TColumnItem.SetFLinkControlFont(const Value: TFont);
begin
  FLinkControlFont.Assign(Value);
  if(self.LinkControl <> nil)then
  if(self.FHaveLinkControl = TRUE)then
    begin
      self.LinkControl.Font.Assign(FLinkControlFont);
      self.LinkControl.Invalidate;
    end;//if...end!!
end;

procedure TColumnItem.SetFLinkControlStyle(
  const Value: TColumnLinkControlStyle);
var ypos,hv,rct:integer;
begin
  if(self.FHaveLinkControl = FALSE)then Exit;
  FLinkControlStyle := Value;
  if(Value = CLS_Down)then
    begin
      ypos := TGridColumns(self.GetOwner).FGrid.DataCellStartY;
      hv   := TGridColumns(self.GetOwner).FGrid.DataCellHeight;
      rct  := TGridColumns(self.GetOwner).FGrid.MaxGridRow;
      self.LinkControl.Top := (hv*rct)-ypos;
    end;//if...end!!
end;

procedure TColumnItem.SetFTitleFont(const Value: TFont);
begin
  FTitleFont.Assign(Value);
  self.TitleCell.Font.Assign(FTitleFont);
  self.TitleCell.Invalidate;
end;

procedure TColumnItem.SetFLinkControlAlignment(const Value: TAlignment);
begin
  FLinkControlAlignment := Value;
  self.LinkControl.Alignment := FLinkControlAlignment;
end;

procedure TColumnItem.SetFLinkControlColor(const Value: TColor);
begin
  FLinkControlColor := Value;
  self.LinkControl.Color := Value;
end;

procedure TColumnItem.SetFLinkControlHeight(const Value: integer);
begin
  FLinkControlHeight := Value;
  self.LinkControl.Height := Value;
end;

procedure TColumnItem.SetFLinkControlWidth(const Value: integer);
begin
  FLinkControlWidth := Value;
  self.LinkControl.Width := Value;
end;

procedure TAspFileDBGrid.SetFMaxGridRow(const Value: integer);
begin
  if(FMaxGridRow = Value)then Exit;
  FMaxGridRow := Value;
end;

procedure TAspFileDBNavigator.SetAllBtnHeight(const Value: integer);
begin
  if(FAllBtnHeight = Value)then Exit;
  FAllBtnHeight := Value;
  if(self.Height < Value)then
    self.Height := Value+1;
  //------------------------------------
  if(self.BtnFirst <> nil)then
    begin
      self.BtnFirst .Height := Value;
      self.BtnPrior .Height := Value;
      self.BtnNext  .Height := Value;
      self.BtnLast  .Height := Value;
      self.BtnAdd   .Height := Value;
      self.BtnEdit  .Height := Value;
      self.BtnDelete.Height := Value;
      self.BtnQuery .Height := Value;
      self.BtnSave  .Height := Value;
      self.BtnCancel.Height := Value;
    end;//if...end!!
  //------------------------------------
end;

function TAspFileDBNavigator.GetAddIsCustomBtn: boolean;
begin
  result := self.BtnAdd.IsCustomBtn;
end;

function TAspFileDBNavigator.GetCancelIsCustomBtn: boolean;
begin
  result := self.BtnCancel.IsCustomBtn;
end;

function TAspFileDBNavigator.GetDeleteIsCustomBtn: boolean;
begin
  result := self.BtnDelete.IsCustomBtn;
end;

function TAspFileDBNavigator.GetEditIsCustomBtn: boolean;
begin
  result := self.BtnEdit.IsCustomBtn;
end;

function TAspFileDBNavigator.GetFirstIsCustomBtn: boolean;
begin
  result := self.BtnFirst.IsCustomBtn;
end;

function TAspFileDBNavigator.GetLastIsCustomBtn: boolean;
begin
  result := self.BtnLast.IsCustomBtn;
end;

function TAspFileDBNavigator.GetNextIsCustomBtn: boolean;
begin
  result := self.BtnNext.IsCustomBtn;
end;

function TAspFileDBNavigator.GetPriorIsCustomBtn: boolean;
begin
  result := self.BtnPrior.IsCustomBtn;
end;

function TAspFileDBNavigator.GetQueryIsCustomBtn: boolean;
begin
  result := self.BtnQuery.IsCustomBtn;
end;

function TAspFileDBNavigator.GetSaveIsCustomBtn: boolean;
begin
  result := self.BtnSave.IsCustomBtn;
end;

procedure TAspFileDBNavigator.SetAddIsCustomBtn(const Value: boolean);
begin
  self.BtnAdd.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnAdd.OnClick := self.RunCustomClick
  else self.BtnAdd.OnClick := self.RunAddClick;
end;

procedure TAspFileDBNavigator.SetCancelIsCustomBtn(const Value: boolean);
begin
  self.BtnCancel.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnCancel.OnClick := self.RunCustomClick
  else self.BtnCancel.OnClick := self.RunCancelClick;
end;

procedure TAspFileDBNavigator.SetDeleteIsCustomBtn(const Value: boolean);
begin
  self.BtnDelete.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnDelete.OnClick := self.RunCustomClick
  else self.BtnDelete.OnClick := self.RunDeleteClick;
end;

procedure TAspFileDBNavigator.SetEditIsCustomBtn(const Value: boolean);
begin
  self.BtnEdit.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnEdit.OnClick := self.RunCustomClick
  else self.BtnEdit.OnClick := self.RunEditClick;
end;

procedure TAspFileDBNavigator.SetFirstIsCustomBtn(const Value: boolean);
begin
  self.BtnFirst.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnFirst.OnClick := self.RunCustomClick
  else self.BtnFirst.OnClick := self.RunFirstClick;
end;

procedure TAspFileDBNavigator.SetLastIsCustomBtn(const Value: boolean);
begin
  self.BtnLast.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnLast.OnClick := self.RunCustomClick
  else self.BtnLast.OnClick := self.RunLastClick;
end;

procedure TAspFileDBNavigator.SetNextIsCustomBtn(const Value: boolean);
begin
  self.BtnNext.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnNext.OnClick := self.RunCustomClick
  else self.BtnNext.OnClick := self.RunNextClick;
end;

procedure TAspFileDBNavigator.SetPriorIsCustomBtn(const Value: boolean);
begin
  self.BtnPrior.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnPrior.OnClick := self.RunCustomClick
  else self.BtnPrior.OnClick := self.RunPriorClick;
end;

procedure TAspFileDBNavigator.SetQueryIsCustomBtn(const Value: boolean);
begin
  self.BtnQuery.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnQuery.OnClick := self.RunCustomClick
  else self.BtnQuery.OnClick := self.RunQueryClick;
end;

procedure TAspFileDBNavigator.SetSaveIsCustomBtn(const Value: boolean);
begin
  self.BtnSave.IsCustomBtn := Value;
  if(Value = TRUE)then self.BtnSave.OnClick := self.RunCustomClick
  else self.BtnSave.OnClick := self.RunSaveClick;
end;

function TAspFileDBNavigator.GetAddVisible: boolean;
begin
  if(self.BtnAdd <> nil)then result := self.BtnAdd.Visible;
end;

function TAspFileDBNavigator.GetCancelVisible: boolean;
begin
  if(self.BtnCancel <> nil)then result := self.BtnCancel.Visible;
end;

function TAspFileDBNavigator.GetDeleteVisible: boolean;
begin
  if(self.BtnDelete <> nil)then result := self.BtnDelete.Visible;
end;

function TAspFileDBNavigator.GetEditVisible: boolean;
begin
  if(self.BtnEdit <> nil)then result := self.BtnEdit.Visible;
end;

function TAspFileDBNavigator.GetFirstVisible: boolean;
begin
  if(self.BtnFirst <> nil)then result := self.BtnFirst.Visible;
end;

function TAspFileDBNavigator.GetLastVisible: boolean;
begin
  if(self.BtnLast <> nil)then result := self.BtnLast.Visible;
end;

function TAspFileDBNavigator.GetNextVisible: boolean;
begin
  if(self.BtnNext <> nil)then result := self.BtnNext.Visible;
end;

function TAspFileDBNavigator.GetPriorVisible: boolean;
begin
  if(self.BtnPrior <> nil)then result := self.BtnPrior.Visible;
end;

function TAspFileDBNavigator.GetQueryVisible: boolean;
begin
  if(self.BtnQuery <> nil)then result := self.BtnQuery.Visible;
end;

function TAspFileDBNavigator.GetSaveVisible: boolean;
begin
  if(self.BtnSave <> nil)then result := self.BtnSave.Visible;
end;

procedure TAspFileDBNavigator.SetAddVisible(const Value: boolean);
begin
  if(self.BtnAdd <> nil)then self.BtnAdd.Visible := Value;
end;

procedure TAspFileDBNavigator.SetCancelVisible(const Value: boolean);
begin
  if(self.BtnCancel <> nil)then self.BtnCancel.Visible := Value;
end;

procedure TAspFileDBNavigator.SetDeleteVisible(const Value: boolean);
begin
  if(self.BtnDelete <> nil)then self.BtnDelete.Visible := Value;
end;

procedure TAspFileDBNavigator.SetEditVisible(const Value: boolean);
begin
  if(self.BtnEdit <> nil)then self.BtnEdit.Visible := Value;
end;

procedure TAspFileDBNavigator.SetFirstVisible(const Value: boolean);
begin
  if(self.BtnFirst <> nil)then self.BtnFirst.Visible := Value;
end;

procedure TAspFileDBNavigator.SetLastVisible(const Value: boolean);
begin
  if(self.BtnLast <> nil)then self.BtnLast.Visible := Value;
end;

procedure TAspFileDBNavigator.SetNextVisible(const Value: boolean);
begin
  if(self.BtnNext <> nil)then self.BtnNext.Visible := Value;
end;

procedure TAspFileDBNavigator.SetPriorVisible(const Value: boolean);
begin
  if(self.BtnPrior <> nil)then self.BtnPrior.Visible := Value;
end;

procedure TAspFileDBNavigator.SetQueryVisible(const Value: boolean);
begin
  if(self.BtnQuery <> nil)then self.BtnQuery.Visible := Value;
end;

procedure TAspFileDBNavigator.SetSaveVisible(const Value: boolean);
begin
  if(self.BtnSave <> nil)then self.BtnSave.Visible := Value;
end;

procedure TGridCell.DoOnCheckBoxClick(Sender: TObject);
var IsChecked:boolean;
begin
  IsChecked := TGridColumns(self.OwnerComp.GetOwner)
                                .FGrid.tmpChkBox.Checked;
  self.FIsSelect := IsChecked;
end;

//TPickListRefFieldItem.
Constructor TPickListRefFieldItem.Create(Collection: TCollection);
begin
  Inherited Create(Collection);
  self.FDataList := TStringList.Create;
  self.SetDisplayName(self.GetRefFieldDescStr);
end;

Destructor TPickListRefFieldItem.Destroy;
begin
  self.FDataList.Clear;
  self.FDataList.Free;
  inherited Destroy;
end;

procedure TPickListRefFieldItem.Assign(Source: TPersistent);
begin
  if(Source Is TPickListRefFieldItem)then
     begin
       self.FFieldDescrip := TPickListRefFieldItem(Source).FieldDescrip;
       self.FDataList.AddStrings(TPickListRefFieldItem(Source).FDataList);
     end//if...end!!
   else Inherited Assign(Source);
end;

function TPickListRefFieldItem.GetDataList: TStrings;
begin
  result := self.FDataList;
end;

function TPickListRefFieldItem.GetDisplayName: string;
begin
  result := self.FDisPlayName;
end;

function TPickListRefFieldItem.GetRefFieldDescStr: string;
var rstr:string;
begin
  if(self.FFieldDescrip = '')then rstr := 'Ref Field [ New ]'
  else rstr := 'Ref Field [ '+self.FFieldDescrip+' ] ';
  result := rstr;
end;

function TPickListRefFieldItem.GetRefData(Index: integer): string;
begin
  if(Index <= self.FDataList.Count-1)then
    result := self.FDataList[Index];
end;

procedure TPickListRefFieldItem.SetDataList(const Value: TStrings);
begin
  self.FDataList.BeginUpdate;
  self.FDataList.Assign(Value);
  self.FDataList.EndUpdate;
end;

procedure TPickListRefFieldItem.SetDisplayName(const Value: string);
begin
  self.FDisPlayName := Value;
end;

procedure TPickListRefFieldItem.SetFFieldDescrip(const Value: string);
begin
  FFieldDescrip := Value;
  self.SetDisplayName(self.GetRefFieldDescStr);
end;

procedure TPickListRefFieldItem.SetRefData(Index: integer; const Value: string);
begin
  if(Index <= self.FDataList.Count-1)then
    self.FDataList[Index] := Value;
end;

//TColumnPickListRefFields.
Constructor TColumnPickListRefFields.Create(TheOwner: TComponent;
  ItemClass: TPickListRefFieldItemClass);
begin
  inherited Create(TheOwner,ItemClass);
end;

Destructor TColumnPickListRefFields.Destroy;
begin
  inherited Destroy;
end;

function TColumnPickListRefFields.Add: TPickListRefFieldItem;
begin
  result := TPickListRefFieldItem(inherited Add);
end;

function TColumnPickListRefFields.GetCount: Integer;
begin
  result := inherited Count;
end;

function TColumnPickListRefFields.GetPickListRefFieldItem(
  Index: Integer): TPickListRefFieldItem;
begin
  result := TPickListRefFieldItem(inherited Items[Index]);
end;

procedure TColumnPickListRefFields.SetPickListRefFieldItem(Index: Integer;
  value: TPickListRefFieldItem);
begin
  self.RefFields[Index].Assign(value);
end;

function TColumnPickListRefFields.GetPickListRefFieldItemByDesc(
  Descrip: string): TPickListRefFieldItem;
var i:integer;
begin
  result := nil;
  for i := 0 to self.Count-1 do
    if(self.RefFields[i].FFieldDescrip = Descrip)then
      begin
        result := self.RefFields[i];
        Break;
      end;//if...end!!
end;

procedure TColumnPickListRefFields.SetPickListRefFieldItemByDesc(
  Descrip: string; const Value: TPickListRefFieldItem);
var i:integer;
begin
  for i := 0 to self.Count-1 do
    if(self.RefFields[i].FFieldDescrip = Descrip)then
      begin
        self.RefFields[i].Assign(Value);
        Break;
      end;//if...end!!
end;

//TAspFileDBMemo.
Constructor TAspFileDBMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.Value := TStringList.Create;
  self.Width  := 160;
  self.Height := 90;
end;

Destructor TAspFileDBMemo.Destroy;
begin
  self.Value.Free;
  inherited Destroy;
end;

procedure TAspFileDBMemo.KeyPress(var Key: Char);
begin
  Inherited KeyPress(Key);
  if(Key = #13)then FocusNextTabStopEdit(self)
  else
    if(self.FDataSource <> nil)then
    if(self.FDataSource.FDataSet <> nil)then
    if(self.FDataSource.FDataSet.RecDataSet.IsOpened = TRUE)then 
      begin
        if(self.FDataSource.FDataSet.RecDataSet.DbState = 'Browse')then
        if(self.FDataSource.FDataSet.RecDataSet.IsKeyField[self.DataField] = FALSE)then
          self.FDataSource.FDataSet.RecDataSet.RecEdit;
      end;//if...end!!
end;

procedure TAspFileDBMemo.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    if(AComponent = self.FDataSource)then
      begin
        self.FFieldName  := '';
        self.FDataSource := nil;
      end;//if...end!!
end;

procedure TAspFileDBMemo.SetFDataSource(const Value: TAspFileDataSource);
begin
  if(self.FDataSource <> nil)then
    self.FDataSource.RemoveDBMemo(self);
  FDataSource := Value;
  if(Value <> nil)then
    begin
      Value.AddNewDBMemo(self);
    end;//if...end!!
end;

procedure TAspFileDBMemo.SetFFieldName(
  const Value: TAspFileDbControlFieldStr);
begin
  FFieldName := Value;
  if(trim(FFieldName) = '')then Exit;
  if(self.FDataSource <> nil)then
  if(self.FDataSource.DataSet <> nil)then
  if(self.FDataSource.DataSet.Active = TRUE)then
    self.Lines.Add(self.FDataSource.DataSet
                       .RecDataSet.FieldByName[FFieldName]);
end;

end.





